function varargout=conn(varargin)
connver='12.l';

disp(varargin)
global CONN_h CONN_x CONN_refs
if nargin<1,
    connversion={'CONN fMRI connectivity tool',' (',connver,') '};
    hfig=findobj('tag',connversion{1});
    if ~isempty(hfig),return;end
	CONN_h=struct;
    conn init;
    conn importrois;
    CONN_x.gui=1;
	CONN_h.screen.colormap=[gray(128);jet(128)]; 
	CONN_h.screen.hfig=figure('units','norm','position',[.025,.3,.95,.6],'color',[0,0,2/6],'doublebuffer','on','tag',connversion{1},'name',strcat(connversion{:}),'numbertitle','off','menubar','none','colormap',CONN_h.screen.colormap);
	conn_menumanager on;
	CONN_h.menus.m0=conn_menumanager([],	'n',4,...
									'string',{'SETUP','PREPROCESSING','first-level ANALYSES','second-level RESULTS'},...
									'help',{'Define/Edit experiment setup','Define/Edit preprocessing options','Define/Edit analysis options','Explore results'},...
                                    'order','horizontal',...
									'state',[1,0,0,0],...
                                    'toggle',1,...
									'position',[.015,.95,4*.18,.05],...
                                    'dposition',[0,-.01],...
									'fontsize',10,...
									'callback',{{@conn,'gui_setup'},{@conn,'gui_preproc'},{@conn,'gui_analyses'},{@conn,'gui_results'}} );
	CONN_h.menus.m_setup_06=conn_menumanager([],	'n',1,...
									'string',{'ver'},...
									'help',{'Checks for updates'},...
                                    'order','horizontal',...
                                    'toggle',0,...
									'position',[.96,.95,1*.04,.05],...
									'fontsize',8,...
									'callback',{{@conn_update,connver}} );
	CONN_h.menus.m_setup_01=conn_menumanager([], 'n',7,...
									'string',{'New','Load','Save','Save as','Merge','Import','Done'},...
									'help',{'Starts a new experiment','Loads experiment information','Saves current experiment information','Saves current experiment to a different file','Merge other experiment files with the current experiment','Imports experiment information from SPM.mat files','Finish setup and prepares data for analysis'},...
                                    'order','horizontal',...
                                    'toggle',0,...
									'position',[.015,.88,7*.06,.05],...
									'fontsize',8,...
									'callback',{{@conn,'gui_setup_new'},{@conn,'gui_setup_load'},{@conn,'gui_setup_save'},{@conn,'gui_setup_saveas'},{@conn,'gui_setup_merge'},{@conn,'gui_setup_import'},{@conn,'gui_setup_finish'}} );
	CONN_h.menus.m_setup_03=conn_menumanager([], 'n',2,...
									'string',{'First level','Second level'},...
									'help',{'Defines 1st level (within subject) covariates','Defines 2nd level (between subject) covariates'},...
                                    'toggle',1,...
									'position',[.085,.45,.07,2*.05],...
									'fontsize',8,...
									'callback',{{@conn,'gui_setup_covariates'},{@conn,'gui_setup_covariates'}} );
	CONN_h.menus.m_setup_02=conn_menumanager([], 'n',6,...
									'string',{'Basic','Functional','Structural','ROIs','Conditions','Covariates'},...
									'help',{'Defines basic experimental setup','Defines functional data source files','Defines structural data source files','Defines regions of interest','Defines experimental conditions','Defines first or second level covariates'},...
									'state',[1,0,0,0,0,0],...
									'value',1,...
                                    'toggle',1,...
									'position',[.015,.5,.07,6*.05],...
									'fontsize',8,...
									'callback',{{@conn,'gui_setup'},{@conn,'gui_setup'},{@conn,'gui_setup'},{@conn,'gui_setup'},{@conn,'gui_setup'},CONN_h.menus.m_setup_03} );
	CONN_h.menus.m_setup_04=conn_menumanager([], 'n',1,...
									'string',{'Done'},...
									'help',{'Press ''Done'' to finish importing SPM files'},...
									'position',[.015,.88,.05,.05],...
                                    'toggle',0,...
									'fontsize',8,...
									'callback',{{@conn,'gui_setup_importdone'}} );
	CONN_h.menus.m_setup_05=conn_menumanager([], 'n',1,...
									'string',{'Done'},...
									'help',{'Press ''Done'' to finish selecting CONN_* files'},...
									'position',[.015,.88,.05,.05],...
                                    'toggle',0,...
									'fontsize',8,...
									'callback',{{@conn,'gui_setup_mergedone'}} );
	CONN_h.menus.m_preproc_01=conn_menumanager([], 'n',1,...
									'string',{'>'},...
									'help',{''},...
                                    'toggle',0,...
									'position',[.128,.5,.02,.05],...
									'backgroundcolor',[0,0,1/6],...
									'callback',{{@conn,'gui_preproc',0}} );
	CONN_h.menus.m_preproc_02=conn_menumanager([], 'n',1,...
									'string',{'Done'},...
									'help',{'Press ''Done'' to start preprocessing all data'},...
									'position',[.015,.88,.05,.05],...
                                    'toggle',0,...
									'fontsize',8,...
									'callback',{{@conn,'gui_preproc_done'}} );
	CONN_h.menus.m_analyses_01=conn_menumanager([], 'n',1,...
									'string',{'>'},...
									'help',{''},...
                                    'toggle',0,...
									'position',[.128,.5,.02,.05],...
									'backgroundcolor',[0,0,1/6],...
									'callback',{{@conn,'gui_analyses',0}} );
	CONN_h.menus.m_analyses_02=conn_menumanager([], 'n',1,...
									'string',{'Done'},...
									'help',{'Press ''Done'' to start analyzing all data'},...
									'position',[.015,.88,.05,.05],...
                                    'toggle',0,...
									'fontsize',8,...
									'callback',{{@conn,'gui_analyses_done'}} );
	CONN_h.menus.m_results_02=conn_menumanager([], 'n',1,...
									'string',{'Done'},...
									'help',{'Press ''Done'' to perform group analyses for all sources'},...
                                    'order','horizontal',...
									'position',[.015,.88,.05,.05],...
                                    'toggle',0,...
									'fontsize',8,...
									'callback',{{@conn,'gui_results_done'}} );
	CONN_h.menus.m_results_03=conn_menumanager([], 'n',2,...
									'string',{'ROI view','Whole brain'},...
									'help',{'Graphic display of ROI-to-ROI connectivity matrix','Whole-brain display of current seed-to-voxel results'},...
									'position',[.015,.7,.07,2*.05],...
                                    'toggle',0,...
									'fontsize',8,...
									'callback',{{@conn,'gui_results_roiview'},{@conn,'gui_results_wholebrain'}} );

    conn gui_setup;

else
	switch(lower(varargin{1})),
        case 'init',
            CONN_x=struct('name',[],'filename','','gui',1,'state',0,'ver',connver,...
                'folders',struct('rois',fullfile(fileparts(which(mfilename)),'rois'),'data',[],'preprocessing',[],'firstlevel',[],'secondlevel',[]),...
                'Setup',struct(...
                'RT',2,'nsubjects',1,'nsessions',1,'fwhm',12,'reorient',eye(4),'normalized',1,...
                'functional',{{}},...
                'structural',{{}},...
                'spm',{{}},...
                'nscans',{{}},....
                'rois',         struct('names',{{}},'files',{{}},'dimensions',{{}},'mask',[]),...
                'conditions',   struct('names',{{}},'values',{{}}),...
                'l1covariates', struct('names',{{}},'files',{{}}),...
                'l2covariates', struct('names',{{}},'values',{{}}) ),...
                'Preproc',struct(...
                'variables', struct('names',{{}},'types',{{}},'deriv',{{}},'dimensions',{{}}),...
                'confounds',	struct('names',{{}},'types',{{}},'deriv',{{}},'dimensions',{{}}),...
                'filter',[0,inf]),...
                'Analyses',struct(...
                'name','ANALYSIS_01',...
                'sourcenames',{{}},...
                'variables', struct('names',{{}},'types',{{}},'deriv',{{}},'dimensions',{{}}),...
                'regressors',	struct('names',{{}},'types',{{}},'deriv',{{}},'dimensions',{{}}),...
                'measure',[],...
                'weight',[]),...
                'Analysis',1);
            
            CONN_x.Setup.functional{1}{1}={[],[],[]};
            CONN_x.Setup.nscans{1}{1}=0;
            CONN_x.Setup.spm{1}={[],[],[]};
            CONN_x.Setup.conditions.values{1}{1}{1}={};
            CONN_x.Setup.conditions.names={' '};
            CONN_x.Setup.l1covariates.files{1}{1}{1}={[],[],[]};
            CONN_x.Setup.l1covariates.names={' '};
            CONN_x.Setup.l2covariates.values{1}{1}=1;
            CONN_x.Setup.l2covariates.names={'All',' '};
            filename=fullfile(fileparts(which('spm')),'canonical','avg152T1.nii');
            [V,str,icon]=conn_getinfo(filename);
            CONN_x.Setup.structural{1}={filename,str,icon};
            CONN_refs.canonical=struct('filename',filename,'V',V,'data',spm_read_vols(V));
            CONN_x.Setup.rois.files{1}{1}={[],[],[]};%{filename,str,icon};
            CONN_x.Setup.rois.files{1}{2}={[],[],[]};%{filename,str,icon};
            CONN_x.Setup.rois.files{1}{3}={[],[],[]};%{filename,str,icon};
            CONN_x.Setup.rois.names={'Grey Matter','White Matter','CSF',' '};
            CONN_x.Setup.rois.dimensions={1,16,16};
            CONN_x.Setup.rois.mask=[0,0,0];
            CONN_x.Setup.rois.multiplelabels=[0,0,0];
            %filename=fullfile(fileparts(which('conn')),'utils','otherrois','talairach.nii');
            %filename=fullfile(fileparts(which('conn')),'utils','otherrois','TDb.img');
            %filename=fullfile(fileparts(which('conn')),'rois','aal.nii');
            filename=fullfile(fileparts(which('conn')),'rois','BA.img');
            [filename_path,filename_name,filename_ext]=fileparts(filename);
            V=spm_vol(filename);
            CONN_refs.rois=struct('filename',filename_name,'V',V,'data',spm_read_vols(V),'labels',{textread(fullfile(filename_path,[filename_name,'.txt']),'%s','delimiter','\n')});
            
        case 'close',
            connversion={'CONN fMRI connectivity tool',' (',connver,') '};
            hfig=findobj('tag',connversion{1});
            if ~isempty(hfig)&&ishandle(hfig),
                close(hfig);
                CONN_h=[];CONN_x=[];CONN_refs=[];
                return;
            end
            
        case 'importrois',
            if ~isfield(CONN_x.folders,'rois'), CONN_x.folders.rois=fullfile(fileparts(which(mfilename)),'rois'); end
            path=CONN_x.folders.rois;
            names=cat(1,dir(fullfile(path,'*.nii')),dir(fullfile(path,'*.img')),dir(fullfile(path,'*.tal')));
            n0=length(CONN_x.Setup.rois.names)-1;
            for n1=1:length(names),
                [nill,name,nameext]=fileparts(names(n1).name);
                filename=fullfile(path,names(n1).name);
                [V,str,icon]=conn_getinfo(filename);
                CONN_x.Setup.rois.names{n0+n1}=name; CONN_x.Setup.rois.names{n0+n1+1}=' ';
                for nsub=1:CONN_x.Setup.nsubjects, CONN_x.Setup.rois.files{nsub}{n0+n1}={filename,str,icon}; end
                CONN_x.Setup.rois.dimensions{n0+n1}=1;
                CONN_x.Setup.rois.mask(n0+n1)=0;
                CONN_x.Setup.rois.multiplelabels(n0+n1)=(strcmp(nameext,'.img')|strcmp(nameext,'.nii'))&~isempty(dir(conn_prepend('',filename,'.txt')));
            end
            
        case 'load',
            if nargin>1,filename=varargin{2};
            else,filename=CONN_x.filename;end
			if ischar(filename),
				try, load(filename,'CONN_x'); CONN_x.filename=filename; catch, error(['Failed to load file ',filename,'.']); return; end
                try, conn_updatefilepaths; end
                CONN_x.filename=filename;
                conn_updatefolders;
			end
			
		case 'save',
			filename=CONN_x.filename;
            conn_updatefolders;
			if ischar(filename),
				try 
					if str2num(version('-release'))>=14, save(filename,'-V6','CONN_x');
					else, save(filename,'CONN_x'); end
                catch
                    error(['Failed to save file ',filename,'. Check file name and/or folder permissions']); 
                end
			end
			
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%			
        case 'gui_setup',
            CONN_x.gui=1;
			state=find(conn_menumanager(CONN_h.menus.m_setup_02,'state'));
            if nargin<2,
                conn_menumanager clf;
                axes('units','norm','position',[0,.935,1,.001]); image(shiftdim([1,1,4/6],-1)); axis off;
				tstate=conn_menumanager(CONN_h.menus.m0,'state'); tstate(:)=0;tstate(1)=1; conn_menumanager(CONN_h.menus.m0,'state',tstate); 
				conn_menumanager([CONN_h.menus.m_setup_02,CONN_h.menus.m_setup_01,CONN_h.menus.m_setup_06,CONN_h.menus.m0],'on',1);
            end
            switch(state),
                case 1, %basic
                    if nargin<2,
                        conn_menu('frame',[.19,.45,.22,.35],'BASIC SETUP');
						CONN_h.menus.m_setup_00{1}=conn_menu('edit',[.2,.7,.2,.04],'Number of subjects',num2str(CONN_x.Setup.nsubjects),'Number of subjects in this experiment','conn(''gui_setup'',1);');
						CONN_h.menus.m_setup_00{2}=conn_menu('edit',[.2,.6,.2,.04],'Repetition Time (seconds)',num2str(CONN_x.Setup.RT),'Sampling period of fMRI data (time between two conscutive whole volume acquisitions)','conn(''gui_setup'',2);');
						CONN_h.menus.m_setup_00{3}=conn_menu('edit',[.2,.5,.2,.04],'Number of sessions',num2str(CONN_x.Setup.nsessions,'%1.0f '),'Number of scanning sessions per subject (enter a single number if every subject underwent the same number of scanning sessions, or a different number per subject otherwise (e.g. 2 2 3)','conn(''gui_setup'',3);');
                    else
                        switch(varargin{2}),
                            case 1, 
								value0=CONN_x.Setup.nsubjects; 
								txt=get(CONN_h.menus.m_setup_00{1},'string'); value=str2num(txt); if ~isempty(value)&&length(value)==1, CONN_x.Setup.nsubjects=value; end; 
								if CONN_x.Setup.nsubjects~=value0, CONN_x.Setup.nsubjects=conn_merge(value0,CONN_x.Setup.nsubjects); end
								set(CONN_h.menus.m_setup_00{1},'string',num2str(CONN_x.Setup.nsubjects)); 
                                set(CONN_h.menus.m_setup_00{3},'string',num2str(CONN_x.Setup.nsessions,'%1.0f '))
							case 2, txt=get(CONN_h.menus.m_setup_00{2},'string'); value=str2num(txt); if isempty(value), try, value=evalin('base',txt); catch, value=[]; end; end;if ~isempty(value)&&length(value)==1, CONN_x.Setup.RT=value; end; set(CONN_h.menus.m_setup_00{2},'string',num2str(CONN_x.Setup.RT)); 
                            case 3, txt=get(CONN_h.menus.m_setup_00{3},'string'); value=str2num(txt); if isempty(value), try, value=evalin('base',txt); catch, value=[]; end; end;if ~isempty(value)&&(length(value)==1||length(value)==CONN_x.Setup.nsubjects), CONN_x.Setup.nsessions=value; end; set(CONN_h.menus.m_setup_00{3},'string',num2str(CONN_x.Setup.nsessions,'%1.0f ')); 
                        end
                    end
                case 2, %functional
                    if nargin<2,
                        conn_menu('frame',[.19,.20,.37,.60],'FUNCTIONAL DATA SETUP');
						CONN_h.menus.m_setup_00{1}=conn_menu('listbox',[.200,.25,.075,.5],'Subjects','','','conn(''gui_setup'',1);');
						CONN_h.menus.m_setup_00{2}=conn_menu('listbox',[.275,.25,.075,.5],'Sessions','','','conn(''gui_setup'',2);');
						CONN_h.menus.m_setup_00{3}=conn_menu('filesearch',[],'Select functional data files','*.img; *.nii','',{@conn,'gui_setup',3});
						CONN_h.menus.m_setup_00{4}=conn_menu('text',[.35,.56,.2,.19],'File');
						CONN_h.menus.m_setup_00{5}=conn_menu('image',[.36,.25,.17,.3]);
						CONN_h.menus.m_setup_00{11}=conn_menu('checkbox',[.38,.205,.02,.04],'spatially-normalized images','','','conn(''gui_setup'',11);');
						set(CONN_h.menus.m_setup_00{3}.files,'max',2);
						set(CONN_h.menus.m_setup_00{1},'max',2);
						set(CONN_h.menus.m_setup_00{1},'string',[repmat('Subject ',[CONN_x.Setup.nsubjects,1]),num2str((1:CONN_x.Setup.nsubjects)')]);
                        nsess=CONN_x.Setup.nsessions(1); set(CONN_h.menus.m_setup_00{2},'string',[repmat('Session ',[nsess,1]),num2str((1:nsess)')],'value',min(nsess,get(CONN_h.menus.m_setup_00{2},'value')));
                        if ~isfield(CONN_x.Setup,'normalized'), CONN_x.Setup.normalized=1; end
                        set([CONN_h.menus.m_setup_00{11}],'visible','on','foregroundcolor','w','backgroundcolor',[0,0,1/6],'value',CONN_x.Setup.normalized);
                    else
                        switch(varargin{2}),
                            case 1, value=get(CONN_h.menus.m_setup_00{1},'value'); 
                                nsess=max(CONN_x.Setup.nsessions(min(length(CONN_x.Setup.nsessions),value))); 
                                set(CONN_h.menus.m_setup_00{2},'string',[repmat('Session ',[nsess,1]),num2str((1:nsess)')],'value',min(nsess,get(CONN_h.menus.m_setup_00{2},'value')));
                                %nsess=CONN_x.Setup.nsessions(min(length(CONN_x.Setup.nsessions),value)); 
                                %set(CONN_h.menus.m_setup_00{2},'string',[repmat('Session ',[nsess,1]),num2str((1:nsess)')],'value',min(nsess,get(CONN_h.menus.m_setup_00{2},'value')));
                            case 2,
                            case 3,
								set(CONN_h.screen.hfig,'pointer','watch');
                                nsubs=get(CONN_h.menus.m_setup_00{1},'value');nsess=get(CONN_h.menus.m_setup_00{2},'value');
								filename=fliplr(deblank(fliplr(deblank(varargin{3}))));
								if size(filename,1)==length(nsubs),
									for n1=1:length(nsubs),
										nsub=nsubs(n1);
										[V,str,icon]=conn_getinfo(deblank(filename(n1,:)));
										CONN_x.Setup.functional{nsub}{nsess}={deblank(filename(n1,:)),str,icon};
										CONN_x.Setup.nscans{nsub}{nsess}=prod(size(V));
									end
								elseif length(nsubs)==1,
									[V,str,icon]=conn_getinfo(deblank(filename));
									CONN_x.Setup.functional{nsubs}{nsess}={deblank(filename),str,icon};
									CONN_x.Setup.nscans{nsubs}{nsess}=prod(size(V));
								else,
									errordlg('mismatched number of files','');
								end
								set(CONN_h.screen.hfig,'pointer','arrow');
                            case 11,
                                normalized=get(CONN_h.menus.m_setup_00{11},'value');
                                if ~normalized, warndlg('Warning: Second-level voxel-level analyses not available for un-normalized data'); end
                                CONN_x.Setup.normalized=normalized;
                        end
                    end
                    nsubs=get(CONN_h.menus.m_setup_00{1},'value');nsess=get(CONN_h.menus.m_setup_00{2},'value');
					for nsub=nsubs(:)',
						if length(CONN_x.Setup.functional)<nsub, CONN_x.Setup.functional{nsub}={}; end
						if length(CONN_x.Setup.functional{nsub})<nsess, CONN_x.Setup.functional{nsub}{nsess}={}; end
						if length(CONN_x.Setup.functional{nsub}{nsess})<3, CONN_x.Setup.functional{nsub}{nsess}{3}=[]; end
					end
					conn_menu('updateimage',CONN_h.menus.m_setup_00{5},CONN_x.Setup.functional{nsub}{nsess}{3});
                    set(CONN_h.menus.m_setup_00{4},'string',CONN_x.Setup.functional{nsub}{nsess}{2});
                case 3, %structural
                    if nargin<2,
                        conn_menu('frame',[.19,.20,.295,.60],'STRUCTURAL DATA SETUP');
						CONN_h.menus.m_setup_00{1}=conn_menu('listbox',[.200,.25,.075,.5],'Subjects','','','conn(''gui_setup'',1);');
						CONN_h.menus.m_setup_00{3}=conn_menu('filesearch',[],'Select structural data files','*.img; *.nii','',{@conn,'gui_setup',3});
						CONN_h.menus.m_setup_00{4}=conn_menu('text', [.275,.56,.2,.19],'Files');
						CONN_h.menus.m_setup_00{5}=conn_menu('image',[.285,.25,.17,.3]);
						CONN_h.menus.m_setup_00{11}=conn_menu('checkbox',[.31,.205,.02,.04],'spatially-normalized images','','','conn(''gui_setup'',11);');
						set(CONN_h.menus.m_setup_00{1},'string',[repmat('Subject ',[CONN_x.Setup.nsubjects,1]),num2str((1:CONN_x.Setup.nsubjects)')],'max',2);
						set(CONN_h.menus.m_setup_00{3}.files,'max',2);
                        if ~isfield(CONN_x.Setup,'normalized'), CONN_x.Setup.normalized=1; end
                        set([CONN_h.menus.m_setup_00{11}],'visible','on','foregroundcolor','w','backgroundcolor',[0,0,1/6],'value',CONN_x.Setup.normalized);
						%for nsub=1:CONN_x.Setup.nsubjects, 
						%	if length(CONN_x.Setup.structural)<nsub || isempty(CONN_x.Setup.structural{nsub}), 
						%		conn('gui_setup',3,fullfile(fileparts(which('spm')),'canonical','avg152T1.nii'),nsub); 
						%	end; 
						%end
                    else
                        switch(varargin{2}),
                            case 1, 
                            case 2,
                            case 3,
                                if nargin<4, nsubs=get(CONN_h.menus.m_setup_00{1},'value'); else, nsubs=varargin{4}; end
								filename=fliplr(deblank(fliplr(deblank(varargin{3}))));
								if size(filename,1)==length(nsubs),
									for n1=1:length(nsubs),
										nsub=nsubs(n1);
										[V,str,icon]=conn_getinfo(deblank(filename(n1,:)));
										CONN_x.Setup.structural{nsub}={deblank(filename(n1,:)),str,icon};
									end
								elseif size(filename,1)==1,
									[V,str,icon]=conn_getinfo(deblank(filename));
									for nsub=nsubs(:)',CONN_x.Setup.structural{nsub}={deblank(filename),str,icon};end
								else,
									errordlg('mismatched number of files','');
								end
                            case 11,
                                normalized=get(CONN_h.menus.m_setup_00{11},'value');
                                if ~normalized, warndlg('Warning: Second-level analyses not available for un-normalized data'); end
                                CONN_x.Setup.normalized=normalized;
                        end
                    end
                    nsubs=get(CONN_h.menus.m_setup_00{1},'value');
					ok=1; ko=[];
					for nsub=nsubs(:)',
						if length(CONN_x.Setup.structural)<nsub, CONN_x.Setup.structural{nsub}={}; end
						if length(CONN_x.Setup.structural{nsub})<3, CONN_x.Setup.structural{nsub}{3}=[]; end
						if isempty(ko), ko=CONN_x.Setup.structural{nsub}{1}; 
						else, if ~all(size(ko)==size(CONN_x.Setup.structural{nsub}{1})) || ~all(all(ko==CONN_x.Setup.structural{nsub}{1})), ok=0; end; end
					end
					if ok,
						conn_menu('updateimage',CONN_h.menus.m_setup_00{5},CONN_x.Setup.structural{nsub}{3});
						set(CONN_h.menus.m_setup_00{4},'string',CONN_x.Setup.structural{nsub}{2});
					else, 
						conn_menu('updateimage',CONN_h.menus.m_setup_00{5},[]);
						set(CONN_h.menus.m_setup_00{4},'string','multiple files');
					end
                case 4, %ROIs
                    if nargin<2,
                        conn_menu('frame',[.19,.20,.37,.60],'ROI DATA SETUP');
						CONN_h.menus.m_setup_00{1}=conn_menu('listbox',[.200,.25,.075,.5],'ROIs','','','conn(''gui_setup'',1);');
						CONN_h.menus.m_setup_00{2}=conn_menu('listbox',[.275,.25,.075,.5],'Subjects','','','conn(''gui_setup'',2);');
						CONN_h.menus.m_setup_00{3}=conn_menu('filesearch',[],'Select ROI definition files','*.img; *.nii; *.tal','',{@conn,'gui_setup',3});
						CONN_h.menus.m_setup_00{4}=conn_menu('text', [.35,.49,.2,.08],'Files');
						CONN_h.menus.m_setup_00{5}=conn_menu('image',[.36,.24,.17,.25]);
						CONN_h.menus.m_setup_00{6}=conn_menu('edit',[.38,.71,.07,.04],'ROI name','','ROI name','conn(''gui_setup'',6);');
						CONN_h.menus.m_setup_00{7}=conn_menu('edit',[.46,.71,.07,.04],'dimensions','','number of dimensions characterizing the ROI activation (1 represents only the mean BOLD activity within the ROI; 2 and above includes additional PCA components)','conn(''gui_setup'',7);');
						CONN_h.menus.m_setup_00{9}=conn_menu('checkbox',[.38,.655,.02,.04],'mask with Grey Matter','','','conn(''gui_setup'',9);');
						CONN_h.menus.m_setup_00{10}=conn_menu('checkbox',[.38,.615,.02,.04],'multiple ROIs','','','conn(''gui_setup'',10);');
						CONN_h.menus.m_setup_00{11}=conn_menu('checkbox',[.38,.205,.02,.04],'spatially-normalized images','','','conn(''gui_setup'',11);');
						set(CONN_h.menus.m_setup_00{2},'string',[repmat('Subject ',[CONN_x.Setup.nsubjects,1]),num2str((1:CONN_x.Setup.nsubjects)')],'max',2);
						set(CONN_h.menus.m_setup_00{1},'string',CONN_x.Setup.rois.names,'max',1);
						set(CONN_h.menus.m_setup_00{6},'visible','off');
						set(CONN_h.menus.m_setup_00{3}.files,'max',2);
                        set([CONN_h.menus.m_setup_00{9},CONN_h.menus.m_setup_00{10}],'value',0,'visible','off');
                        if ~isfield(CONN_x.Setup,'normalized'), CONN_x.Setup.normalized=1; end
                        set([CONN_h.menus.m_setup_00{11}],'visible','on','foregroundcolor','w','backgroundcolor',[0,0,1/6],'value',CONN_x.Setup.normalized);
                        hc1=uicontextmenu;uimenu(hc1,'Label','remove selected ROIs','callback','conn(''gui_setup'',8);');set(CONN_h.menus.m_setup_00{1},'uicontextmenu',hc1);
                    else
                        switch(varargin{2}),
                            case 1, 
                            case 2,
                            case 3,
								nrois=get(CONN_h.menus.m_setup_00{1},'value'); 
                                nsubs=get(CONN_h.menus.m_setup_00{2},'value'); 
								filename=fliplr(deblank(fliplr(deblank(varargin{3}))));
								if size(filename,1)==length(nsubs),
									for n1=1:length(nsubs),
										nsub=nsubs(n1);
										[V,str,icon]=conn_getinfo(deblank(filename(n1,:)));
										CONN_x.Setup.rois.files{nsub}{nrois}={deblank(filename(n1,:)),str,icon};
                                        [nill,nill,nameext]=fileparts(deblank(filename(n1,:)));CONN_x.Setup.rois.multiplelabels(nrois)=(strcmp(nameext,'.img')|strcmp(nameext,'.nii'))&~isempty(dir(conn_prepend('',deblank(filename(n1,:)),'.txt'))); 
									end
								elseif size(filename,1)==1,
									[V,str,icon]=conn_getinfo(deblank(filename));
									for nsub=nsubs(:)',CONN_x.Setup.rois.files{nsub}{nrois}={deblank(filename),str,icon};end
                                    [nill,nill,nameext]=fileparts(deblank(filename));CONN_x.Setup.rois.multiplelabels(nrois)=(strcmp(nameext,'.img')|strcmp(nameext,'.nii'))&~isempty(dir(conn_prepend('',deblank(filename),'.txt'))); 
								else,
									errordlg('mismatched number of files','');
								end
							case 6,
								nrois=get(CONN_h.menus.m_setup_00{1},'value'); 
								names=get(CONN_h.menus.m_setup_00{1},'string');
								name=fliplr(deblank(fliplr(deblank(get(CONN_h.menus.m_setup_00{6},'string')))));
								if nrois<=3||~isempty(strmatch(name,names,'exact')),name=CONN_x.Setup.rois.names{nrois}; end
                                names{nrois}=name;
                                CONN_x.Setup.rois.names{nrois}=name;
                                if nrois==length(CONN_x.Setup.rois.names)&&~strcmp(CONN_x.Setup.rois.names{nrois},' '), CONN_x.Setup.rois.names{nrois+1}=' '; names{nrois+1}=' '; end
                                set(CONN_h.menus.m_setup_00{1},'string',names);
                            case 7,
								nrois=get(CONN_h.menus.m_setup_00{1},'value'); 
								names=get(CONN_h.menus.m_setup_00{1},'string');
								dims=abs(round(str2num(get(CONN_h.menus.m_setup_00{7},'string'))));
								if length(dims)==1,CONN_x.Setup.rois.dimensions{nrois}=dims;end
                            case 8,
                                nrois0=length(CONN_x.Setup.rois.names);
								nrois1=get(CONN_h.menus.m_setup_00{1},'value'); 
                                nrois=setdiff(nrois1,[1:3,nrois0]);
                                nrois=setdiff(1:nrois0,nrois);
                                CONN_x.Setup.rois.names={CONN_x.Setup.rois.names{nrois}};
                                nrois=setdiff(nrois,nrois0);
                                CONN_x.Setup.rois.dimensions={CONN_x.Setup.rois.dimensions{nrois}};
                                CONN_x.Setup.rois.mask=CONN_x.Setup.rois.mask(nrois);
                                CONN_x.Setup.rois.multiplelabels=CONN_x.Setup.rois.multiplelabels(nrois);
                                for n1=1:length(CONN_x.Setup.rois.files), CONN_x.Setup.rois.files{n1}={CONN_x.Setup.rois.files{n1}{nrois}}; end
        						set(CONN_h.menus.m_setup_00{1},'string',CONN_x.Setup.rois.names,'value',max(1,min(length(CONN_x.Setup.rois.names)-1,max(nrois1))));
                                nsubs=get(CONN_h.menus.m_setup_00{2},'value');
                                for n1=1:3,if any(nrois1==n1), for nsub=nsubs(:)', CONN_x.Setup.rois.files{nsub}{n1}={[],[],[]}; end; end; end
                            case 9,
								nrois=get(CONN_h.menus.m_setup_00{1},'value'); 
                                if nrois>3,
                                    value=get(CONN_h.menus.m_setup_00{9},'value');
                                    CONN_x.Setup.rois.mask(nrois)=value;
                                else,set(CONN_h.menus.m_setup_00{9},'value',0);end
                            case 10,
								nrois=get(CONN_h.menus.m_setup_00{1},'value'); 
                                if nrois>3,
                                    value=get(CONN_h.menus.m_setup_00{10},'value');
                                    CONN_x.Setup.rois.multiplelabels(nrois)=value;
                                else,set(CONN_h.menus.m_setup_00{10},'value',0);end
                            case 11,
                                normalized=get(CONN_h.menus.m_setup_00{11},'value');
                                if ~normalized, warndlg('Warning: Second-level analyses not available for un-normalized data'); end
                                CONN_x.Setup.normalized=normalized;
                        end
                    end
					names=get(CONN_h.menus.m_setup_00{1},'string');
					nrois=get(CONN_h.menus.m_setup_00{1},'value'); 
                    nsubs=get(CONN_h.menus.m_setup_00{2},'value');
					set(CONN_h.menus.m_setup_00{6},'string',deblank(names{nrois}));
					if ~isfield(CONN_x.Setup.rois,'dimensions') || length(CONN_x.Setup.rois.dimensions)<nrois, CONN_x.Setup.rois.dimensions{nrois}=1; end
					if ~isfield(CONN_x.Setup.rois,'mask') || length(CONN_x.Setup.rois.mask)<nrois, CONN_x.Setup.rois.mask(nrois)=0; end
					if ~isfield(CONN_x.Setup.rois,'multiplelabels') || length(CONN_x.Setup.rois.multiplelabels)<nrois, CONN_x.Setup.rois.multiplelabels(nrois)=0; end
					set(CONN_h.menus.m_setup_00{7},'string',num2str(CONN_x.Setup.rois.dimensions{nrois}));
					set(CONN_h.menus.m_setup_00{9},'value',CONN_x.Setup.rois.mask(nrois));
					set(CONN_h.menus.m_setup_00{10},'value',CONN_x.Setup.rois.multiplelabels(nrois));
                    %if nrois<=3, set([CONN_h.menus.m_setup_00{6},CONN_h.menus.m_setup_00{9},CONN_h.menus.m_setup_00{10}],'visible','off');
                    %else, set(CONN_h.menus.m_setup_00{6},'visible','on','backgroundcolor','w','foregroundcolor','k'); set([CONN_h.menus.m_setup_00{9},CONN_h.menus.m_setup_00{10}],'visible','on'); end
                    set(CONN_h.menus.m_setup_00{6},'visible','on','backgroundcolor','k','foregroundcolor','w'); set([CONN_h.menus.m_setup_00{9},CONN_h.menus.m_setup_00{10}],'visible','on','foregroundcolor','w','backgroundcolor',[0,0,1/6]);
					ok=1; ko=[];
					for nsub=nsubs(:)',
						if length(CONN_x.Setup.rois.files)<nsub, CONN_x.Setup.rois.files{nsub}={}; end
						if length(CONN_x.Setup.rois.files{nsub})<nrois, CONN_x.Setup.rois.files{nsub}{nrois}={}; end
						if length(CONN_x.Setup.rois.files{nsub}{nrois})<3, CONN_x.Setup.rois.files{nsub}{nrois}{3}=[]; end
						if isempty(ko), ko=CONN_x.Setup.rois.files{nsub}{nrois}{1}; 
						else, if ~all(size(ko)==size(CONN_x.Setup.rois.files{nsub}{nrois}{1})) || ~all(all(ko==CONN_x.Setup.rois.files{nsub}{nrois}{1})), ok=0; end; end
					end
					if ok,
						conn_menu('update',CONN_h.menus.m_setup_00{5},CONN_x.Setup.rois.files{nsub}{nrois}{3});
						set(CONN_h.menus.m_setup_00{4},'string',CONN_x.Setup.rois.files{nsub}{nrois}{2});
					else, 
						conn_menu('update',CONN_h.menus.m_setup_00{5},[]);
						set(CONN_h.menus.m_setup_00{4},'string','multiple files');
					end
                case 5, %conditions
                    if nargin<2,
                        conn_menu('frame',[.19,.23,.47,.57],'EXPERIMENTAL CONDITIONS SETUP');
						CONN_h.menus.m_setup_00{1}=conn_menu('listbox',[.200,.25,.075,.5],'Conditions','','','conn(''gui_setup'',1);');
						CONN_h.menus.m_setup_00{2}=conn_menu('listbox',[.275,.25,.075,.5],'Subjects','','','conn(''gui_setup'',2);');
						CONN_h.menus.m_setup_00{3}=conn_menu('listbox',[.350,.25,.075,.5],'Sessions','','','conn(''gui_setup'',3);');
						CONN_h.menus.m_setup_00{4}=conn_menu('edit',[.45,.55,.2,.04],'onset',[],'onset times marking the beginning of each block (in seconds)','conn(''gui_setup'',4);');
						CONN_h.menus.m_setup_00{5}=conn_menu('edit',[.45,.45,.2,.04],'duration',[],'duration of condition blocks (in seconds)','conn(''gui_setup'',5);');
						CONN_h.menus.m_setup_00{6}=conn_menu('edit',[.45,.65,.2,.04],'condition name','','Condition name','conn(''gui_setup'',6);');
						set(CONN_h.menus.m_setup_00{3},'max',2);
						set(CONN_h.menus.m_setup_00{2},'string',[repmat('Subject ',[CONN_x.Setup.nsubjects,1]),num2str((1:CONN_x.Setup.nsubjects)')],'max',2);
						set(CONN_h.menus.m_setup_00{1},'string',CONN_x.Setup.conditions.names,'max',1);
                        nsess=CONN_x.Setup.nsessions(1); set(CONN_h.menus.m_setup_00{3},'string',[repmat('Session ',[nsess,1]),num2str((1:nsess)')],'value',min(nsess,get(CONN_h.menus.m_setup_00{3},'value')));
                        hc1=uicontextmenu;uimenu(hc1,'Label','remove selected condition','callback','conn(''gui_setup'',8);');set(CONN_h.menus.m_setup_00{1},'uicontextmenu',hc1);
                    else
                        switch(varargin{2}),
                            case 2, value=get(CONN_h.menus.m_setup_00{2},'value'); 
                                nsess=max(CONN_x.Setup.nsessions(min(length(CONN_x.Setup.nsessions),value))); 
                                set(CONN_h.menus.m_setup_00{3},'string',[repmat('Session ',[nsess,1]),num2str((1:nsess)')],'value',min(nsess,get(CONN_h.menus.m_setup_00{3},'value')));
							case 4,
								nconditions=get(CONN_h.menus.m_setup_00{1},'value'); 
								nsubs=get(CONN_h.menus.m_setup_00{2},'value');
								nsess=get(CONN_h.menus.m_setup_00{3},'value');
								value=str2num(get(CONN_h.menus.m_setup_00{4},'string'));
                                if isempty(value), try, value=evalin('base',get(CONN_h.menus.m_setup_00{4},'string')); catch, value=[]; end; end
								if ~isempty(value),
									for nsub=nsubs(:)', for nses=nsess(:)', 
											if nses<=CONN_x.Setup.nsessions(min(length(CONN_x.Setup.nsessions),nsub)), CONN_x.Setup.conditions.values{nsub}{nconditions}{nses}{1}=value; end
									end; end;
								end
							case 5,
								nconditions=get(CONN_h.menus.m_setup_00{1},'value'); 
								nsubs=get(CONN_h.menus.m_setup_00{2},'value');
								nsess=get(CONN_h.menus.m_setup_00{3},'value');
								value=str2num(get(CONN_h.menus.m_setup_00{5},'string'));
                                if isempty(value), try, value=evalin('base',get(CONN_h.menus.m_setup_00{5},'string')); catch, value=[]; end; end
								if ~isempty(value),
									for nsub=nsubs(:)', for nses=nsess(:)', 
											if nses<=CONN_x.Setup.nsessions(min(length(CONN_x.Setup.nsessions),nsub)), CONN_x.Setup.conditions.values{nsub}{nconditions}{nses}{2}=value; end
									end; end;
								end
							case 6,
								nconditions=get(CONN_h.menus.m_setup_00{1},'value'); 
								names=get(CONN_h.menus.m_setup_00{1},'string');
								name=fliplr(deblank(fliplr(deblank(get(CONN_h.menus.m_setup_00{6},'string')))));
								if isempty(strmatch(name,names,'exact')),
									names{nconditions}=name;
									CONN_x.Setup.conditions.names{nconditions}=name;
									if nconditions==length(CONN_x.Setup.conditions.names), CONN_x.Setup.conditions.names{nconditions+1}=' '; names{nconditions+1}=' '; end
									set(CONN_h.menus.m_setup_00{1},'string',names);
								end
                            case 8,
								nconditions1=get(CONN_h.menus.m_setup_00{1},'value'); 
                                nconditions0=length(CONN_x.Setup.conditions.names);
                                nconditions=setdiff(nconditions1,[nconditions0]);
                                nconditions=setdiff(1:nconditions0,nconditions);
                                CONN_x.Setup.conditions.names={CONN_x.Setup.conditions.names{nconditions}};
                                nconditions=setdiff(nconditions,nconditions0);
                                for n1=1:length(CONN_x.Setup.conditions.values), CONN_x.Setup.conditions.values{n1}={CONN_x.Setup.conditions.values{n1}{nconditions}}; end
        						set(CONN_h.menus.m_setup_00{1},'string',CONN_x.Setup.conditions.names,'value',max(1,min(length(CONN_x.Setup.conditions.names)-1,max(nconditions1))));
                        end
                    end
					names=get(CONN_h.menus.m_setup_00{1},'string');
					nconditions=get(CONN_h.menus.m_setup_00{1},'value'); 
                    nsubs=get(CONN_h.menus.m_setup_00{2},'value');
                    nsess=get(CONN_h.menus.m_setup_00{3},'value');
					set(CONN_h.menus.m_setup_00{6},'string',deblank(names{nconditions}));
					ok=[1,1]; ko={[],[]};
					for nsub=nsubs(:)',
						if length(CONN_x.Setup.conditions.values)<nsub, CONN_x.Setup.conditions.values{nsub}={}; end
						if length(CONN_x.Setup.conditions.values{nsub})<nconditions, CONN_x.Setup.conditions.values{nsub}{nconditions}={}; end
						for nses=nsess(:)',
							if nses<=CONN_x.Setup.nsessions(min(length(CONN_x.Setup.nsessions),nsub)), 
								if length(CONN_x.Setup.conditions.values{nsub}{nconditions})<nses, CONN_x.Setup.conditions.values{nsub}{nconditions}{nses}={}; end
								if length(CONN_x.Setup.conditions.values{nsub}{nconditions}{nses})<2, CONN_x.Setup.conditions.values{nsub}{nconditions}{nses}{2}=[]; end
								if isempty(ko{1}), ko=CONN_x.Setup.conditions.values{nsub}{nconditions}{nses}; 
								else 
									if ~all(size(ko{1})==size(CONN_x.Setup.conditions.values{nsub}{nconditions}{nses}{1})) || ~all(all(ko{1}==CONN_x.Setup.conditions.values{nsub}{nconditions}{nses}{1})), ok(1)=0; end; 
									if ~all(size(ko{2})==size(CONN_x.Setup.conditions.values{nsub}{nconditions}{nses}{2})) || ~all(all(ko{2}==CONN_x.Setup.conditions.values{nsub}{nconditions}{nses}{2})), ok(2)=0; end; 
								end
							end
						end
					end
					if ok(1), set(CONN_h.menus.m_setup_00{4},'string',num2str(ko{1}(:)')); else, set(CONN_h.menus.m_setup_00{4},'string','MULTIPLE VALUES'); end
					if ok(2), set(CONN_h.menus.m_setup_00{5},'string',num2str(ko{2}(:)')); else, set(CONN_h.menus.m_setup_00{5},'string','MULTIPLE VALUES'); end
				case 6, % covariates
					conn('gui_setup_covariates');
			end
		case 'gui_setup_covariates',
			state=conn_menumanager(CONN_h.menus.m_setup_02,'state');state=0*state;state(6)=1;conn_menumanager(CONN_h.menus.m_setup_02,'state',state,'on',1);	
			state=find(conn_menumanager(CONN_h.menus.m_setup_03,'state'));
            if nargin<2,
                conn_menumanager clf;
                axes('units','norm','position',[0,.935,1,.001]); image(shiftdim([1,1,4/6],-1)); axis off;
				conn_menumanager([CONN_h.menus.m_setup_02,CONN_h.menus.m_setup_01,CONN_h.menus.m_setup_06,CONN_h.menus.m0],'on',1);
            end
			if isempty(state) return; end
			switch(state),
				case 1, % first-level covariates
					if nargin<2,
						conn_menu('frame',[.19,.23,.44,.57],'FIRST-LEVEL COVARIATES SETUP');
						CONN_h.menus.m_setup_00{1}=conn_menu('listbox',[.200,.25,.075,.5],'Covariates','','','conn(''gui_setup_covariates'',1);');
						CONN_h.menus.m_setup_00{2}=conn_menu('listbox',[.275,.25,.075,.5],'Subjects','','','conn(''gui_setup_covariates'',2);');
						CONN_h.menus.m_setup_00{3}=conn_menu('listbox',[.350,.25,.075,.5],'Sessions','','','conn(''gui_setup_covariates'',3);');
						CONN_h.menus.m_setup_00{4}=conn_menu('filesearch',[],'Select covariate files','*.mat; *.txt;','',{@conn,'gui_setup_covariates',4});
						CONN_h.menus.m_setup_00{5}=conn_menu('text', [.425,.51,.2,.09],'Files');
						CONN_h.menus.m_setup_00{6}=conn_menu('image',[.435,.25,.17,.25]);
						CONN_h.menus.m_setup_00{7}=conn_menu('edit',[.455,.66,.14,.04],'covariate name','','First-level covariate name','conn(''gui_setup_covariates'',7);');
						set(CONN_h.menus.m_setup_00{4}.files,'max',2);
						set(CONN_h.menus.m_setup_00{3},'max',2);
						set(CONN_h.menus.m_setup_00{2},'string',[repmat('Subject ',[CONN_x.Setup.nsubjects,1]),num2str((1:CONN_x.Setup.nsubjects)')],'max',2);
						set(CONN_h.menus.m_setup_00{1},'string',CONN_x.Setup.l1covariates.names,'max',1);
						nsess=CONN_x.Setup.nsessions(1); set(CONN_h.menus.m_setup_00{3},'string',[repmat('Session ',[nsess,1]),num2str((1:nsess)')],'value',min(nsess,get(CONN_h.menus.m_setup_00{3},'value')));
                        hc1=uicontextmenu;uimenu(hc1,'Label','remove selected covariate','callback','conn(''gui_setup_covariates'',8);');set(CONN_h.menus.m_setup_00{1},'uicontextmenu',hc1);
					else
						switch(varargin{2}),
							case 2, value=get(CONN_h.menus.m_setup_00{2},'value'); 
								nsess=max(CONN_x.Setup.nsessions(min(length(CONN_x.Setup.nsessions),value))); 
								set(CONN_h.menus.m_setup_00{3},'string',[repmat('Session ',[nsess,1]),num2str((1:nsess)')],'value',min(nsess,get(CONN_h.menus.m_setup_00{3},'value')));
							case 4,
								nl1covariates=get(CONN_h.menus.m_setup_00{1},'value'); 
								nsubs=get(CONN_h.menus.m_setup_00{2},'value');
								nsess=get(CONN_h.menus.m_setup_00{3},'value');
								filename=fliplr(deblank(fliplr(deblank(varargin{3}))));
								if size(filename,1)==length(nsubs)*length(nsess),
									n3=1;for n1=1:length(nsubs), for n2=1:length(nsess),
										nsub=nsubs(n1);nses=nsess(n2);
										[V,str,icon]=conn_getinfo(deblank(filename(n3,:)));
                                        CONN_x.Setup.l1covariates.files{nsub}{nl1covariates}{nses}={deblank(filename(n3,:)),str,icon};
                                        n3=n3+1;
                                    end;end
								elseif size(filename,1)==1,
                                    [V,str,icon]=conn_getinfo(filename);
                                    for nsub=nsubs(:)', for nses=nsess(:)',
                                            if nses<=CONN_x.Setup.nsessions(min(length(CONN_x.Setup.nsessions),nsub)), CONN_x.Setup.l1covariates.files{nsub}{nl1covariates}{nses}={filename,str,icon}; end;
                                        end; end
								else,
									errordlg('mismatched number of files','');
                                end
                                
							case 7,
								nl1covariates=get(CONN_h.menus.m_setup_00{1},'value'); 
								names=get(CONN_h.menus.m_setup_00{1},'string');
								name=fliplr(deblank(fliplr(deblank(get(CONN_h.menus.m_setup_00{7},'string')))));
								if isempty(strmatch(name,names,'exact')),
									names{nl1covariates}=name;
									CONN_x.Setup.l1covariates.names{nl1covariates}=name;
									if nl1covariates==length(CONN_x.Setup.l1covariates.names), CONN_x.Setup.l1covariates.names{nl1covariates+1}=' '; names{nl1covariates+1}=' '; end
									set(CONN_h.menus.m_setup_00{1},'string',names);
								end
                            case 8,
								nl1covariates1=get(CONN_h.menus.m_setup_00{1},'value'); 
                                nl1covariates0=length(CONN_x.Setup.l1covariates.names);
                                nl1covariates=setdiff(nl1covariates1,[nl1covariates0]);
                                nl1covariates=setdiff(1:nl1covariates0,nl1covariates);
                                CONN_x.Setup.l1covariates.names={CONN_x.Setup.l1covariates.names{nl1covariates}};
                                nl1covariates=setdiff(nl1covariates,nl1covariates0);
                                for n1=1:length(CONN_x.Setup.l1covariates.files), CONN_x.Setup.l1covariates.files{n1}={CONN_x.Setup.l1covariates.files{n1}{nl1covariates}}; end
        						set(CONN_h.menus.m_setup_00{1},'string',CONN_x.Setup.l1covariates.names,'value',max(1,min(length(CONN_x.Setup.l1covariates.names)-1,max(nl1covariates1))));
						end
					end
					names=get(CONN_h.menus.m_setup_00{1},'string');
					nl1covariates=get(CONN_h.menus.m_setup_00{1},'value'); 
					nsubs=get(CONN_h.menus.m_setup_00{2},'value');
					nsess=get(CONN_h.menus.m_setup_00{3},'value');
					set(CONN_h.menus.m_setup_00{7},'string',deblank(names{nl1covariates}));
					ok=1; ko=[];
					for nsub=nsubs(:)',
						if length(CONN_x.Setup.l1covariates.files)<nsub, CONN_x.Setup.l1covariates.files{nsub}={}; end
						if length(CONN_x.Setup.l1covariates.files{nsub})<nl1covariates, CONN_x.Setup.l1covariates.files{nsub}{nl1covariates}={}; end
						for nses=nsess(:)',
							if nses<=CONN_x.Setup.nsessions(min(length(CONN_x.Setup.nsessions),nsub)), 
								if length(CONN_x.Setup.l1covariates.files{nsub}{nl1covariates})<nses, CONN_x.Setup.l1covariates.files{nsub}{nl1covariates}{nses}={}; end
								if length(CONN_x.Setup.l1covariates.files{nsub}{nl1covariates}{nses})<3, CONN_x.Setup.l1covariates.files{nsub}{nl1covariates}{nses}{3}=[]; end
								if isempty(ko), ko=CONN_x.Setup.l1covariates.files{nsub}{nl1covariates}{nses}{1}; 
								elseif ~all(size(ko)==size(CONN_x.Setup.l1covariates.files{nsub}{nl1covariates}{nses}{1})) || ~all(all(ko==CONN_x.Setup.l1covariates.files{nsub}{nl1covariates}{nses}{1})), ok=0; end; 
							end
						end
					end
					if ok,
						conn_menu('update',CONN_h.menus.m_setup_00{6},CONN_x.Setup.l1covariates.files{nsub}{nl1covariates}{nses}{3});
						set(CONN_h.menus.m_setup_00{5},'string',CONN_x.Setup.l1covariates.files{nsub}{nl1covariates}{nses}{2});
					else, 
						conn_menu('update',CONN_h.menus.m_setup_00{6},[]);
						set(CONN_h.menus.m_setup_00{5},'string','multiple files');
					end
				case 2, %Covariates (L2)
					if nargin<2,
						conn_menu('frame',[.19,.23,.32,.57],'SECOND-LEVEL COVARIATES SETUP');
						CONN_h.menus.m_setup_00{1}=conn_menu('listbox',[.200,.25,.075,.5],'Covariate','','','conn(''gui_setup_covariates'',1);');
						CONN_h.menus.m_setup_00{2}=conn_menu('edit',[.3,.55,.2,.04],'values',[],'values of this covariate for each subject','conn(''gui_setup_covariates'',2);');
						CONN_h.menus.m_setup_00{3}=conn_menu('edit',[.3,.65,.2,.04],'covariate name','','Second-level covariate name','conn(''gui_setup_covariates'',3);');
						set(CONN_h.menus.m_setup_00{1},'string',CONN_x.Setup.l2covariates.names,'max',1);
                        hc1=uicontextmenu;uimenu(hc1,'Label','remove selected covariate','callback','conn(''gui_setup_covariates'',8);');set(CONN_h.menus.m_setup_00{1},'uicontextmenu',hc1);
					else
						switch(varargin{2}),
							case 2,
								nl2covariates=get(CONN_h.menus.m_setup_00{1},'value'); 
								value=str2num(get(CONN_h.menus.m_setup_00{2},'string'));
                                if isempty(value), try, value=evalin('base',get(CONN_h.menus.m_setup_00{2},'string')); catch, value=[]; end; end
								if length(value)==1 || length(value)==CONN_x.Setup.nsubjects,
									for nsub=1:CONN_x.Setup.nsubjects,
										CONN_x.Setup.l2covariates.values{nsub}{nl2covariates}=value(min(length(value),nsub));
									end
								end
							case 3,
								nl2covariates=get(CONN_h.menus.m_setup_00{1},'value'); 
								names=get(CONN_h.menus.m_setup_00{1},'string');
								name=fliplr(deblank(fliplr(deblank(get(CONN_h.menus.m_setup_00{3},'string')))));
								if isempty(strmatch(name,names,'exact')),
									names{nl2covariates}=name;
									CONN_x.Setup.l2covariates.names{nl2covariates}=name;
									if nl2covariates==length(CONN_x.Setup.l2covariates.names), CONN_x.Setup.l2covariates.names{nl2covariates+1}=' '; names{nl2covariates+1}=' '; end
									set(CONN_h.menus.m_setup_00{1},'string',names);
								end
                            case 8,
								nl2covariates1=get(CONN_h.menus.m_setup_00{1},'value'); 
                                nl2covariates0=length(CONN_x.Setup.l2covariates.names);
                                nl2covariates=setdiff(nl2covariates1,[nl2covariates0]);
                                nl2covariates=setdiff(1:nl2covariates0,nl2covariates);
                                CONN_x.Setup.l2covariates.names={CONN_x.Setup.l2covariates.names{nl2covariates}};
                                nl2covariates=setdiff(nl2covariates,nl2covariates0);
                                for n1=1:length(CONN_x.Setup.l2covariates.values), CONN_x.Setup.l2covariates.values{n1}={CONN_x.Setup.l2covariates.values{n1}{nl2covariates}}; end
        						set(CONN_h.menus.m_setup_00{1},'string',CONN_x.Setup.l2covariates.names,'value',max(1,min(length(CONN_x.Setup.l2covariates.names)-1,max(nl2covariates1))));
						end
					end
					names=get(CONN_h.menus.m_setup_00{1},'string');
					nl2covariates=get(CONN_h.menus.m_setup_00{1},'value'); 
					set(CONN_h.menus.m_setup_00{3},'string',deblank(names{nl2covariates}));
					t=[]; 
					for nsub=1:CONN_x.Setup.nsubjects,
						if length(CONN_x.Setup.l2covariates.values)<nsub, CONN_x.Setup.l2covariates.values{nsub}={}; end
						if length(CONN_x.Setup.l2covariates.values{nsub})<nl2covariates, CONN_x.Setup.l2covariates.values{nsub}{nl2covariates}=0; end
						t=cat(2,t,CONN_x.Setup.l2covariates.values{nsub}{nl2covariates});
					end					
					k=t; for n=0:6, if abs(round(k)-k)<1e-6, break; end; k=k*10; end; 
					set(CONN_h.menus.m_setup_00{2},'string',num2str(t,['%0.',num2str(n),'f '])); 
			end

		case 'gui_setup_load',
            [filename,pathname]=uigetfile('conn_*.mat','Loads experiment data');
			if ischar(filename),
				filename=fullfile(pathname,filename);
				try, load(filename,'CONN_x'); CONN_x.filename=filename; catch, waitfor(errordlg(['Failed to load file ',filename,'.'],mfilename)); return; end
                try, conn_updatefilepaths; end
                CONN_x.filename=filename;
                conn_updatefolders;
			end
            conn gui_setup;
			
		case {'gui_setup_save','gui_setup_saveas'},
			if strcmp(varargin{1},'gui_setup_saveas') || isempty(CONN_x.filename) || ~ischar(CONN_x.filename), if ~ischar(CONN_x.filename), filename=''; else, filename=CONN_x.filename; end; [filename,pathname]=uiputfile('conn_*.mat','Save experiment data',filename);
			else pathname='';filename=CONN_x.filename; end
			if ischar(filename),
				set(CONN_h.screen.hfig,'pointer','watch');
				filename=fullfile(pathname,filename);
				pathname=CONN_x.filename;
				CONN_x.filename=filename;
                conn_updatefolders;
				try 
					if str2num(version('-release'))>=14, save(filename,'-V6','CONN_x');
					else, save(filename,'CONN_x'); end
                catch
                    CONN_x.filename=pathname; waitfor(errordlg(['Failed to save file ',filename,'. Check file name and/or folder permissions'],mfilename)); 
                end
				set(CONN_h.screen.hfig,'pointer','arrow');
            end

        case 'gui_setup_new',
            Answ=questdlg('Do you want to spatially preprocess your data now (realignment/coregistration/normalization/smoothing)?','conn','Yes','No','Yes');
            if strcmp(Answ,'Yes'),
                conn_setup_wizard;
            else,
                conn init;
                conn importrois;
                conn gui_setup;
            end
            
		case 'gui_setup_import',
			if nargin<2
                conn_menumanager clf;
                axes('units','norm','position',[0,.935,1,.001]); image(shiftdim([1,1,4/6],-1)); axis off;
				conn_menumanager([CONN_h.menus.m_setup_04,CONN_h.menus.m0],'on',1);
				
				conn_menu('frame',[.19,.13,.295,.67],'IMPORT SETUP FROM SPM');
				CONN_h.menus.m_setup_00{1}=conn_menu('listbox',[.2,.15,.075,.5],'Subjects','','','conn(''gui_setup_import'',1);');
				CONN_h.menus.m_setup_00{2}=conn_menu('edit',[.2,.7,.2,.04],'Number of subjects',num2str(CONN_x.Setup.nsubjects),'Number of subjects in this experiment','conn(''gui_setup_import'',2);');
				CONN_h.menus.m_setup_00{3}=conn_menu('filesearch',[],'Select SPM.mat subject files','SPM.mat','',{@conn,'gui_setup_import',3});
				CONN_h.menus.m_setup_00{4}=conn_menu('text', [.275,.46,.2,.19],'Files');
				CONN_h.menus.m_setup_00{5}=conn_menu('image',[.285,.15,.17,.3]);
				set(CONN_h.menus.m_setup_00{1},'string',[repmat('Subject ',[CONN_x.Setup.nsubjects,1]),num2str((1:CONN_x.Setup.nsubjects)')],'max',1);
			else
				switch(varargin{2}),
					case 1, 
					case 2,
						value0=CONN_x.Setup.nsubjects; 
						txt=get(CONN_h.menus.m_setup_00{2},'string'); value=str2num(txt); if ~isempty(value)&&length(value)==1, CONN_x.Setup.nsubjects=value; end; 
						if CONN_x.Setup.nsubjects~=value0, CONN_x.Setup.nsubjects=conn_merge(value0,CONN_x.Setup.nsubjects); end
						set(CONN_h.menus.m_setup_00{2},'string',num2str(CONN_x.Setup.nsubjects)); 
						set(CONN_h.menus.m_setup_00{1},'string',[repmat('Subject ',[CONN_x.Setup.nsubjects,1]),num2str((1:CONN_x.Setup.nsubjects)')],'max',1,'value',min(CONN_x.Setup.nsubjects,get(CONN_h.menus.m_setup_00{1},'value')));
					case 3,
						if nargin<4, nsubs=get(CONN_h.menus.m_setup_00{1},'value'); else, nsubs=varargin{4}; end
						filename=fliplr(deblank(fliplr(deblank(varargin{3}))));
						[V,str,icon]=conn_getinfo(filename);
						CONN_x.Setup.spm{nsubs}={filename,str,icon};
				end
			end
			nsubs=get(CONN_h.menus.m_setup_00{1},'value');
			conn_menu('update',CONN_h.menus.m_setup_00{5},CONN_x.Setup.spm{nsubs}{3});
			set(CONN_h.menus.m_setup_00{4},'string',CONN_x.Setup.spm{nsubs}{2});
				
		case 'gui_setup_importdone',
			conn_importspm;
			conn gui_setup;
			%conn_menumanager clf;
			%axes('units','norm','position',[0,.935,1,.001]); image(shiftdim([1,1,4/6],-1)); axis off;
			%conn_menumanager([CONN_h.menus.m_setup_02,CONN_h.menus.m_setup_01,CONN_h.menus.m0],'on',1);
			
		case 'gui_setup_merge',
			if nargin<2
                conn_menumanager clf;
                axes('units','norm','position',[0,.935,1,.001]); image(shiftdim([1,1,4/6],-1)); axis off;
				conn_menumanager([CONN_h.menus.m_setup_05,CONN_h.menus.m0],'on',1);
                
                CONN_x.Setup.merge.nprojs=1;
                CONN_x.Setup.merge.files={{[],[],[]}};
                conn_menu('frame',[.19,.13,.295,.67],'MERGE WITH OTHER CONN_* PROJECTS');
                CONN_h.menus.m_setup_00{1}=conn_menu('listbox',[.2,.15,.075,.5],'Projects','','','conn(''gui_setup_merge'',1);');
				CONN_h.menus.m_setup_00{2}=conn_menu('edit',[.2,.7,.2,.04],'Number of projects',num2str(1),'Number of projects to merge the current experiment with','conn(''gui_setup_merge'',2);');
				CONN_h.menus.m_setup_00{3}=conn_menu('filesearch',[],'Select conn_*.mat project files','conn_*.mat','',{@conn,'gui_setup_merge',3});
				CONN_h.menus.m_setup_00{4}=conn_menu('text', [.275,.46,.2,.19],'Files');
				CONN_h.menus.m_setup_00{5}=conn_menu('image',[.285,.15,.17,.3]);
				set(CONN_h.menus.m_setup_00{1},'string',[repmat('Project ',[CONN_x.Setup.merge.nprojs,1]),num2str((1:CONN_x.Setup.merge.nprojs)')],'max',1);
			else
				switch(varargin{2}),
					case 1, 
					case 2,
						value0=CONN_x.Setup.merge.nprojs; 
						txt=get(CONN_h.menus.m_setup_00{2},'string'); value=str2num(txt); 
                        if ~isempty(value)&&length(value)==1, CONN_x.Setup.merge.nprojs=value; end; 
                        for n0=value0+1:CONN_x.Setup.merge.nprojs,CONN_x.Setup.merge.files{n0}={[],[],[]};end
                        CONN_x.Setup.merge.files={CONN_x.Setup.merge.files{1:CONN_x.Setup.merge.nprojs}};
						set(CONN_h.menus.m_setup_00{2},'string',num2str(CONN_x.Setup.merge.nprojs)); 
						set(CONN_h.menus.m_setup_00{1},'string',[repmat('Project ',[CONN_x.Setup.merge.nprojs,1]),num2str((1:CONN_x.Setup.merge.nprojs)')],'max',1,'value',min(CONN_x.Setup.merge.nprojs,get(CONN_h.menus.m_setup_00{1},'value')));
					case 3,
						if nargin<4, nprojs=get(CONN_h.menus.m_setup_00{1},'value'); else, nprojs=varargin{4}; end
						filename=fliplr(deblank(fliplr(deblank(varargin{3}))));
						[V,str,icon]=conn_getinfo(filename);
						CONN_x.Setup.merge.files{nprojs}={filename,str,icon};
				end
			end
			nprojs=get(CONN_h.menus.m_setup_00{1},'value');
			conn_menu('update',CONN_h.menus.m_setup_00{5},CONN_x.Setup.merge.files{nprojs}{3});
			set(CONN_h.menus.m_setup_00{4},'string',CONN_x.Setup.merge.files{nprojs}{2});
				
		case 'gui_setup_mergedone',
            filenames=[];for n1=1:CONN_x.Setup.merge.nprojs,filenames=strvcat(filenames,CONN_x.Setup.merge.files{n1}{1});end
            hm=msgbox('Merging projects... please wait','conn_display');
            value0=CONN_x.Setup.nsubjects;
            value=conn_merge(filenames);
            if value~=value0,
                conn_process('prepare_results');
                close(hm);
                conn gui_setup;
            else,
                close(hm);
                hm=msgbox('There were problems importing the new subject data. Check the command line for further information','conn_display');
            end
			%conn_menumanager clf;
			%axes('units','norm','position',[0,.935,1,.001]); image(shiftdim([1,1,4/6],-1)); axis off;
			%conn_menumanager([CONN_h.menus.m_setup_02,CONN_h.menus.m_setup_01,CONN_h.menus.m0],'on',1);
			
		case 'gui_setup_finish',
			if isempty(CONN_x.filename), conn gui_setup_save; end
			conn_menumanager clf;
			axes('units','norm','position',[0,.935,1,.001]); image(shiftdim([1,1,4/6],-1)); axis off;
			conn_menumanager([CONN_h.menus.m0],'on',1);
			conn_process('setup');
			conn gui_setup_save;
			
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%			
		case 'gui_preproc',
            CONN_x.gui=1;
			model=0;
            if nargin<2,
				if isempty(CONN_x.Preproc.variables.names), uiwait(errordlg('Data not prepared for analyses. Press "done" in the Setup window','')); conn gui_setup; return; end
                conn_menumanager clf;
                axes('units','norm','position',[0,.935,1,.001]); image(shiftdim([1,1,4/6],-1)); axis off;
				conn_menumanager([CONN_h.menus.m_preproc_02,CONN_h.menus.m0],'on',1);

				conn_menu('frame',[.04,.13,.37,.67],'GLM - DEFINE POSSIBLE CONFOUNDS');
				CONN_h.menus.m_preproc_00{1}=conn_menu('listbox',[.05,.25,.075,.5],'','','','conn(''gui_preproc'',1);');
				CONN_h.menus.m_preproc_00{2}=conn_menu('listbox',[.15,.25,.075,.5],'Confounds','','','conn(''gui_preproc'',2);');
				CONN_h.menus.m_preproc_00{3}=conn_menu('image',[.25,.25,.14,.31],'');
				CONN_h.menus.m_preproc_00{4}=conn_menu('edit',[.25,.7,.14,.04],'derivatives order','','Include derivates up to n-th order (0 for no derivatives, 1 for first-order derivatives,...)','conn(''gui_preproc'',4);');
				CONN_h.menus.m_preproc_00{5}=conn_menu('edit',[.05,.15,.175,.04],'band-pass filter (Hz)',num2str(CONN_x.Preproc.filter),'Band pass filter threshold (two values, low-pass and high-pass thresholds, respectively)','conn(''gui_preproc'',5);');
				CONN_h.menus.m_preproc_00{6}=conn_menu('edit',[.25,.6,.14,.04],'dimensions','','Number of dimensions','conn(''gui_preproc'',6);');
				conn_menu('frame',[.49,.16,.47,.64],'PREVIEW RESULTS');
				CONN_h.menus.m_preproc_00{11}=conn_menu('listbox',[.5,.45,.075,.3],'Subject','','','conn(''gui_preproc'',11);');
				CONN_h.menus.m_preproc_00{12}=conn_menu('listbox',[.575,.45,.075,.3],'Sessions','','','conn(''gui_preproc'',12);');
				CONN_h.menus.m_preproc_00{13}=conn_menu('listbox',[.65,.45,.075,.3],'Effect','','','conn(''gui_preproc'',13);');
				CONN_h.menus.m_preproc_00{14}=conn_menu('image',[.75,.25,.17,.5],'BOLD % variance explained');
				[CONN_h.menus.m_preproc_00{16},CONN_h.menus.m_preproc_00{17}]=conn_menu('hist',[.5,.20,.225,.20],'Voxel-to-voxel connectivity (r)');
				pos=[.75,.25,.17,.5];
				uicontrol('style','text','units','norm','position',[pos(1)+pos(3)-.170,pos(2)-2*.04,.070,.04],'string','threshold','backgroundcolor',[0,0,1/6],'foregroundcolor',[1,1,4/6]); 
				pos=[.75,.25,.17,.5];
				CONN_h.menus.m_preproc_00{15}=uicontrol('style','slider','units','norm','position',[pos(1)+pos(3)-0*.015,pos(2),.015,pos(4)],'callback','conn(''gui_preproc'',15);','backgroundcolor',[0,0,1/6]);

				set([CONN_h.menus.m_preproc_00{1},CONN_h.menus.m_preproc_00{2}],'max',2);
				set(CONN_h.menus.m_preproc_00{1},'string',CONN_x.Preproc.variables.names);
				set(CONN_h.menus.m_preproc_00{2},'string',CONN_x.Preproc.confounds.names);
				conn_menumanager(CONN_h.menus.m_preproc_01,'on',1);
				set([CONN_h.menus.m_preproc_00{1},CONN_h.menus.m_preproc_00{2}],'value',[]);
				set(CONN_h.menus.m_preproc_00{4},'enable','off');
				set(CONN_h.menus.m_preproc_00{6},'enable','off');
				set([CONN_h.menus.m_preproc_00{11},CONN_h.menus.m_preproc_00{12},CONN_h.menus.m_preproc_00{13}],'max',1);
				set(CONN_h.menus.m_preproc_00{11},'string',[repmat('Subject ',[CONN_x.Setup.nsubjects,1]),num2str((1:CONN_x.Setup.nsubjects)')]);
				nsess=CONN_x.Setup.nsessions(1); set(CONN_h.menus.m_preproc_00{12},'string',[repmat('Session ',[nsess,1]),num2str((1:nsess)')],'value',min(nsess,get(CONN_h.menus.m_preproc_00{12},'value')));
				set(CONN_h.menus.m_preproc_00{13},'string',{'TOTAL',CONN_x.Preproc.confounds.names{:}}); 
				%set(CONN_h.screen.hfig,'pointer','watch');
				[path,name,ext]=fileparts(CONN_x.filename);
% 				filepath=fullfile(path,name,'data');
                filepath=CONN_x.folders.data;
				filename=fullfile(filepath,['DATA_Subject',num2str(1,'%03d'),'_Session',num2str(1,'%03d'),'.mat']);
				CONN_h.menus.m_preproc.Y=conn_vol(filename);
				CONN_h.menus.m_preproc.y.slice=ceil(CONN_h.menus.m_preproc.Y.matdim.dim(3)/2);
				[CONN_h.menus.m_preproc.y.data,CONN_h.menus.m_preproc.y.idx]=conn_get_slice(CONN_h.menus.m_preproc.Y,CONN_h.menus.m_preproc.y.slice);
				filename=fullfile(filepath,['ROI_Subject',num2str(1,'%03d'),'_Session',num2str(1,'%03d'),'.mat']);
				CONN_h.menus.m_preproc.X1=load(filename);
				filename=fullfile(filepath,['COV_Subject',num2str(1,'%03d'),'_Session',num2str(1,'%03d'),'.mat']);
				CONN_h.menus.m_preproc.X2=load(filename);
                try,
                    CONN_h.menus.m_preproc.XS=spm_vol(deblank(CONN_x.Setup.structural{1}{1}));
                catch,
                    CONN_h.menus.m_preproc.XS=spm_vol(fullfile(fileparts(which('spm')),'canonical','single_subj_T1.nii'));
                end
				xyz=conn_convertcoordinates('idx2tal',prod(CONN_h.menus.m_preproc.Y.matdim.dim(1:2))*(CONN_h.menus.m_preproc.y.slice-1)+(1:prod(CONN_h.menus.m_preproc.Y.matdim.dim(1:2))),CONN_h.menus.m_preproc.Y.matdim.mat,CONN_h.menus.m_preproc.Y.matdim.dim);
				CONN_h.menus.m_preproc.Xs=spm_get_data(CONN_h.menus.m_preproc.XS(1),pinv(CONN_h.menus.m_preproc.XS(1).mat)*xyz'); 
				CONN_h.menus.m_preproc.Xs=permute(reshape(CONN_h.menus.m_preproc.Xs,CONN_h.menus.m_preproc.Y.matdim.dim(1:2)),[2,1,3]);
				set(CONN_h.menus.m_preproc_00{15},'min',1,'max',CONN_h.menus.m_preproc.Y.matdim.dim(3),'sliderstep',min(.5,[1,10]/(CONN_h.menus.m_preproc.Y.matdim.dim(3)-1)),'value',CONN_h.menus.m_preproc.y.slice);
				model=1;
			else,
				switch(varargin{2}),
					case 0,
						str=conn_menumanager(CONN_h.menus.m_preproc_01,'string');
						switch(str{1}),
							case '>',
								ncovariates=get(CONN_h.menus.m_preproc_00{1},'value'); 
								for ncovariate=ncovariates(:)',
									if isempty(strmatch(CONN_x.Preproc.variables.names{ncovariate},CONN_x.Preproc.confounds.names,'exact')), 
										CONN_x.Preproc.confounds.names{end+1}=CONN_x.Preproc.variables.names{ncovariate}; 
										CONN_x.Preproc.confounds.types{end+1}=CONN_x.Preproc.variables.types{ncovariate}; 
										CONN_x.Preproc.confounds.deriv{end+1}=CONN_x.Preproc.variables.deriv{ncovariate}; 
										CONN_x.Preproc.confounds.dimensions{end+1}=CONN_x.Preproc.variables.dimensions{ncovariate}; 
									end
								end
								set(CONN_h.menus.m_preproc_00{2},'string',CONN_x.Preproc.confounds.names); 
								set(CONN_h.menus.m_preproc_00{13},'string',{'TOTAL',CONN_x.Preproc.confounds.names{:}}); 
							case '<',
								ncovariates=get(CONN_h.menus.m_preproc_00{2},'value'); 
								idx=setdiff(1:length(CONN_x.Preproc.confounds.names),ncovariates);
								CONN_x.Preproc.confounds.names={CONN_x.Preproc.confounds.names{idx}};
								CONN_x.Preproc.confounds.types={CONN_x.Preproc.confounds.types{idx}};
								CONN_x.Preproc.confounds.deriv={CONN_x.Preproc.confounds.deriv{idx}};
								CONN_x.Preproc.confounds.dimensions={CONN_x.Preproc.confounds.dimensions{idx}};
								set(CONN_h.menus.m_preproc_00{2},'string',CONN_x.Preproc.confounds.names,'value',min(max(ncovariates),length(CONN_x.Preproc.confounds.names))); 
								set(CONN_h.menus.m_preproc_00{13},'string',{'TOTAL',CONN_x.Preproc.confounds.names{:}},'value',min(max(get(CONN_h.menus.m_preproc_00{13},'value')),length(CONN_x.Preproc.confounds.names)+1)); 
						end
						model=1;
					case 1,
						conn_menumanager(CONN_h.menus.m_preproc_01,'string',{'>'},'on',1);
						set(CONN_h.menus.m_preproc_00{2},'value',[]); 
						set([CONN_h.menus.m_preproc_00{4},CONN_h.menus.m_preproc_00{6}],'enable','off'); 
					case 2,
						conn_menumanager(CONN_h.menus.m_preproc_01,'string',{'<'},'on',1);
						set(CONN_h.menus.m_preproc_00{1},'value',[]); 
						set([CONN_h.menus.m_preproc_00{4},CONN_h.menus.m_preproc_00{6}],'enable','on','backgroundcolor','k','foregroundcolor','w'); 
					case 4,
						nconfounds=get(CONN_h.menus.m_preproc_00{2},'value');
						value=str2num(get(CONN_h.menus.m_preproc_00{4},'string'));
						if length(value)==1, for nconfound=nconfounds(:)', CONN_x.Preproc.confounds.deriv{nconfound}=value; end; end
						model=1;
					case 5,
						value=str2num(get(CONN_h.menus.m_preproc_00{5},'string'));
						if length(value)==2 && value(2)>value(1), CONN_x.Preproc.filter=value; end
						model=1;
					case 6,
						nconfounds=get(CONN_h.menus.m_preproc_00{2},'value');
						value=str2num(get(CONN_h.menus.m_preproc_00{6},'string'));
						if length(value)==1, for nconfound=nconfounds(:)', CONN_x.Preproc.confounds.dimensions{nconfound}(1)=max(1,min(CONN_x.Preproc.confounds.dimensions{nconfound}(2),value)); end; end
						model=1;
					case {11,12},
						nsubs=get(CONN_h.menus.m_preproc_00{11},'value');
						 if varargin{2}==11,
							 nsess=CONN_x.Setup.nsessions(min(length(CONN_x.Setup.nsessions),nsubs)); 
							 set(CONN_h.menus.m_preproc_00{12},'string',[repmat('Session ',[nsess,1]),num2str((1:nsess)')],'value',min(nsess,get(CONN_h.menus.m_preproc_00{12},'value')));
						 end
						 nsess=get(CONN_h.menus.m_preproc_00{12},'value');
						 %set(CONN_h.screen.hfig,'pointer','watch');
						 [path,name,ext]=fileparts(CONN_x.filename);
%                          filepath=fullfile(path,name,'data');
                         filepath=CONN_x.folders.data;
						 filename=fullfile(filepath,['DATA_Subject',num2str(nsubs,'%03d'),'_Session',num2str(nsess,'%03d'),'.mat']);
						 CONN_h.menus.m_preproc.Y=conn_vol(filename);
						 [CONN_h.menus.m_preproc.y.data,CONN_h.menus.m_preproc.y.idx]=conn_get_slice(CONN_h.menus.m_preproc.Y,CONN_h.menus.m_preproc.y.slice);
						 filename=fullfile(filepath,['ROI_Subject',num2str(nsubs,'%03d'),'_Session',num2str(nsess,'%03d'),'.mat']);
						 CONN_h.menus.m_preproc.X1=load(filename);
						 filename=fullfile(filepath,['COV_Subject',num2str(nsubs,'%03d'),'_Session',num2str(nsess,'%03d'),'.mat']);
						 CONN_h.menus.m_preproc.X2=load(filename);
                         try,
                             CONN_h.menus.m_preproc.XS=spm_vol(deblank(CONN_x.Setup.structural{nsubs}{1}));
                         catch,
                             CONN_h.menus.m_preproc.XS=spm_vol(fullfile(fileparts(which('spm')),'canonical','single_subj_T1.nii'));
                         end
						 xyz=conn_convertcoordinates('idx2tal',prod(CONN_h.menus.m_preproc.Y.matdim.dim(1:2))*(CONN_h.menus.m_preproc.y.slice-1)+(1:prod(CONN_h.menus.m_preproc.Y.matdim.dim(1:2))),CONN_h.menus.m_preproc.Y.matdim.mat,CONN_h.menus.m_preproc.Y.matdim.dim);
						 CONN_h.menus.m_preproc.Xs=spm_get_data(CONN_h.menus.m_preproc.XS(1),pinv(CONN_h.menus.m_preproc.XS(1).mat)*xyz'); 
						 CONN_h.menus.m_preproc.Xs=permute(reshape(CONN_h.menus.m_preproc.Xs,CONN_h.menus.m_preproc.Y.matdim.dim(1:2)),[2,1,3]);
						 model=1;
					 case 13,
						 model=2;
					 case 15,
						 nsubs=get(CONN_h.menus.m_preproc_00{11},'value');
						 CONN_h.menus.m_preproc.y.slice=round(get(CONN_h.menus.m_preproc_00{15},'value'));
						 [CONN_h.menus.m_preproc.y.data,CONN_h.menus.m_preproc.y.idx]=conn_get_slice(CONN_h.menus.m_preproc.Y,CONN_h.menus.m_preproc.y.slice);
						 xyz=conn_convertcoordinates('idx2tal',prod(CONN_h.menus.m_preproc.Y.matdim.dim(1:2))*(CONN_h.menus.m_preproc.y.slice-1)+(1:prod(CONN_h.menus.m_preproc.Y.matdim.dim(1:2))),CONN_h.menus.m_preproc.Y.matdim.mat,CONN_h.menus.m_preproc.Y.matdim.dim);
						 CONN_h.menus.m_preproc.Xs=spm_get_data(CONN_h.menus.m_preproc.XS(1),pinv(CONN_h.menus.m_preproc.XS(1).mat)*xyz'); 
						 CONN_h.menus.m_preproc.Xs=permute(reshape(CONN_h.menus.m_preproc.Xs,CONN_h.menus.m_preproc.Y.matdim.dim(1:2)),[2,1,3]);
						 model=1;
				end
			end
			nsubs=get(CONN_h.menus.m_preproc_00{11},'value');
			nconfounds=get(CONN_h.menus.m_preproc_00{2},'value');
			nview=get(CONN_h.menus.m_preproc_00{13},'value')-1;
			[CONN_h.menus.m_preproc.X,CONN_h.menus.m_preproc.select]=conn_designmatrix(CONN_x.Preproc.confounds,CONN_h.menus.m_preproc.X1,CONN_h.menus.m_preproc.X2,{nconfounds,nview});
			if isempty(nconfounds), conn_menu('update',CONN_h.menus.m_preproc_00{3},[]); 
			else, conn_menu('update',CONN_h.menus.m_preproc_00{3},CONN_h.menus.m_preproc.X); end
			if ~isempty(nconfounds)&&all(nconfounds>0), 
				temp=cat(1,CONN_x.Preproc.confounds.deriv{nconfounds});
				if length(temp)==1 || ~any(diff(temp)),set(CONN_h.menus.m_preproc_00{4},'string',num2str(CONN_x.Preproc.confounds.deriv{nconfounds(1)})); 
				else, set(CONN_h.menus.m_preproc_00{4},'string','MULTIPLE VALUES'); end
				temp=cat(1,CONN_x.Preproc.confounds.dimensions{nconfounds});
				if size(temp,1)==1 || ~any(any(diff(temp,1,1))),set(CONN_h.menus.m_preproc_00{6},'string',num2str(CONN_x.Preproc.confounds.dimensions{nconfounds(1)}(1))); 
				else, set(CONN_h.menus.m_preproc_00{6},'string','MULTIPLE VALUES'); end
			end
			set(CONN_h.menus.m_preproc_00{5},'string',num2str(CONN_x.Preproc.filter));
			if size(CONN_h.menus.m_preproc.X,2)<=500,
				offon={'off','on'};
				for n1=1:size(CONN_h.menus.m_preproc.X,2),
					set(CONN_h.menus.m_preproc_00{3}.h4(n1),'visible',offon{1+CONN_h.menus.m_preproc.select{1}(n1)});
				end
				xtemp=CONN_h.menus.m_preproc.X(:,find(CONN_h.menus.m_preproc.select{1}));
				if ~isempty(xtemp), set(CONN_h.menus.m_preproc_00{3}.h3,'ylim',[min(min(xtemp))-1e-4,max(max(xtemp))+1e-4]); end
			end
			if model==1, 
				xf=CONN_h.menus.m_preproc.X;%conn_filter(CONN_x.Setup.RT,CONN_x.Preproc.filter,CONN_h.menus.m_preproc.X,'partial');
				yf=CONN_h.menus.m_preproc.y.data;%conn_filter(CONN_x.Setup.RT,CONN_x.Preproc.filter,CONN_h.menus.m_preproc.y.data,'partial');
				[CONN_h.menus.m_preproc.B,CONN_h.menus.m_preproc.opt]=conn_glmunivariate('estimate',xf,yf); 
                if CONN_h.menus.m_preproc.opt.dof<=0, disp(['Warning: Over-determined model (no degrees of freedom for this subject). Please consider reducing the number, dimensions, or covariates order of the confounds or disregarding this subject/session']); end
                if isfield(CONN_h.menus.m_preproc.X1,'sampledata'),
                    x0=detrend(CONN_h.menus.m_preproc.X1.sampledata);x0=x0(:,~all(abs(x0)<1e-4,1));x1=x0-xf*(pinv(xf)*x0);z0=corrcoef(x0);z1=corrcoef(x1);z0=(z0(z0~=1));z1=(z1(z1~=1));
                    [a0,b0]=hist(z0(:),linspace(-1,1,100));[a1,b1]=hist(z1(:),linspace(-1,1,100));
                    conn_menu('updatehist',CONN_h.menus.m_preproc_00{16},{[b1(1),b1,b1(end)],[0,a1,0],[0,a0,0]});
                    set(CONN_h.menus.m_preproc_00{17},'string',['Voxel-to-voxel connectivity (r) (dof=',num2str(CONN_h.menus.m_preproc.opt.dof),')']);
                else, conn_menu('updatehist',CONN_h.menus.m_preproc_00{16},[]);end
			end
			if model,
				t1=zeros(CONN_h.menus.m_preproc.Y.matdim.dim(1:2));
				t2=nan+zeros(CONN_h.menus.m_preproc.Y.matdim.dim(1:2));
				idx=find(CONN_h.menus.m_preproc.select{2});
				C=eye(size(CONN_h.menus.m_preproc.X,2)); 
				if ~isempty(idx), 
					C=pinv(CONN_h.menus.m_preproc.opt.X(:,[1,idx]))*CONN_h.menus.m_preproc.opt.X; C=C(2:end,:); % unique + shared variance
					%C=C(idx,:);  % unique variance
				end
				[h,F,p,dof,R]=conn_glmunivariate('evaluate',CONN_h.menus.m_preproc.opt,[],C); 
				t1(CONN_h.menus.m_preproc.y.idx)=R;
				t1=permute(t1,[2,1,3]);
				 %f=conn_hanning(5)/sum(conn_hanning(5)); t1=convn(convn(convn(t1,f,'same'),f','same'),shiftdim(f,-2),'same'); 
				t2(CONN_h.menus.m_preproc.y.idx)=abs(R);
				t2=permute(t2,[2,1,3]);
				 %f=conn_hanning(5)/sum(conn_hanning(5)); t2=convn(convn(convn(t2,f,'same'),f','same'),shiftdim(f,-2),'same'); 
				%t(CONN_h.menus.m_preproc.Y.voxels)=sqrt(sum(abs(CONN_h.menus.m_preproc.B(find(CONN_h.menus.m_preproc.select{2}),:)).^2,1))';
				conn_menu('update',CONN_h.menus.m_preproc_00{14},{CONN_h.menus.m_preproc.Xs,t1,t2},{CONN_h.menus.m_preproc.Y.matdim,CONN_h.menus.m_preproc.y.slice});
			end
			
		case 'gui_preproc_done',
			if isempty(CONN_x.filename), conn gui_setup_save; end
			conn_menumanager clf;
			axes('units','norm','position',[0,.935,1,.001]); image(shiftdim([1,1,4/6],-1)); axis off;
			conn_menumanager([CONN_h.menus.m0],'on',1);
			conn_process('preprocessing_gui');
			conn gui_setup_save;
			conn gui_preproc;
			conn gui_setup_save;
			
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%			
		case 'gui_analyses',
            CONN_x.gui=1;
			model=0;
            if ~isfield(CONN_x,'Analysis'), CONN_x.Analysis=1; end
            ianalysis=CONN_x.Analysis;
            if ~isfield(CONN_x.Analyses(ianalysis),'name'),CONN_x.Analyses(ianalysis).name='ANALYSIS_01'; end
            if nargin<2,
				if isempty(CONN_x.Analyses(ianalysis).variables.names), uiwait(errordlg('Data not prepared for analyses. Press "done" in the Preprocessing window','')); conn gui_setup; return; end
                conn_menumanager clf;
                axes('units','norm','position',[0,.935,1,.001]); image(shiftdim([1,1,4/6],-1)); axis off;
				conn_menumanager([CONN_h.menus.m_analyses_02,CONN_h.menus.m0],'on',1);

				conn_menu('frame',[.04,.13,.37,.67],'GLM CONNECTIVITY - DEFINE SOURCES');
				CONN_h.menus.m_analyses_00{1}=conn_menu('listbox',[.05,.25,.075,.5],'','','','conn(''gui_analyses'',1);');
				CONN_h.menus.m_analyses_00{2}=conn_menu('listbox',[.15,.25,.075,.5],'Sources','','','conn(''gui_analyses'',2);');
				CONN_h.menus.m_analyses_00{3}=conn_menu('image',[.25,.25,.14,.31],'');
				CONN_h.menus.m_analyses_00{4}=conn_menu('edit',[.25,.7,.14,.04],'derivatives order','','Include derivates up to n-th order (0 for no derivatives, 1 for first-order derivatives,...)','conn(''gui_analyses'',4);');
				%CONN_h.menus.m_analyses_00{5}=conn_menu('edit',[.05,.15,.175,.04],'band-pass filter (Hz)',num2str(CONN_x.Analyses(ianalysis).filter),'Band pass filter threshold (two values, low-pass and high-pass thresholds, respectively)','conn(''gui_analyses'',5);');
				CONN_h.menus.m_analyses_00{6}=conn_menu('edit',[.25,.6,.14,.04],'dimensions','','Number of dimensions','conn(''gui_analyses'',6);');
				connmeasures={'correlation (bivariate)','correlation (semipartial)','regression (bivariate)','regression (multivariate)'};
				CONN_h.menus.m_analyses_00{7}=conn_menu('popup',[.05,.15,.15,.04],'Connectivity measure',connmeasures,'Choose outcome measure of connectivity for second level analyses','conn(''gui_analyses'',7);');
				CONN_h.menus.m_analyses_00{8}=conn_menu('popup',[.20,.15,.15,.04],'Within-condition weights',{'none','hrf','hanning'},'Choose method for weighting samples within each condition block','conn(''gui_analyses'',8);');
				conn_menu('frame',[.49,.16,.47,.64],'PREVIEW RESULTS');
				CONN_h.menus.m_analyses_00{11}=conn_menu('listbox',[.5,.25,.075,.5],'Subject','','','conn(''gui_analyses'',11);');
				CONN_h.menus.m_analyses_00{12}=conn_menu('listbox',[.575,.25,.075,.5],'Conditions','','','conn(''gui_analyses'',12);');
				CONN_h.menus.m_analyses_00{13}=conn_menu('listbox',[.65,.25,.075,.5],'Sources','','','conn(''gui_analyses'',13);');
				CONN_h.menus.m_analyses_00{14}=conn_menu('image',[.75,.25,.17,.5],'connectivity');
				pos=[.75,.25,.17,.5];
				uicontrol('style','text','units','norm','position',[pos(1)+pos(3)-.170,pos(2)-2*.04,.070,.04],'string','threshold','backgroundcolor',[0,0,1/6],'foregroundcolor',[1,1,4/6]); 
				pos=[.75,.25,.17,.5];
				CONN_h.menus.m_analyses_00{15}=uicontrol('style','slider','units','norm','position',[pos(1)+pos(3)-0*.015,pos(2),.015,pos(4)],'callback','conn(''gui_analyses'',15);','backgroundcolor',[0,0,1/6]);
                txt=strvcat(CONN_x.Analyses(:).name,'new');
                CONN_h.menus.m_analyses_00{20}=uicontrol('units','norm','position',[.85,.95,.15,.05],'style','popupmenu','string',txt,'value',ianalysis,'backgroundcolor',[0,0,2/6],'foregroundcolor',[1,1,4/6],'callback','conn(''gui_analyses'',20);');

				if ~isfield(CONN_x.Analyses(ianalysis),'measure') || isempty(CONN_x.Analyses(ianalysis).measure), CONN_x.Analyses(ianalysis).measure=1; end
				set(CONN_h.menus.m_analyses_00{7},'value',CONN_x.Analyses(ianalysis).measure);
				if ~isfield(CONN_x.Analyses(ianalysis),'weight') || isempty(CONN_x.Analyses(ianalysis).weight), CONN_x.Analyses(ianalysis).weight=2; end
				set(CONN_h.menus.m_analyses_00{8},'value',CONN_x.Analyses(ianalysis).weight);
				set([CONN_h.menus.m_analyses_00{1},CONN_h.menus.m_analyses_00{2}],'max',2);
				set(CONN_h.menus.m_analyses_00{1},'string',CONN_x.Analyses(ianalysis).variables.names);
				set(CONN_h.menus.m_analyses_00{2},'string',CONN_x.Analyses(ianalysis).regressors.names);
				conn_menumanager(CONN_h.menus.m_analyses_01,'on',1);
				set([CONN_h.menus.m_analyses_00{1},CONN_h.menus.m_analyses_00{2}],'value',[]);
				set(CONN_h.menus.m_analyses_00{4},'enable','off');
				set(CONN_h.menus.m_analyses_00{6},'enable','off');
				set([CONN_h.menus.m_analyses_00{11},CONN_h.menus.m_analyses_00{12},CONN_h.menus.m_analyses_00{13}],'max',1);
				set(CONN_h.menus.m_analyses_00{11},'string',[repmat('Subject ',[CONN_x.Setup.nsubjects,1]),num2str((1:CONN_x.Setup.nsubjects)')]);
				nconditions=length(CONN_x.Setup.conditions.names)-1; 
				set(CONN_h.menus.m_analyses_00{12},'string',{CONN_x.Setup.conditions.names{1:end-1}},'value',min(nconditions,get(CONN_h.menus.m_analyses_00{12},'value')));
				set(CONN_h.menus.m_analyses_00{13},'string',{'TOTAL',CONN_x.Analyses(ianalysis).regressors.names{:}}); 
				%set(CONN_h.screen.hfig,'pointer','watch');
				[path,name,ext]=fileparts(CONN_x.filename);
% 				filepath=fullfile(path,name,'data');
                filepath=CONN_x.folders.preprocessing;
				filename=fullfile(filepath,['DATA_Subject',num2str(1,'%03d'),'_Condition',num2str(1,'%03d'),'.mat']);
				CONN_h.menus.m_analyses.Y=conn_vol(filename);
				CONN_h.menus.m_analyses.y.slice=ceil(CONN_h.menus.m_analyses.Y.matdim.dim(3)/2);
				[CONN_h.menus.m_analyses.y.data,CONN_h.menus.m_analyses.y.idx]=conn_get_slice(CONN_h.menus.m_analyses.Y,CONN_h.menus.m_analyses.y.slice);
				filename=fullfile(filepath,['ROI_Subject',num2str(1,'%03d'),'_Condition',num2str(1,'%03d'),'.mat']);
				CONN_h.menus.m_analyses.X1=load(filename);
                try,
                    CONN_h.menus.m_analyses.XS=spm_vol(deblank(CONN_x.Setup.structural{1}{1}));
                catch,
                    CONN_h.menus.m_analyses.XS=spm_vol(fullfile(fileparts(which('spm')),'canonical','single_subj_T1.nii'));
                end
				xyz=conn_convertcoordinates('idx2tal',prod(CONN_h.menus.m_analyses.Y.matdim.dim(1:2))*(CONN_h.menus.m_analyses.y.slice-1)+(1:prod(CONN_h.menus.m_analyses.Y.matdim.dim(1:2))),CONN_h.menus.m_analyses.Y.matdim.mat,CONN_h.menus.m_analyses.Y.matdim.dim);
				CONN_h.menus.m_analyses.Xs=spm_get_data(CONN_h.menus.m_analyses.XS(1),pinv(CONN_h.menus.m_analyses.XS(1).mat)*xyz'); 
				CONN_h.menus.m_analyses.Xs=permute(reshape(CONN_h.menus.m_analyses.Xs,CONN_h.menus.m_analyses.Y.matdim.dim(1:2)),[2,1,3]);
				set(CONN_h.menus.m_analyses_00{15},'min',1,'max',CONN_h.menus.m_analyses.Y.matdim.dim(3),'sliderstep',min(.5,[1,10]/(CONN_h.menus.m_analyses.Y.matdim.dim(3)-1)),'value',CONN_h.menus.m_analyses.y.slice);
				model=1;
			else,
				switch(varargin{2}),
					case 0,
						str=conn_menumanager(CONN_h.menus.m_analyses_01,'string');
						switch(str{1}),
							case '>',
								ncovariates=get(CONN_h.menus.m_analyses_00{1},'value'); 
								for ncovariate=ncovariates(:)',
									if isempty(strmatch(CONN_x.Analyses(ianalysis).variables.names{ncovariate},CONN_x.Analyses(ianalysis).regressors.names,'exact')), 
										CONN_x.Analyses(ianalysis).regressors.names{end+1}=CONN_x.Analyses(ianalysis).variables.names{ncovariate}; 
										CONN_x.Analyses(ianalysis).regressors.types{end+1}=CONN_x.Analyses(ianalysis).variables.types{ncovariate}; 
										CONN_x.Analyses(ianalysis).regressors.deriv{end+1}=CONN_x.Analyses(ianalysis).variables.deriv{ncovariate}; 
										CONN_x.Analyses(ianalysis).regressors.dimensions{end+1}=CONN_x.Analyses(ianalysis).variables.dimensions{ncovariate}; 
									end
								end
								set(CONN_h.menus.m_analyses_00{2},'string',CONN_x.Analyses(ianalysis).regressors.names); 
								set(CONN_h.menus.m_analyses_00{13},'string',{'TOTAL',CONN_x.Analyses(ianalysis).regressors.names{:}}); 
							case '<',
								ncovariates=get(CONN_h.menus.m_analyses_00{2},'value'); 
								idx=setdiff(1:length(CONN_x.Analyses(ianalysis).regressors.names),ncovariates);
								CONN_x.Analyses(ianalysis).regressors.names={CONN_x.Analyses(ianalysis).regressors.names{idx}};
								CONN_x.Analyses(ianalysis).regressors.types={CONN_x.Analyses(ianalysis).regressors.types{idx}};
								CONN_x.Analyses(ianalysis).regressors.deriv={CONN_x.Analyses(ianalysis).regressors.deriv{idx}};
								CONN_x.Analyses(ianalysis).regressors.dimensions={CONN_x.Analyses(ianalysis).regressors.dimensions{idx}};
								set(CONN_h.menus.m_analyses_00{2},'string',CONN_x.Analyses(ianalysis).regressors.names,'value',min(max(ncovariates),length(CONN_x.Analyses(ianalysis).regressors.names))); 
								set(CONN_h.menus.m_analyses_00{13},'string',{'TOTAL',CONN_x.Analyses(ianalysis).regressors.names{:}},'value',min(max(get(CONN_h.menus.m_analyses_00{13},'value')),length(CONN_x.Analyses(ianalysis).regressors.names)+1)); 
						end
						model=1;
					case 1,
						conn_menumanager(CONN_h.menus.m_analyses_01,'string',{'>'},'on',1);
						set(CONN_h.menus.m_analyses_00{2},'value',[]); 
						set([CONN_h.menus.m_analyses_00{4},CONN_h.menus.m_analyses_00{6}],'enable','off'); 
					case 2,
						conn_menumanager(CONN_h.menus.m_analyses_01,'string',{'<'},'on',1);
						set(CONN_h.menus.m_analyses_00{1},'value',[]); 
						set([CONN_h.menus.m_analyses_00{4},CONN_h.menus.m_analyses_00{6}],'enable','on','backgroundcolor','k','foregroundcolor','w'); 
					case 4,
						nregressors=get(CONN_h.menus.m_analyses_00{2},'value');
						value=str2num(get(CONN_h.menus.m_analyses_00{4},'string'));
						if length(value)==1, for nregressor=nregressors(:)', CONN_x.Analyses(ianalysis).regressors.deriv{nregressor}=value; end; end
						model=1;
					case 6,
						nregressors=get(CONN_h.menus.m_analyses_00{2},'value');
						value=str2num(get(CONN_h.menus.m_analyses_00{6},'string'));
						if length(value)==1, for nregressor=nregressors(:)', CONN_x.Analyses(ianalysis).regressors.dimensions{nregressor}(1)=max(1,min(CONN_x.Analyses(ianalysis).regressors.dimensions{nregressor}(2),value)); end; end
						model=1;
					case 7,
						CONN_x.Analyses(ianalysis).measure=get(CONN_h.menus.m_analyses_00{7},'value');
						model=2;
					case 8,
						CONN_x.Analyses(ianalysis).weight=get(CONN_h.menus.m_analyses_00{8},'value');
						model=1;
					case {11,12},
						nsubs=get(CONN_h.menus.m_analyses_00{11},'value');
						 nconditions=get(CONN_h.menus.m_analyses_00{12},'value');
						 %set(CONN_h.screen.hfig,'pointer','watch');
						 [path,name,ext]=fileparts(CONN_x.filename);
%                          filepath=fullfile(path,name,'data');
                         filepath=CONN_x.folders.preprocessing;
						 filename=fullfile(filepath,['DATA_Subject',num2str(nsubs,'%03d'),'_Condition',num2str(nconditions,'%03d'),'.mat']);
						 CONN_h.menus.m_analyses.Y=conn_vol(filename);
						 [CONN_h.menus.m_analyses.y.data,CONN_h.menus.m_analyses.y.idx]=conn_get_slice(CONN_h.menus.m_analyses.Y,CONN_h.menus.m_analyses.y.slice);
						 filename=fullfile(filepath,['ROI_Subject',num2str(nsubs,'%03d'),'_Condition',num2str(nconditions,'%03d'),'.mat']);
						 CONN_h.menus.m_analyses.X1=load(filename);
						 %filename=fullfile(filepath,['COV_Subject',num2str(nsubs,'%03d'),'_Session',num2str(nconditions,'%03d'),'.mat']);
						 %CONN_h.menus.m_analyses.X2=load(filename);
                         try,
                             CONN_h.menus.m_analyses.XS=spm_vol(deblank(CONN_x.Setup.structural{nsubs}{1}));
                         catch,
                             CONN_h.menus.m_analyses.XS=spm_vol(fullfile(fileparts(which('spm')),'canonical','single_subj_T1.nii'));
                         end
						 xyz=conn_convertcoordinates('idx2tal',prod(CONN_h.menus.m_analyses.Y.matdim.dim(1:2))*(CONN_h.menus.m_analyses.y.slice-1)+(1:prod(CONN_h.menus.m_analyses.Y.matdim.dim(1:2))),CONN_h.menus.m_analyses.Y.matdim.mat,CONN_h.menus.m_analyses.Y.matdim.dim);
						 CONN_h.menus.m_analyses.Xs=spm_get_data(CONN_h.menus.m_analyses.XS(1),pinv(CONN_h.menus.m_analyses.XS(1).mat)*xyz'); 
						 CONN_h.menus.m_analyses.Xs=permute(reshape(CONN_h.menus.m_analyses.Xs,CONN_h.menus.m_analyses.Y.matdim.dim(1:2)),[2,1,3]);
						 model=1;
					 case 13,
						 model=2;
					 case 15,
						 CONN_h.menus.m_analyses.y.slice=round(get(CONN_h.menus.m_analyses_00{15},'value'));
						 [CONN_h.menus.m_analyses.y.data,CONN_h.menus.m_analyses.y.idx]=conn_get_slice(CONN_h.menus.m_analyses.Y,CONN_h.menus.m_analyses.y.slice);
						 xyz=conn_convertcoordinates('idx2tal',prod(CONN_h.menus.m_analyses.Y.matdim.dim(1:2))*(CONN_h.menus.m_analyses.y.slice-1)+(1:prod(CONN_h.menus.m_analyses.Y.matdim.dim(1:2))),CONN_h.menus.m_analyses.Y.matdim.mat,CONN_h.menus.m_analyses.Y.matdim.dim);
						 CONN_h.menus.m_analyses.Xs=spm_get_data(CONN_h.menus.m_analyses.XS(1),pinv(CONN_h.menus.m_analyses.XS(1).mat)*xyz'); 
						 CONN_h.menus.m_analyses.Xs=permute(reshape(CONN_h.menus.m_analyses.Xs,CONN_h.menus.m_analyses.Y.matdim.dim(1:2)),[2,1,3]);
						 model=1;
					 case 20,
                         tianalysis=get(CONN_h.menus.m_analyses_00{20},'value');
                         analysisname=get(CONN_h.menus.m_analyses_00{20},'string');
                         if strcmp(deblank(analysisname(tianalysis,:)),'new'),
                             ok=0;
                             while ~ok,
                                 txt=inputdlg('New analysis name:','conn',1,{['ANALYSIS_',num2str(tianalysis,'%02d')]});
                                 if isempty(txt), break; end
                                 txt{1}(txt{1}==' ')='_';
                                 [ok,nill]=mkdir(CONN_x.folders.firstlevel,txt{1});
                                 if ~ok, errordlg('Analysis name must be a valid name for a folder','conn');end
                             end
                             if ok,
                                 CONN_x.Analyses(tianalysis)=CONN_x.Analyses(ianalysis);
                                 CONN_x.Analyses(tianalysis).name=txt{1};
                                 CONN_x.Analyses(tianalysis).sourcenames={};
                                 CONN_x.Analysis=tianalysis;
                                 conn gui_analyses;
                                 return;
                             else,
                                 set(CONN_h.menus.m_analyses_00{20},'value',ianalysis);
                             end
                         else,
                             CONN_x.Analysis=tianalysis;
                             conn gui_analyses;
                             return;
                         end
				end
			end
			nsubs=get(CONN_h.menus.m_analyses_00{11},'value');
			nregressors=get(CONN_h.menus.m_analyses_00{2},'value');
			nview=get(CONN_h.menus.m_analyses_00{13},'value')-1;
			[CONN_h.menus.m_analyses.X,CONN_h.menus.m_analyses.select]=conn_designmatrix(CONN_x.Analyses(ianalysis).regressors,CONN_h.menus.m_analyses.X1,[],{nregressors,nview});
			if isempty(nregressors), conn_menu('update',CONN_h.menus.m_analyses_00{3},[]); 
			else, conn_menu('update',CONN_h.menus.m_analyses_00{3},CONN_h.menus.m_analyses.X); end
			if ~isempty(nregressors)&&all(nregressors>0), 
				temp=cat(1,CONN_x.Analyses(ianalysis).regressors.deriv{nregressors});
				if length(temp)==1 || ~any(any(diff(temp,1,1))),set(CONN_h.menus.m_analyses_00{4},'string',num2str(CONN_x.Analyses(ianalysis).regressors.deriv{nregressors(1)})); 
				else, set(CONN_h.menus.m_analyses_00{4},'string','MULTIPLE VALUES'); end
				temp=cat(1,CONN_x.Analyses(ianalysis).regressors.dimensions{nregressors});
				if size(temp,1)==1 || ~any(any(diff(temp,1,1))),set(CONN_h.menus.m_analyses_00{6},'string',num2str(CONN_x.Analyses(ianalysis).regressors.dimensions{nregressors(1)}(1))); 
				else, set(CONN_h.menus.m_analyses_00{6},'string','MULTIPLE VALUES'); end
			end
			if size(CONN_h.menus.m_analyses.X,2)<=500,
				offon={'off','on'};
				for n1=1:size(CONN_h.menus.m_analyses.X,2),
					set(CONN_h.menus.m_analyses_00{3}.h4(n1),'visible',offon{1+CONN_h.menus.m_analyses.select{1}(n1)});
				end
				xtemp=CONN_h.menus.m_analyses.X(:,find(CONN_h.menus.m_analyses.select{1}));
				if ~isempty(xtemp), set(CONN_h.menus.m_analyses_00{3}.h3,'ylim',[min(min(xtemp))-1e-4,max(max(xtemp))+1e-4]); end
			end
			if model==1, 
				xf=CONN_h.menus.m_analyses.X;
				yf=CONN_h.menus.m_analyses.y.data;
				switch(CONN_x.Analyses(ianalysis).weight),
					case 1,
					case 2, xf=xf.*repmat(CONN_h.menus.m_analyses.X1.conditionweights{1},[1,size(xf,2)]);yf=yf.*repmat(CONN_h.menus.m_analyses.X1.conditionweights{1},[1,size(yf,2)]);
					case 3, xf=xf.*repmat(CONN_h.menus.m_analyses.X1.conditionweights{2},[1,size(xf,2)]);yf=yf.*repmat(CONN_h.menus.m_analyses.X1.conditionweights{2},[1,size(yf,2)]);
				end
				[CONN_h.menus.m_analyses.B,CONN_h.menus.m_analyses.opt]=conn_glmunivariate('estimate',xf,yf);
				%CONN_h.menus.m_analyses.B=pinv(CONN_h.menus.m_analyses.X)*CONN_h.menus.m_analyses.Y.data; 
			end
			if model,
				t1=zeros(CONN_h.menus.m_analyses.Y.matdim.dim(1:2));
				t2=0+zeros(CONN_h.menus.m_analyses.Y.matdim.dim(1:2));
				idx=find(CONN_h.menus.m_analyses.select{2});
				C=eye(size(CONN_h.menus.m_analyses.X,2)); 
				if ~isempty(idx), 
					switch(CONN_x.Analyses(ianalysis).measure),
						case {1,3}, %bivariate
							C=pinv(CONN_h.menus.m_analyses.opt.X(:,[1,idx]))*CONN_h.menus.m_analyses.opt.X; C=C(2:end,:); % unique + shared variance
						case {2,4}, %partial
							C=C(idx,:);  % unique variance
					end
				end
				[h,F,p,dof,R]=conn_glmunivariate('evaluate',CONN_h.menus.m_analyses.opt,[],C); 
				switch(CONN_x.Analyses(ianalysis).measure),
					case {1,2}, %correlation
						S1=sign(R).*sqrt(abs(R)); S2=abs(S1);
					case {3,4}, %regression
						S1=h; if size(S1,1)>1, S1=sqrt(sum(abs(S1).^2,1)); end; S2=abs(S1); 
					end
				t1(CONN_h.menus.m_analyses.y.idx)=S1; 
				t1=permute(t1,[2,1,3]);
				%f=conn_hanning(5)/sum(conn_hanning(5)); t1=convn(convn(convn(t1,f,'same'),f','same'),shiftdim(f,-2),'same'); 
				t2(CONN_h.menus.m_analyses.y.idx)=S2; 
				t2=permute(t2,[2,1,3]);
				%f=conn_hanning(5)/sum(conn_hanning(5));
				%t2=convn(convn(convn(t2,f,'same'),f','same'),shiftdim(f,-2),'same'); 
				%t(CONN_h.menus.m_analyses.Y.voxels)=sqrt(sum(abs(CONN_h.menus.m_analyses.B(find(CONN_h.menus.m_analyses.select{2}),:)).^2,1))';
				conn_menu('update',CONN_h.menus.m_analyses_00{14},{CONN_h.menus.m_analyses.Xs,t1,t2},{CONN_h.menus.m_analyses.Y.matdim,CONN_h.menus.m_analyses.y.slice});
			end
			
		case 'gui_analyses_done',
			if isempty(CONN_x.filename), conn gui_setup_save; end
			conn_menumanager clf;
			axes('units','norm','position',[0,.935,1,.001]); image(shiftdim([1,1,4/6],-1)); axis off;
			conn_menumanager([CONN_h.menus.m0],'on',1);
			conn_process('analyses_gui');
			conn gui_setup_save;
			conn gui_analyses;
			conn gui_setup_save;
			
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%			
        case 'gui_results',
            CONN_x.gui=1;
			model=0;modelroi=0;
            if ~isfield(CONN_x.Setup,'normalized'), CONN_x.Setup.normalized=1; end
            if ~isfield(CONN_x,'Analysis'), CONN_x.Analysis=1; end
            ianalysis=CONN_x.Analysis;
            if ~isfield(CONN_x.Analyses(ianalysis),'name'),CONN_x.Analyses(ianalysis).name='ANALYSIS_01'; end
            if nargin<2,
				if ~isfield(CONN_x.Analyses(ianalysis),'sources')||isempty(CONN_x.Analyses(ianalysis).sources), uiwait(errordlg('Data not prepared for results. Press "done" in the Analyses window','')); conn gui_setup; return; end
                conn_menumanager clf;
                axes('units','norm','position',[0,.935,1,.001]); image(shiftdim([1,1,4/6],-1)); axis off;
				tstate=conn_menumanager(CONN_h.menus.m0,'state'); tstate(:)=0;tstate(4)=1; conn_menumanager(CONN_h.menus.m0,'state',tstate); 
				%conn_menumanager([CONN_h.menus.m0],'on',1);
				conn_menumanager([CONN_h.menus.m_results_02,CONN_h.menus.m0,CONN_h.menus.m_results_03],'on',1);

				conn_menu('frame',[.09,.06,.82,.77],'FUNCTIONAL CONNECTIVITY RESULTS');
				CONN_h.menus.m_results_00{11}=conn_menu('listbox',[.10,.63,.175,.15],'Subject effects','','','conn(''gui_results'',11);');
				CONN_h.menus.m_results_00{12}=conn_menu('listbox',[.275,.63,.175,.15],'Conditions','','','conn(''gui_results'',12);');
				CONN_h.menus.m_results_00{13}=conn_menu('listbox',[.45,.63,.175,.15],'Sources','','','conn(''gui_results'',13);');
				connmeasures={'correlation (bivariate)','correlation (semipartial)','regression (bivariate)','regression (multivariate)'};
				pos=[.675,.15,.215,.63];
				[CONN_h.menus.m_results_00{14},CONN_h.menus.m_results_00{23}]=conn_menu('image2',pos,['Connectivity with source  (voxel-level)']);%,connmeasures{CONN_x.Results.measure}]);
				CONN_h.menus.m_results_00{24}=uicontrol('style','text','units','norm','position',[pos(1)+pos(3)-.195,pos(2)-2*.04,.095,.04],'string','p-value','backgroundcolor',[0,0,1/6],'foregroundcolor',[1,1,4/6]); 
				CONN_h.menus.m_results_00{15}=uicontrol('style','slider','units','norm','position',[pos(1)+pos(3)-0*.015,pos(2),.015,pos(4)],'callback','conn(''gui_results'',15);','backgroundcolor',[0,0,1/6]);
				[CONN_h.menus.m_results_00{18},CONN_h.menus.m_results_00{22}]=conn_menu('listbox2',[.10,.08,.525,.30],sprintf('%-36s%10s%10s%12s%12s','Targets','beta','T','p-unc','p-FDR'),'','','conn(''gui_results'',18);');
				uicontrol('style','text','units','norm','position',[.10,.42,.525,.04],'string','Connectivity with source (ROI-level)','backgroundcolor',[0,0,1/6],'foregroundcolor',[1,1,4/6],'fontweight','bold','fontname','arial','fontsize',9,'horizontalalignment','center'); 

				[path,name,ext]=fileparts(CONN_x.filename);
%                 filepath=fullfile(path,name,'data');
                filepathresults=fullfile(CONN_x.folders.firstlevel,CONN_x.Analyses(ianalysis).name);
				ncovariates=length(CONN_x.Setup.l2covariates.names)-1; 
				nconditions=length(CONN_x.Setup.conditions.names)-1; 
%                 filename=fullfile(filepathresults,['resultsROI_Condition',num2str(1,'%03d'),'.mat']);
%                 if isempty(dir(filename)),Ransw=questdlg('First-level ROI analyses have not completed. Perform now?','warning','Yes','No','Yes');if strcmp(Ransw,'Yes'), conn_process('analyses_ROI'); end;end
%                 load(filename,'names','xyz');
                CONN_h.menus.m_results.outcomenames=CONN_x.Analyses(ianalysis).sources;
                CONN_h.menus.m_results.outcomeiroi=[];for n1=1:length(CONN_h.menus.m_results.outcomenames),
                    [CONN_h.menus.m_results.outcomeiroi(n1),isnew]=conn_sourcenames(CONN_h.menus.m_results.outcomenames{n1},'-');
                end
				CONN_h.menus.m_results_00{16}=conn_menu('edit',[.10,.54,.175,.04],'Between-subjects contrast',num2str(1),'Enter contrast vector','conn(''gui_results'',16);');
				CONN_h.menus.m_results_00{17}=conn_menu('edit',[.45,.54,.175,.04],'Between-sources contrast',num2str(1),'Enter contrast vector','conn(''gui_results'',17);');
				CONN_h.menus.m_results_00{19}=conn_menu('edit',[.275,.54,.175,.04],'Between-conditions contrast',num2str(1),'Enter contrast vector','conn(''gui_results'',19);');
				set(CONN_h.menus.m_results_00{11},'string',{CONN_x.Setup.l2covariates.names{1:end-1}},'value',min(ncovariates,get(CONN_h.menus.m_results_00{11},'value')));
				set(CONN_h.menus.m_results_00{12},'string',{CONN_x.Setup.conditions.names{1:end-1}},'value',min(nconditions,get(CONN_h.menus.m_results_00{12},'value')));
				set(CONN_h.menus.m_results_00{13},'string',{CONN_h.menus.m_results.outcomenames{:}},'value',1); 
                modeltypes={'Random effects','Fixed effects'};
                modeltype=1+(CONN_x.Setup.nsubjects==1);
				CONN_h.menus.m_results_00{21}=conn_menu('popup',[.10,.44,.125,.04],'Between-subjects model',modeltypes,'Select model type','conn(''gui_results'',21);');
                set(CONN_h.menus.m_results_00{21},'value',modeltype);
				nconditions=1;nsources=1;
				%c=str2num(get(CONN_h.menus.m_results_00{17},'string'));
                txt=get(CONN_h.menus.m_results_00{17},'string'); value=str2num(txt); if isempty(value), try, value=evalin('base',txt); set(CONN_h.menus.m_results_00{17},'string',num2str(value)); catch, value=[]; end; end;c=value;
				CONN_h.menus.m_results.X=zeros(CONN_x.Setup.nsubjects,length(CONN_x.Setup.l2covariates.names)-1);
				for nsub=1:CONN_x.Setup.nsubjects,
					for ncovariate=1:length(CONN_x.Setup.l2covariates.names)-1;
						CONN_h.menus.m_results.X(nsub,ncovariate)=CONN_x.Setup.l2covariates.values{nsub}{ncovariate};
					end
				end
                txt=strvcat(CONN_x.Analyses(:).name);
                CONN_h.menus.m_results_00{20}=uicontrol('units','norm','position',[.85,.95,.15,.05],'style','popupmenu','string',txt,'value',ianalysis,'backgroundcolor',[0,0,2/6],'foregroundcolor',[1,1,4/6],'callback','conn(''gui_results'',20);');
	
                CONN_h.menus.m_results.y.data=0;
                if CONN_x.Setup.normalized,
                    for n1=1:length(nsources),
                        filename=fullfile(filepathresults,['resultsDATA_Condition',num2str(nconditions,'%03d'),'_Source',num2str(CONN_h.menus.m_results.outcomeiroi(nsources(n1)),'%03d'),'.mat']);
                        CONN_h.menus.m_results.Y=conn_vol(filename);
                        CONN_h.menus.m_results.y.slice=ceil(CONN_h.menus.m_results.Y.matdim.dim(3)/2);
                        [temp,CONN_h.menus.m_results.y.idx]=conn_get_slice(CONN_h.menus.m_results.Y,CONN_h.menus.m_results.y.slice);
                        CONN_h.menus.m_results.y.data=CONN_h.menus.m_results.y.data+temp*c(n1);
                    end
                    filename=fullfile(filepathresults,['seDATA_Condition',num2str(nconditions,'%03d'),'.mat']);
                    CONN_h.menus.m_results.SE=conn_vol(filename);
                    [temp,nill]=conn_get_slice(CONN_h.menus.m_results.SE,CONN_h.menus.m_results.y.slice);
                    CONN_h.menus.m_results.se.data=temp;
                    CONN_h.menus.m_results.se.dof=CONN_h.menus.m_results.SE.DOF;
                    %CONN_h.menus.m_results.XS=spm_vol(fullfile(fileparts(which('spm')),'canonical','avg152T1.nii'));
                    CONN_h.menus.m_results.XS=CONN_refs.canonical.V;
                    xyz=conn_convertcoordinates('idx2tal',prod(CONN_h.menus.m_results.Y.matdim.dim(1:2))*(CONN_h.menus.m_results.y.slice-1)+(1:prod(CONN_h.menus.m_results.Y.matdim.dim(1:2))),CONN_h.menus.m_results.Y.matdim.mat,CONN_h.menus.m_results.Y.matdim.dim);
                    CONN_h.menus.m_results.Xs=spm_get_data(CONN_h.menus.m_results.XS(1),pinv(CONN_h.menus.m_results.XS(1).mat)*xyz');
                    CONN_h.menus.m_results.Xs=permute(reshape(CONN_h.menus.m_results.Xs,CONN_h.menus.m_results.Y.matdim.dim(1:2)),[2,1,3]);
                    set(CONN_h.menus.m_results_00{15},'min',1,'max',CONN_h.menus.m_results.Y.matdim.dim(3),'sliderstep',min(.5,[1,10]/(CONN_h.menus.m_results.Y.matdim.dim(3)-1)),'value',CONN_h.menus.m_results.y.slice);
                else,
                    set([CONN_h.menus.m_results_00{24},CONN_h.menus.m_results_00{15},CONN_h.menus.m_results_00{23}],'visible','off');
                end
				set(CONN_h.menus.m_results_00{11},'max',2);set(CONN_h.menus.m_results_00{12},'max',2);set(CONN_h.menus.m_results_00{13},'max',2);
				model=1;
                modelroi=1;
			else,
				switch(varargin{2}),
					case 11,
						model=2;modelroi=1;
						ncovariates=get(CONN_h.menus.m_results_00{11},'value');
						if length(ncovariates)==1, set(CONN_h.menus.m_results_00{16},'string','1'); else, set(CONN_h.menus.m_results_00{16},'string',repmat(['1/',num2str(length(ncovariates)),' '],[1,length(ncovariates)])); end
					case {12,13,15,17,18,19}
                         modelroi=1;
						 nconditions=get(CONN_h.menus.m_results_00{12},'value');
						 nsources=get(CONN_h.menus.m_results_00{13},'value');
						 if varargin{2}==18,
                             ntarget=get(CONN_h.menus.m_results_00{18},'value');
                             ntarget=CONN_h.menus.m_results.roiresults.idx(ntarget);
                             if CONN_x.Setup.normalized,
                                 CONN_h.menus.m_results.y.slice=ceil(conn_convertcoordinates('tal2idx',CONN_h.menus.m_results.roiresults.xyz2{ntarget},CONN_h.menus.m_results.Y.matdim.mat,CONN_h.menus.m_results.Y.matdim.dim)/prod(CONN_h.menus.m_results.Y.matdim.dim(1:2)));
                                 set(CONN_h.menus.m_results_00{15},'value',CONN_h.menus.m_results.y.slice);
                             end
                         else, CONN_h.menus.m_results.y.slice=round(get(CONN_h.menus.m_results_00{15},'value')); end
						 if varargin{2}==12,if length(nconditions)==1, set(CONN_h.menus.m_results_00{19},'string','1'); else, set(CONN_h.menus.m_results_00{19},'string',repmat(['1/',num2str(length(nconditions)),' '],[1,length(nconditions)]));end; end
						 if varargin{2}==13,if length(nsources)==1, set(CONN_h.menus.m_results_00{17},'string','1'); else, set(CONN_h.menus.m_results_00{17},'string',repmat(['1/',num2str(length(nsources)),' '],[1,length(nsources)]));end; end
%  						 [path,name,ext]=fileparts(CONN_x.filename);
%                        filepath=fullfile(path,name,'data');
                         filepathresults=fullfile(CONN_x.folders.firstlevel,CONN_x.Analyses(ianalysis).name);
						 %c=str2num(get(CONN_h.menus.m_results_00{17},'string'));
						 %d=str2num(get(CONN_h.menus.m_results_00{19},'string'));
                         txt=get(CONN_h.menus.m_results_00{17},'string'); value=str2num(txt); if isempty(value), try, value=evalin('base',txt); set(CONN_h.menus.m_results_00{17},'string',num2str(value)); catch, value=[]; end; end;c=value;
                         txt=get(CONN_h.menus.m_results_00{19},'string'); value=str2num(txt); if isempty(value), try, value=evalin('base',txt); set(CONN_h.menus.m_results_00{19},'string',num2str(value)); catch, value=[]; end; end;d=value;
                         if CONN_x.Setup.normalized,
                             CONN_h.menus.m_results.y.data=0;
                             CONN_h.menus.m_results.se.data=0;
                             CONN_h.menus.m_results.se.dof=0;
                             for ncondition=1:length(nconditions),
                                 for nsource=1:length(nsources),
                                     filename=fullfile(filepathresults,['resultsDATA_Condition',num2str(nconditions(ncondition),'%03d'),'_Source',num2str(CONN_h.menus.m_results.outcomeiroi(nsources(nsource)),'%03d'),'.mat']);
                                     CONN_h.menus.m_results.Y=conn_vol(filename);
                                     [temp,CONN_h.menus.m_results.y.idx]=conn_get_slice(CONN_h.menus.m_results.Y,CONN_h.menus.m_results.y.slice);
                                     CONN_h.menus.m_results.y.data=CONN_h.menus.m_results.y.data+temp*c(nsource)*d(ncondition);
                                 end;
                                 filename=fullfile(filepathresults,['seDATA_Condition',num2str(nconditions(ncondition),'%03d'),'.mat']);
                                 CONN_h.menus.m_results.SE=conn_vol(filename);
                                 [temp,nill]=conn_get_slice(CONN_h.menus.m_results.SE,CONN_h.menus.m_results.y.slice);
                                 CONN_h.menus.m_results.se.data=CONN_h.menus.m_results.se.data+sum(c.^2)*(d(ncondition)*temp).^2;
                                 CONN_h.menus.m_results.se.dof=CONN_h.menus.m_results.se.dof+CONN_h.menus.m_results.SE.DOF;
                             end
                             CONN_h.menus.m_results.se.data=sqrt(CONN_h.menus.m_results.se.data);
                             if varargin{2}==15||varargin{2}==18,
                                 xyz=conn_convertcoordinates('idx2tal',prod(CONN_h.menus.m_results.Y.matdim.dim(1:2))*(CONN_h.menus.m_results.y.slice-1)+(1:prod(CONN_h.menus.m_results.Y.matdim.dim(1:2))),CONN_h.menus.m_results.Y.matdim.mat,CONN_h.menus.m_results.Y.matdim.dim);
                                 CONN_h.menus.m_results.Xs=spm_get_data(CONN_h.menus.m_results.XS(1),pinv(CONN_h.menus.m_results.XS(1).mat)*xyz');
                                 CONN_h.menus.m_results.Xs=permute(reshape(CONN_h.menus.m_results.Xs,CONN_h.menus.m_results.Y.matdim.dim(1:2)),[2,1,3]);
                                 modelroi=0;
                             end
                         end
						 model=1;
					case 16,
						model=2;modelroi=1;
                    case 20,
                        tianalysis=get(CONN_h.menus.m_results_00{20},'value');
                        CONN_x.Analysis=tianalysis;
                        conn gui_results;
                        return;
                    case 21,
						model=1;modelroi=1;
				end
			end
			ncovariates=get(CONN_h.menus.m_results_00{11},'value');
			nconditions=get(CONN_h.menus.m_results_00{12},'value');
			nsources=get(CONN_h.menus.m_results_00{13},'value');
			modeltype=get(CONN_h.menus.m_results_00{21},'value');

			if model==1&&CONN_x.Setup.normalized, 
				xf=CONN_h.menus.m_results.X;
				yf=CONN_h.menus.m_results.y.data;
                nsubjects=find(any(xf~=0,2));
                xf=xf(nsubjects,:);
                yf=yf(nsubjects,:);
				if modeltype==1, [CONN_h.menus.m_results.B,CONN_h.menus.m_results.opt]=conn_glmunivariate('estimate',xf,yf);
                else, [CONN_h.menus.m_results.B,CONN_h.menus.m_results.opt]=conn_glmunivariate('estimatefixed',xf,yf,CONN_h.menus.m_results.se); end
				set(CONN_h.menus.m_results_00{22},'string',sprintf('%-36s%10s%10s%12s%12s','Targets','beta',['T(',num2str(CONN_h.menus.m_results.opt.dof(1)),')'],'p-unc','p-FDR'));
                CONN_h.menus.m_results.ncovariates=1:size(xf,2);
                CONN_x.Results.xX.X=xf;
			end
			if model,
				idx=ncovariates;
				if ~isempty(idx), 
					txt=get(CONN_h.menus.m_results_00{16},'string'); value=str2num(txt); if isempty(value), try, value=evalin('base',txt); set(CONN_h.menus.m_results_00{16},'string',num2str(value)); catch, value=[]; end; end;C=value; 
        			CONN_x.Results.xX.nsubjecteffects=ncovariates;
        			CONN_x.Results.xX.nconditions=nconditions;
                    CONN_x.Results.xX.nsources=nsources;
					txt=get(CONN_h.menus.m_results_00{16},'string'); value=str2num(txt); if isempty(value), try, value=evalin('base',txt); set(CONN_h.menus.m_results_00{16},'string',num2str(value)); catch, value=[]; end; end;
                    CONN_x.Results.xX.csubjecteffects=value;
					txt=get(CONN_h.menus.m_results_00{17},'string'); value=str2num(txt); if isempty(value), try, value=evalin('base',txt); set(CONN_h.menus.m_results_00{17},'string',num2str(value)); catch, value=[]; end; end;
                    CONN_x.Results.xX.csources=value;
					txt=get(CONN_h.menus.m_results_00{19},'string'); value=str2num(txt); if isempty(value), try, value=evalin('base',txt); set(CONN_h.menus.m_results_00{19},'string',num2str(value)); catch, value=[]; end; end;
                    CONN_x.Results.xX.cconditions=value;
                    CONN_x.Results.xX.modeltype=modeltype;
                    if CONN_x.Setup.normalized
                        t1=zeros(CONN_h.menus.m_results.Y.matdim.dim(1:2));
                        t2=nan+zeros(CONN_h.menus.m_results.Y.matdim.dim(1:2));
                        if length(idx)~=length(CONN_h.menus.m_results.ncovariates) || any(idx~=CONN_h.menus.m_results.ncovariates),
                            xf=CONN_h.menus.m_results.X(:,idx);
                            yf=CONN_h.menus.m_results.y.data;
                            se=CONN_h.menus.m_results.se;
                            nsubjects=find(any(xf~=0,2));
                            xf=xf(nsubjects,:);
                            yf=yf(nsubjects,:);
                            se.data=se.data(nsubjects,:);
                            se.dof=se.dof(nsubjects);
                            if modeltype==1, [CONN_h.menus.m_results.B,CONN_h.menus.m_results.opt]=conn_glmunivariate('estimate',xf,yf);
                            else, [CONN_h.menus.m_results.B,CONN_h.menus.m_results.opt]=conn_glmunivariate('estimatefixed',xf,yf,se); end
                            %[CONN_h.menus.m_results.B,CONN_h.menus.m_results.opt]=conn_glmunivariate('estimate',xf,yf);
                            set(CONN_h.menus.m_results_00{22},'string',sprintf('%-36s%10s%10s%12s%12s','Targets','beta',['T(',num2str(CONN_h.menus.m_results.opt.dof(1)),')'],'p-unc','p-FDR'));
                            CONN_h.menus.m_results.ncovariates=idx;
                            CONN_x.Results.xX.X=xf;
                        end
                        %C=eye(size(CONN_h.menus.m_results.X,2));
                        %C=C(idx,:);  % unique variance
                        %c=str2num(get(CONN_h.menus.m_results_00{16},'string'));
                        %if ~isempty(c)&&length(c)==length(idx), C=c(:)'*C; end
                        %C=str2num(get(CONN_h.menus.m_results_00{16},'string'));
                        %CONN_x.Results.xX.C=C;
                        %CONN_x.Results.xX.name={CONN_x.Setup.l2covariates.names{ncovariates}};
                        %CONN_x.Results.xX.csubjecteffects=str2num(get(CONN_h.menus.m_results_00{16},'string'));
                        %CONN_x.Results.xX.csources=str2num(get(CONN_h.menus.m_results_00{17},'string'));
                        %CONN_x.Results.xX.cconditions=str2num(get(CONN_h.menus.m_results_00{19},'string'));
                        if modeltype==1, [h,F,p,dof,R]=conn_glmunivariate('evaluate',CONN_h.menus.m_results.opt,[],C);
                        else, [h,F,p,dof,R]=conn_glmunivariate('evaluatefixed',CONN_h.menus.m_results.opt,[],C); end
                        switch(CONN_x.Analyses(ianalysis).measure),
                            case {1,2}, % correlation
                                S1=tanh(h); S2=2*min(p,1-p);
                            case {3,4}, % regression
                                S1=h; S2=2*min(p,1-p);
                        end
                        t1(CONN_h.menus.m_results.y.idx)=S1;
                        t1=permute(t1,[2,1,3]);
                        t2(CONN_h.menus.m_results.y.idx)=S2;
                        t2=permute(t2,[2,1,3]);
                        conn_menu('update',CONN_h.menus.m_results_00{14},{CONN_h.menus.m_results.Xs,t1,-t2},{CONN_h.menus.m_results.Y.matdim,CONN_h.menus.m_results.y.slice})
                    end
				end
			end
            if modelroi,
                CONN_h.menus.m_results.roiresults=conn_process('results_ROI',CONN_x.Results.xX.nsources,CONN_x.Results.xX.csources);
                CONN_h.menus.m_results.roiresults.p=2*min(CONN_h.menus.m_results.roiresults.p,1-CONN_h.menus.m_results.roiresults.p);
                P=conn_fdr(CONN_h.menus.m_results.roiresults.p,2);
                [nill,CONN_h.menus.m_results.roiresults.idx]=sort(P-1e-10*abs(CONN_h.menus.m_results.roiresults.F));
                txt=[];for n1=1:numel(CONN_h.menus.m_results.roiresults.names2),
                    n2=CONN_h.menus.m_results.roiresults.idx(n1);
                    tmp=CONN_h.menus.m_results.roiresults.names2{n2};if length(tmp)>36,tmp=[tmp(1:31),'*',tmp(end-3:end)]; end;
                    txt=strvcat(txt,...
                        [[sprintf('%-36s',tmp)],...
                        [sprintf('%10.2f',CONN_h.menus.m_results.roiresults.h(n2))],...
                        [sprintf('%10.2f',CONN_h.menus.m_results.roiresults.F(n2))],...
                        [sprintf('%12f',CONN_h.menus.m_results.roiresults.p(n2))],...
                        [sprintf('%12f',P(n2))]]); end;
                set(CONN_h.menus.m_results_00{18},'string',txt,'fontname','monospaced','fontsize',8);
            end
		
        case 'gui_results_roiview',
            conn_displayroi('init',CONN_x.Results.xX.nsources);
            return;
            
        case 'gui_results_wholebrain',
            if ~CONN_x.Setup.normalized, warndlg('Second-level voxel-level analyses not available for un-normalized data'); return; end
            CONN_x.Results.foldername='';
            conn_process('results_voxel','readsingle');
            set(CONN_h.screen.hfig,'pointer','arrow')
            return;
            
		case 'gui_results_done',
			if isempty(CONN_x.filename), conn gui_setup_save; end
			%conn_menumanager clf;
			%axes('units','norm','position',[0,.935,1,.001]); image(shiftdim([1,1,4/6],-1)); axis off;
			%conn_menumanager([CONN_h.menus.m0],'on',1);
			%conn gui_setup_save;
            CONN_x.gui=0;
            CONN_x.Results.foldername='';
            if ~CONN_x.Setup.normalized, 
                conn_process('results_roi');
            else,
                conn_process('results');
            end
            CONN_x.gui=1;
			conn gui_setup_save;
            set(CONN_h.screen.hfig,'pointer','arrow')
            return;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%			

	end
end
drawnow;


function [h,h2]=conn_menu(type,position,title,string,tooltipstring,callback);

nmax=500;
if nargin<2 || isempty(position), position=[0,0,0,0]; end
if nargin<3, title='';end
if nargin<4, string='';end
if nargin<5, tooltipstring='';end
if nargin<6, callback='';end
if ~ischar(type), [type,position,title]=deal(title,get(type,'userdata'),get(type,'value')); end
switch(lower(type)),
	case 'edit',
		if ~isempty(title), h2=uicontrol('style','text','units','norm','position',position+[0,.04,0,0],'string',title,'foregroundcolor',[1,1,4/6],'backgroundcolor',[0,0,1/6],'fontweight','bold','fontname','arial','fontsize',9,'horizontalalignment','left'); end
		h=uicontrol('style','edit','units','norm','position',position,'foregroundcolor','w','backgroundcolor','k','string',string,'tooltipstring',tooltipstring,'callback',callback,'fontweight','bold');
	case 'listbox',
		if ~isempty(title), h2=uicontrol('style','text','units','norm','position',(position+[0,position(4),0,0]).*[1,1,1,0]+[0,0,0,.04],'string',title,'foregroundcolor',[1,1,4/6],'backgroundcolor',[0,0,1/6],'fontweight','bold','fontname','arial','fontsize',9,'horizontalalignment','center'); end
		h=uicontrol('style','listbox','units','norm','position',position,'foregroundcolor','w','backgroundcolor','k','string',string,'max',1,'value',1,'tooltipstring',tooltipstring,'callback',callback);
	case 'listbox2',
		if ~isempty(title), h2=uicontrol('style','text','units','norm','position',(position+[0,position(4),0,0]).*[1,1,1,0]+[0,0,0,.04],'string',title,'foregroundcolor',[1,1,4/6],'backgroundcolor',[0,0,1/6],'fontname','monospaced','fontsize',8,'horizontalalignment','left'); end
		h=uicontrol('style','listbox','units','norm','position',position,'foregroundcolor','w','backgroundcolor','k','string',string,'max',1,'value',1,'tooltipstring',tooltipstring,'callback',callback);
	case 'text',	
		if ~isempty(title), h2=uicontrol('style','text','units','norm','position',(position+[0,position(4),0,0]).*[1,1,1,0]+[0,0,0,.04],'string',title,'foregroundcolor',[1,1,4/6],'backgroundcolor',[0,0,1/6],'fontweight','bold','fontname','arial','fontsize',9,'horizontalalignment','center'); end
		h=uicontrol('style','text','units','norm','position',position,'foregroundcolor','w','backgroundcolor',[0,0,1/6],'string',string,'tooltipstring',tooltipstring,'max',2,'horizontalalignment','center');
	case 'popup',
		if ~isempty(title), h2=uicontrol('style','text','units','norm','position',(position+[0,position(4),0,0]).*[1,1,1,0]+[0,0,0,.04],'string',title,'foregroundcolor',[1,1,4/6],'backgroundcolor',[0,0,1/6],'fontweight','bold','fontname','arial','fontsize',9,'horizontalalignment','left'); end
		h=uicontrol('style','popupmenu','units','norm','position',position,'foregroundcolor','w','backgroundcolor','k','string',string,'value',1,'tooltipstring',tooltipstring,'callback',callback);
	case 'checkbox',
		if ~isempty(title), h2=uicontrol('style','text','units','norm','position',(position+[position(3),0,0,0]).*[1,1,0,1]+[0,0,.15,0],'string',title,'foregroundcolor',[1,1,4/6],'backgroundcolor',[0,0,1/6],'fontweight','bold','fontname','arial','fontsize',9,'horizontalalignment','left'); end
		h=uicontrol('style','checkbox','units','norm','position',position,'foregroundcolor','w','backgroundcolor',[0,0,1/6],'string',string,'value',1,'tooltipstring',tooltipstring,'callback',callback);
	case 'image',
		if ~isempty(title), h2=uicontrol('style','text','units','norm','position',(position+[0,position(4),0,0]).*[1,1,1,0]+[0,0,0,.04],'string',title,'foregroundcolor',[1,1,4/6],'backgroundcolor',[0,0,1/6],'fontweight','bold','fontname','arial','fontsize',9,'horizontalalignment','center'); end
		data=struct('n',[],'thr',.5,'cscale',1,'x0',[],'x1',[],'p',0); 
		h.h1=axes('units','norm','position',position); 
		h.h2=image(shiftdim([0,0,1/6],-1)); 
		h.h3=axes('units','norm','position',position+[.1*position(3),0,-.1*position(3),0]); 
		h.h4=plot(0,zeros(1,nmax))';
		h.h5=uicontrol('style','slider','units','norm','position',[position(1)+position(3)-0*.015,position(2),.015,position(4)],'callback',{@conn_menu,'updateslider1'},'backgroundcolor',[0,0,1/6]);
		h.h6=uicontrol('style','slider','units','norm','position',[position(1),position(2)-.03,position(3),.03],'min',0,'max',1,'callback',{@conn_menu,'updateslider2'},'backgroundcolor',[0,0,1/6],'value',data.thr);
		%h.h7=axes('position',[position(1)+0*.015,position(2)-.06,position(3)-0*.03,.02],'color',[0,0,1/6]); 
		h.h7=axes('position',[position(1)-.01,position(2),.01,position(4)],'color',[0,0,1/6]); 
		h.h8=image((1:128)'); 
		h.h9=uicontrol('style','edit','units','norm','position',[position(1)-.015,position(2)+position(4),.02,.04],'callback',{@conn_menu,'updatecscale'},'backgroundcolor',[0,0,1/6],'string',num2str(data.cscale)); 
		h.h10=uicontrol('style','edit','units','norm','position',[position(1)+position(3)-.1,position(2)-2*.04,.1,.04],'callback',{@conn_menu,'updatethr'},'backgroundcolor',[0,0,1/6],'foregroundcolor',[1,1,4/6],'string',num2str(data.thr)); 
		set(h.h1,'color',[0,0,1/6],'xtick',[],'ytick',[],'xcolor',[0,0,1/6],'ycolor',[0,0,1/6]); 
		set(h.h3,'color',[0,0,1/6],'xtick',[],'xcolor',[1,1,4/6],'ycolor',[1,1,4/6],'visible','off'); 
		set(h.h7,'color',[0,0,1/6],'xtick',[],'ytick',[64.5],'yticklabel',{'0'},'xcolor',[1,1,4/6],'ycolor',[1,1,4/6],'visible','off','ydir','normal'); 
		set(h.h9,'backgroundcolor',[0,0,1/6],'foregroundcolor',[1,1,4/6],'visible','off'); 
		set([h.h4,h.h5,h.h6,h.h7,h.h8,h.h9,h.h10],'visible','off'); 
		set([h.h5,h.h6,h.h9,h.h10],'userdata',h);
		set([h.h2],'userdata',data);
	case 'image2',
		if ~isempty(title), h2=uicontrol('style','text','units','norm','position',(position+[0,position(4),0,0]).*[1,1,1,0]+[0,0,0,.04],'string',title,'foregroundcolor',[1,1,4/6],'backgroundcolor',[0,0,1/6],'fontweight','bold','fontname','arial','fontsize',9,'horizontalalignment','center'); end
		data=struct('n',[],'thr',.001,'cscale',1,'x0',[],'x1',[],'p',0); 
		h.h1=axes('units','norm','position',position); 
		h.h2=image(shiftdim([0,0,1/6],-1)); 
		h.h3=axes('units','norm','position',position+[.1*position(3),0,-.1*position(3),0]); 
		h.h4=plot(0,zeros(1,nmax))';
		h.h5=uicontrol('style','slider','units','norm','position',[position(1)+position(3)-0*.015,position(2),.015,position(4)],'callback',{@conn_menu,'updateslider1'},'backgroundcolor',[0,0,1/6]);
		h.h6=uicontrol('style','slider','units','norm','position',[position(1),position(2)-.03,position(3),.03],'min',0,'max',1,'callback',{@conn_menu,'updateslider2'},'backgroundcolor',[0,0,1/6],'value',data.thr);
		%h.h7=axes('position',[position(1)+0*.015,position(2)-.06,position(3)-0*.03,.02],'color',[0,0,1/6]); 
		h.h7=axes('position',[position(1)-.01,position(2),.01,position(4)],'color',[0,0,1/6]); 
		h.h8=image((1:128)'); 
		h.h9=uicontrol('style','edit','units','norm','position',[position(1)-.015,position(2)+position(4),.02,.04],'callback',{@conn_menu,'updatecscale'},'backgroundcolor',[0,0,1/6],'string',num2str(data.cscale)); 
		h.h10=uicontrol('style','edit','units','norm','position',[position(1)+position(3)-.1,position(2)-2*.04,.1,.04],'callback',{@conn_menu,'updatethr'},'backgroundcolor',[0,0,1/6],'foregroundcolor',[1,1,4/6],'string',num2str(data.thr)); 
		set(h.h1,'color',[0,0,1/6],'xtick',[],'ytick',[],'xcolor',[0,0,1/6],'ycolor',[0,0,1/6]); 
		set(h.h3,'color',[0,0,1/6],'xtick',[],'xcolor',[1,1,4/6],'ycolor',[1,1,4/6],'visible','off'); 
		set(h.h7,'color',[0,0,1/6],'xtick',[],'ytick',[64.5],'yticklabel',{'0'},'xcolor',[1,1,4/6],'ycolor',[1,1,4/6],'visible','off','ydir','normal'); 
		set(h.h9,'backgroundcolor',[0,0,1/6],'foregroundcolor',[1,1,4/6],'visible','off'); 
		set([h.h4,h.h5,h.h6,h.h7,h.h8,h.h9,h.h10],'visible','off'); 
		set([h.h5,h.h6,h.h9,h.h10],'userdata',h);
		set([h.h2],'userdata',data);
	case 'hist',
		if ~isempty(title), h2=uicontrol('style','text','units','norm','position',(position+[0,position(4),0,0]).*[1,1,1,0]+[0,0,0,.04],'string',title,'foregroundcolor',[1,1,4/6],'backgroundcolor',[0,0,1/6],'fontweight','bold','fontname','arial','fontsize',9,'horizontalalignment','center'); end
		h.h1=axes('units','norm','position',position); 
		h.h3=patch(0,0,'k'); 
		h.h4=patch(0,0,'k'); 
		h.h5=patch(0,0,'k'); 
		h.h6=text(0,0,'original'); 
		h.h7=text(0,0,'without confounds'); 
		hold on; h.h2=plot([0,0],[0,0],'k-'); hold off;
		set(h.h1,'color',[0,0,1/6],'ytick',[],'xcolor',[1,1,4/6],'ycolor',[0,0,1/6],'visible','off'); 
        set([h.h1,h.h2,h.h3,h.h4,h.h5,h.h6,h.h7],'visible','off');
	case 'updatehist',
		if isempty(title), 
			set([position.h1,position.h2,position.h3,position.h4,position.h5,position.h6,position.h7],'visible','off'); 
		else,
            set(position.h3,'xdata',title{1},'ydata',title{2},'facecolor',.5*[0,0,1],'facealpha',1,'edgecolor','k');
            set(position.h4,'xdata',title{1},'ydata',title{3},'facecolor',.15*[1,1,1],'facealpha',1,'edgecolor','none');
            set(position.h5,'xdata',title{1},'ydata',min(title{2},title{3}),'facecolor',[.2,.2,.4],'facealpha',1,'edgecolor','none');
            set(position.h2,'xdata',[0,0],'ydata',[0,max(max(title{2}),max(title{3}))*1.1],'color','w');
            axis(position.h1,'tight');
            [nill,idxtemp]=max(title{3});set(position.h6,'position',[title{1}(idxtemp),title{3}(idxtemp),0],'color',.25*[1,1,1],'horizontalalignment','left');
            [nill,idxtemp]=max(title{2});set(position.h7,'position',[title{1}(idxtemp),title{2}(idxtemp),0],'color',.6*[0,0,1],'horizontalalignment','right');
            set([position.h1,position.h2,position.h3,position.h4,position.h5,position.h6,position.h7],'visible','on');
        end
	case {'update','updateplot','updateimage'},
		if isempty(title), 
			set(position.h2,'cdata',shiftdim([0,0,1/6],-1)); set(position.h1,'xlim',[.5,1.5],'ylim',[.5,1.5],'xtick',[],'ytick',[]); axis(position.h1,'equal','tight');
			set([position.h1,position.h2],'visible','on'); 
			set([position.h3,position.h4,position.h5,position.h6,position.h7,position.h9,position.h10],'visible','off'); 
		else,
			if strcmp(lower(type),'updateimage')||isstruct(title)||iscell(title)||size(title,2)>nmax||size(title,3)>1, 
				data=get(position.h2,'userdata');
				if iscell(title), 
					title0=title{2}; titleTHR=title{end}; title=title{1}; 
					if any(titleTHR(:)<0), data.p=1; titleTHR=-titleTHR; else, data.p=0; end
				else, title0=[]; data.p=0; end; % title: structural; title0: activation; titleTHR: p-value (nan for missing data)
				if isstruct(title), 
					if length(title)>1, title=cat(2,permute(spm_read_vols(title(end)),[2,1,3]),permute(spm_read_vols(title(1)),[2,1,3])); 
					else, title=permute(spm_read_vols(title),[2,1,3]); end
					%title=permute(spm_read_vols(title),[2,1,3,4]); 
				end
				if size(title,4)>1, title=cat(2,title(:,:,:,end),title(:,:,:,1)); end
				if isempty(data.n), data.n=ceil(size(title,3)/2); end
				data.n=max(1,min(size(title,3),data.n));
				data.x1=round(1+127*(title-min(title(:)))/max(max(title(:))-min(title(:)),eps)); 
				if ~isempty(title0),
					data.x0=title0; %max(-1,min(1,title0)); % x1: structural; x0: activation; xTHR: p-value
					data.xTHR=titleTHR;%max(0,min(1,titleTHR));
					t0=(129:256)'; idxt0=find(~isnan(titleTHR)); 
					if isempty(idxt0), idxt0=[1,1]; %ceil(128*max(eps,max(title0(:))))];
					else, idxt0=ceil(128*max(eps,min(1,.5+.5*max(-1,min(1, [min(title0(idxt0)),max(title0(:))]/data.cscale ))))); end
					t0(1:min(idxt0)-1)=1;t0(max(idxt0)+1:end)=1;%t0(idxt0)=128;%t0(max(1,idxt0-1))=1;t0(min(128,idxt0+1))=1;
					set(position.h8,'cdata',t0);
					set([position.h6,position.h7,position.h8,position.h9,position.h10],'visible','on');
				else, 
					data.x0=[]; 
					set([position.h6,position.h7,position.h8,position.h9,position.h10],'visible','off');
				end
				if size(data.x1,3)>1, 
					set(position.h5,'min',1,'max',size(data.x1,3),'sliderstep',min(.5,[1,10]/(size(data.x1,3)-1)),'value',data.n,'visible','on');
				else, set(position.h5,'visible','off'); end
				title=fliplr(flipud(data.x1(:,:,data.n))); 
				if ~isempty(data.x0), 
					title0=fliplr(flipud(data.x0(:,:,data.n))); %if all(size(title)==2*size(title0)-1), title0=interp2(title0,'nearest'); end
					titleTHR=fliplr(flipud(data.xTHR(:,:,data.n))); %if all(size(title)==2*size(titleTHR)-1), titleTHR=interp2(titleTHR,'nearest'); end
					if data.p, idx=find(titleTHR<=data.thr); else, idx=find(titleTHR>=data.thr); end
					title(idx)=round(192.5+63.5*max(-1,min(1, title0(idx)/data.cscale ))); 
				end
				set(position.h2,'cdata',title);set(position.h1,'xlim',[.5,size(title,2)+.5],'ylim',[.5,size(title,1)+.5+eps],'xtick',[],'ytick',[]); 
				axis(position.h1,'equal','tight'); 

				set([position.h1,position.h2],'visible','on'); set([position.h3,position.h4],'visible','off'); 
                if ~isempty(string),
                    data.buttondown=struct('matdim',string{1},'z',string{2},'h1',position.h1);
                    set(position.h2,'buttondownfcn',@conn_menubuttondownfcn,'userdata',data);
                else,
                    set(position.h2,'userdata',data);
                end
			else, 
				if isstruct(title), title=permute(spm_read_vols(title),[2,1,3,4]); end
				for n1=1:size(title,2),set(position.h4(n1),'xdata',(1:size(title,1))','ydata',title(:,n1));end
				for n1=size(title,2)+1:nmax,set(position.h4(n1),'xdata',(1:size(title,1))','ydata',zeros(size(title,1),1));end
				minmaxt=[min(title(:)),max(title(:))]; set(position.h3,'xlim',[0,size(title,1)+1],'ylim',minmaxt*[1.1,-.1;-.1,1.1]+[-1e-10,1e-10]); 
				set([position.h3,position.h4],'visible','on'); set([position.h1,position.h2,position.h5,position.h6,position.h7,position.h9,position.h10],'visible','off'); 
			end
		end
	case 'updateslider1',
		data=get(position.h2,'userdata');
		data.n=max(1,min(size(data.x1,3), round(title)));
		title=fliplr(flipud(data.x1(:,:,data.n))); 
		if ~isempty(data.x0), 
			title0=fliplr(flipud(data.x0(:,:,data.n))); %if all(size(title)==2*size(title0)-1), title0=interp2(title0,'nearest'); end
			titleTHR=fliplr(flipud(data.xTHR(:,:,data.n))); %if all(size(title)==2*size(titleTHR)-1), titleTHR=interp2(titleTHR,'nearest'); end
			if data.p, idx=find(titleTHR<=data.thr); else, idx=find(titleTHR>=data.thr); end
			title(idx)=round(192.5+63.5*max(-1,min(1, title0(idx)/data.cscale ))); 
		end
		set(position.h2,'cdata',title);set(position.h1,'xlim',[.5,size(title,2)+.5],'ylim',[.5,size(title,1)+.5+eps],'xtick',[],'ytick',[]); 
		axis(position.h1,'equal','tight'); 
		set([position.h1,position.h2],'visible','on'); set([position.h3,position.h4],'visible','off'); 
		set(position.h2,'userdata',data);
	case 'updateslider2',
		data=get(position.h2,'userdata');
		data.thr=max(0,min(1, title));
		title=fliplr(flipud(data.x1(:,:,data.n))); 
		if ~isempty(data.x0), 
			title0=fliplr(flipud(data.x0(:,:,data.n))); %if all(size(title)==2*size(title0)-1), title0=interp2(title0,'nearest'); end
			titleTHR=fliplr(flipud(data.xTHR(:,:,data.n))); %if all(size(title)==2*size(titleTHR)-1), titleTHR=interp2(titleTHR,'nearest'); end
			if data.p, idx=find(titleTHR<=data.thr); else, idx=find(titleTHR>=data.thr); end
			title(idx)=round(192.5+63.5*max(-1,min(1, title0(idx)/data.cscale ))); 
		end
		set(position.h10,'string',num2str(data.thr));
		set(position.h2,'cdata',title);set(position.h1,'xlim',[.5,size(title,2)+.5],'ylim',[.5,size(title,1)+.5+eps],'xtick',[],'ytick',[]); 
		axis(position.h1,'equal','tight'); 
		set([position.h1,position.h2],'visible','on'); set([position.h3,position.h4],'visible','off'); 
		set(position.h2,'userdata',data);
		
	case 'updatethr',
		position=get(gcbo,'userdata');
		title=str2num(get(gcbo,'string'));
		data=get(position.h2,'userdata');
		data.thr=max(0,min(1,title));
		set(position.h6,'value',data.thr);
		title=fliplr(flipud(data.x1(:,:,data.n))); 
		if ~isempty(data.x0), 
			title0=fliplr(flipud(data.x0(:,:,data.n))); %if all(size(title)==2*size(title0)-1), title0=interp2(title0,'nearest'); end
			titleTHR=fliplr(flipud(data.xTHR(:,:,data.n))); %if all(size(title)==2*size(titleTHR)-1), titleTHR=interp2(titleTHR,'nearest'); end
			if data.p, idx=find(titleTHR<=data.thr); else, idx=find(titleTHR>=data.thr); end
			title(idx)=round(192.5+63.5*max(-1,min(1, title0(idx)/data.cscale ))); 
		end
		set(position.h2,'cdata',title);set(position.h1,'xlim',[.5,size(title,2)+.5],'ylim',[.5,size(title,1)+.5+eps],'xtick',[],'ytick',[]); 
		axis(position.h1,'equal','tight'); 
		set([position.h1,position.h2],'visible','on'); set([position.h3,position.h4],'visible','off'); 
		set(position.h2,'userdata',data);
		
	case 'updatecscale',
		position=get(gcbo,'userdata');
		title=str2num(get(gcbo,'string'));
		data=get(position.h2,'userdata');
		data.cscale=max(eps,title);
		title=fliplr(flipud(data.x1(:,:,data.n))); 
		if ~isempty(data.x0), 
			title0=fliplr(flipud(data.x0(:,:,data.n))); %if all(size(title)==2*size(title0)-1), title0=interp2(title0,'nearest'); end
			titleTHR=fliplr(flipud(data.xTHR(:,:,data.n))); %if all(size(title)==2*size(titleTHR)-1), titleTHR=interp2(titleTHR,'nearest'); end
			
			t0=(129:256)'; idxt0=find(~isnan(titleTHR)); 
			if isempty(idxt0), idxt0=[1,1]; %ceil(128*max(eps,max(title0(:))))];
			else, idxt0=ceil(128*max(eps,min(1,.5+.5*max(-1,min(1, [min(title0(idxt0)),max(title0(:))]/data.cscale ))))); end
			t0(1:min(idxt0)-1)=1;t0(max(idxt0)+1:end)=1;%t0(idxt0)=128;%t0(max(1,idxt0-1))=1;t0(min(128,idxt0+1))=1;
			set(position.h8,'cdata',t0);
		
			if data.p, idx=find(titleTHR<=data.thr); else, idx=find(titleTHR>=data.thr); end
			title(idx)=round(192.5+63.5*max(-1,min(1, title0(idx)/data.cscale ))); 
		end
		set(position.h2,'cdata',title);set(position.h1,'xlim',[.5,size(title,2)+.5],'ylim',[.5,size(title,1)+.5+eps],'xtick',[],'ytick',[]); 
		axis(position.h1,'equal','tight'); 
		set([position.h1,position.h2],'visible','on'); set([position.h3,position.h4],'visible','off'); 
		set(position.h2,'userdata',data);
		
	case 'filesearch',
		h=conn_filesearchtool('position',[.7,.06,.29,.84],'backgroundcolor',[0,0,1/6],'foregroundcolor',[1,1,4/6],...
			'title',title,'filter',string,'callback',callback,'max',1);
		set([h.folder,h.filter,h.find,h.files],'backgroundcolor','k','foregroundcolor','w');
	case 'frame',
		if ~isempty(title), uicontrol('style','text','units','norm','position',(position+[0,position(4),0,0]).*[1,1,1,0]+[0,0,0,.04],'string',title,'foregroundcolor',[1,1,4/6],'backgroundcolor',[0,0,2/6],'fontweight','bold','fontname','arial','fontsize',9,'horizontalalignment','center'); end
		h=axes('units','norm','position',position,'color',[0,0,1/6],'xtick',[],'ytick',[],'xcolor',[1,1,4/6],'ycolor',[1,1,4/6],'box','on');
		%h=axes('units','norm','position',[position(1),position(2)+.99*position(4),position(3),.01*position(4)],'color',[0,0,1/6],'xtick',[],'ytick',[],'xcolor',[1,1,4/6],'ycolor',[1,1,4/6],'box','on');

end

function conn_menubuttondownfcn(varargin);
global CONN_refs
data=get(gcbo,'userdata');data=data.buttondown;
xyz=get(data.h1,'currentpoint'); 
xyz=round(data.matdim.mat(1:3,:)*[data.matdim.dim(1)+1-xyz(1),data.matdim.dim(2)+1-xyz(1,2),data.z,1]');
v=spm_get_data(CONN_refs.rois.V,pinv(CONN_refs.rois.V.mat)*[xyz;1]);
if v>0, txt=[CONN_refs.rois.filename,'.',CONN_refs.rois.labels{v}]; else, txt=''; end
h=findobj('tag','conn_menubuttondownfcn');if isempty(h), h=figure('units','pixels','position',[get(0,'pointerlocation')-[400,30],250,40]);else, figure(h); end;
set(h,'units','pixels','position',[get(0,'pointerlocation')-[150,30],0,0]+get(h,'position')*[0,0,0,0;0,0,0,0;-1,0,1,0;0,0,0,1],'menubar','none','numbertitle','off','color','k','tag','conn_menubuttondownfcn');
clf(h);text(0,1,['x,y,z = (',num2str(xyz(1)),',',num2str(xyz(2)),',',num2str(xyz(3)),') mm'],'color','y','fontweight','bold','horizontalalignment','center','fontsize',9);text(0,0,txt,'color','y','fontweight','bold','horizontalalignment','center','fontsize',9,'interpreter','none');set(gca,'units','norm','position',[0,0,1,1],'xlim',[-1,1],'ylim',[-.5,1.5],'visible','off');
%hc=get(0,'children');if length(hc)>0&&hc(1)~=h,hc=[h;hc(hc~=h)];set(0,'children',h); end

        