
function [X,select,names]=conn_designmatrix(confounds,X1,X2,nconfounds);

select=[];X=[];names={};
if nargin>3, select=cell(size(nconfounds)); end


for n1=1:length(confounds.names), 
	switch(confounds.types{n1}),
		case 'roi',
			idx=strmatch(confounds.names{n1},X1.names,'exact');
			if isempty(idx)||length(idx)>1, error('Mismatch info: Run SETUP again!'); end
			x=X1.data{idx}(:,1:min(confounds.dimensions{n1}(1),size(X1.data{idx},2)));
		case 'cov',
			idx=strmatch(confounds.names{n1},X2.names,'exact');
			if isempty(idx)||length(idx)>1, error('Mismatch info: Run SETUP again!'); end
			x=X2.data{idx}(:,1:min(confounds.dimensions{n1}(1),size(X2.data{idx},2)));
    end
    if ~isempty(x),
        X=cat(2,X,x);
        for n0=1:size(x,2),names{end+1}=[confounds.names{n1},'_',num2str(1),'_',num2str(n0)];end
        if nargin>3, for n0=1:length(nconfounds),
                if any(n1==nconfounds{n0}), select{n0}=cat(2,select{n0},ones(1,size(x,2)));
                else, select{n0}=cat(2,select{n0},zeros(1,size(x,2))); end
            end; end
        for n2=1:confounds.deriv{n1},
            x=convn(cat(1,x(1,:),x,x(end,:)),[1;0;-1],'valid');
            X=cat(2,X,x);
            for n0=1:size(x,2),names{end+1}=[confounds.names{n1},'_',num2str(n2+1),'_',num2str(n0)];end
            if nargin>3, for n0=1:length(nconfounds),
                    if any(n1==nconfounds{n0}), select{n0}=cat(2,select{n0},ones(1,size(x,2)));
                    else, select{n0}=cat(2,select{n0},zeros(1,size(x,2))); end
                end; end
        end
    end
end
N=size(X,1); if ~N, N=size(X1.data{1},1); end
X=[ones(N,1),X];
if nargin>3, for n0=1:length(nconfounds),select{n0}=[0,select{n0}];end; end
