function conn_display(SPMfilename,ncon);
% CONN_DISPLAY
% Displays second-level results
% conn_display(SPMfilename);
%

% 03/09 alfnie@gmail.com
%

if nargin<1 || isempty(SPMfilename),
    [filename,filepath]=uigetfile('SPM.mat');
    if ~ischar(filename), return; end
    SPMfilename=fullfile(filepath,filename);
else,
    [filepath,filename,fileext]=fileparts(SPMfilename);
    if isempty(filepath), filepath=pwd;end
    SPMfilename=fullfile(filepath,[filename,fileext]);
end
[filepath,filename,fileext]=fileparts(SPMfilename);
cwd=pwd;

if ~isempty(filepath), cd(filepath); end
hm=msgbox('Loading... please wait','conn_display'); 
load([filename,fileext]);

if length(SPM.xCon)>1, 
    if nargin<2, ncon=spm_conman(SPM); end
else, ncon=1; end
[x,y,z]=ndgrid(1:SPM.xCon(ncon).Vspm.dim(1),1:SPM.xCon(ncon).Vspm.dim(2),1:SPM.xCon(ncon).Vspm.dim(3));
xyz=SPM.xCon(ncon).Vspm.mat*[x(:),y(:),z(:),ones(numel(x),1)]';
strfile=spm_vol(fullfile(fileparts(which('spm')),'apriori','brainmask.nii'));
a=reshape(spm_get_data(strfile,pinv(strfile.mat)*xyz),[SPM.xCon(ncon).Vspm.dim(1:3)]);
%strfile=spm_vol(fullfile(fileparts(which('spm')),'canonical','single_subj_T1.nii'));
strfile=spm_vol(fullfile(fileparts(which('spm')),'canonical','avg305T1.nii'));
b=reshape(spm_get_data(strfile,pinv(strfile.mat)*xyz),[SPM.xCon(ncon).Vspm.dim(1:3)]);
ab=(a>.2).*(a.*b);
if length(SPM.xCon(ncon).Vspm.dim)>3,SPM.xCon(ncon).Vspm.dim=SPM.xCon(ncon).Vspm.dim(1:3); end;
if ~isfield(SPM.xCon(ncon).Vspm,'dt'), SPM.xCon(ncon).Vspm.dt=[spm_type('float32') spm_platform('bigend')]; end
T=spm_read_vols(SPM.xCon(ncon).Vspm);
df=[SPM.xCon(ncon).eidf,SPM.xX.erdf];
R=SPM.xVol.R;
S=SPM.xVol.S;
try, v2r=1/prod(SPM.xVol.FWHM(1:3)); catch, v2r=[]; end

p=nan+zeros(size(T));idxvalid=find(~isnan(T)|isequal(T,0));p(idxvalid)=(1-spm_Tcdf(T(idxvalid),df(2))); 


figure;
close(hm);
x=find(any(any(ab,2),3)|any(any(T,2),3)); %crop
y=find(any(any(ab,1),3)|any(any(T,1),3));
z=find(any(any(ab,1),2)|any(any(T,1),2));
p=p(x(1):x(end),y(1):y(end),z(1):z(end));
ab=ab(x(1):x(end),y(1):y(end),z(1):z(end));
logp=p;logp(logp==0)=nan; logp=-log(logp);
conn_vproject(ab,logp,p,[],[],{.05,2,.05,2},[],[],[],{SPM.xCon(ncon).Vspm.mat*(eye(4)+[zeros(4,3),[x(1)-1;y(1)-1;z(1)-1;0]]),R,df,S,v2r},.20,[],SPMfilename);
%vproject(ab,-log(p),[],[],{.05,2,.05,2},[],[],[],{SPM.xCon(ncon).Vspm.mat,R,df,S},.3);%+[zeros(4,3),[x(1)-1;y(1)-1;z(1)-1;0]],R,df,S},.3);

cd(cwd);
