function conn_displayroi(option,varargin);
global CONN_x;
if ~nargin, option='init'; end
if ~ischar(option), option=varargin{2}; end;
switch(lower(option)),
    case 'init',
        if nargin>1, 
            data.source=varargin{1}; 
            data.side=1;
            results=conn_process('results_roi');
        else,
            data.side=3;
            [filename,filepath]=uigetfile('*ROI*.mat');
            if ~ischar(filename), return; end
            results=load(fullfile(filepath,filename));results=results.ROI;
            data.source=1:length(results);
        end
%         if nargin<2 || isempty(varargin{1}), 
%             answ=listdlg('Promptstring','Select ROIs','selectionmode','multiple','liststring',CONN_x.Analyses(CONN_x.Analysis).sources);
%             nsources=answ; 
%             data.source=0;
%         elseif iscell(varargin{1}), nsources=varargin{1}{1}; data.source=varargin{1}{2};
%         else, nsources=varargin{1}; data.source=0; end
        data.h=cat(1,results.h);
        data.F=cat(1,results.F);
        data.p=cat(1,results.p);
        data.names=results(1).names;
        data.names2=results(1).names2;
        data.xyz=cat(1,results(1).xyz{:});
        data.xyz2=cat(1,results(1).xyz2{:});
        data.thr=.05;
        data.thrtype=2;
        data.clusters=[];
        data.view=[];
        data.proj=[];
        data.x=[];
        data.y=[];
        data.z=[];
        data.bgz=0;
        data.display='connectivity';
        data.displayreduced=0;
        data.displaytheserois=1:length(data.names2);
        data.visible='on';
        filename=fullfile(fileparts(which('spm')),'canonical','avg152T1.nii');
        data.ref=spm_vol(filename);
        color1=[1,1,1];
        color2=.85*[1,1,1];
        hfig=figure;
        set(hfig,'units','norm','position',[.1,.2,.8,.6],'numbertitle','off','name','ROI second-level results','color',color1,'colormap',gray);
        uicontrol('style','frame','units','norm','position',[.03,.9,.45,.08],'backgroundcolor',color2);
        %uicontrol('style','frame','units','norm','position',[.53,.02,.44,.96],'backgroundcolor',color2);
        data.handles=[...
            uicontrol('style','text','units','norm','position',[.05,.925,.10,.04],'string','threshold: p =','foregroundcolor','k','backgroundcolor',color2,'fontweight','bold','horizontalalignment','right'),...
            uicontrol('style','edit','units','norm','position',[.17,.925,.05,.04],'string',num2str(data.thr),'foregroundcolor','k','backgroundcolor','w','callback',{@conn_displayroi,'thr'}),...
            uicontrol('style','popupmenu','units','norm','position',[.24,.925,.10,.04],'string',{'uncorrected','FDR corrected'},'foregroundcolor','k','backgroundcolor','w','callback',{@conn_displayroi,'thrtype'},'value',data.thrtype),...
            uicontrol('style','popupmenu','units','norm','position',[.36,.925,.10,.04],'string',{'one-sided (positive)','one-sided (negative)','two-sided'},'foregroundcolor','k','backgroundcolor','w','callback',{@conn_displayroi,'side'},'value',data.side),...
            uicontrol('style','text','units','norm','position',[.55,.93,.4,.04],'string','ROIs','foregroundcolor','b','backgroundcolor','w','fontweight','bold'),...
            uicontrol('style','listbox','units','norm','position',[.55,.53,.4,.4],'string',' ','max',2,'fontname','monospaced','foregroundcolor','k','backgroundcolor','w','callback',{@conn_displayroi,'list1'}),...
            uicontrol('style','text','units','norm','position',[.55,.45,.4,.04],'string',sprintf('%6s %6s  %6s  %6s  %8s  %8s','Source','Target','beta','T','p-unc','p-FDR'),'foregroundcolor','b','backgroundcolor','w','fontname','monospaced','fontweight','bold','horizontalalignment','left'),...
            uicontrol('style','listbox','units','norm','position',[.55,.05,.4,.4],'string',' ','fontname','monospaced','foregroundcolor','k','backgroundcolor','w','callback',{@conn_displayroi,'list2'}),...
            uicontrol('style','popupmenu','units','norm','position',[.08,.0,.10,.05],'string',{'axial (x-y)','coronal (x-z)','sagittal (y-z)'},'foregroundcolor','k','backgroundcolor',color1,'callback',{@conn_displayroi,'view'},'value',1),...
            uicontrol('style','slider','units','norm','position',[.38,.0,.10,.05],'foregroundcolor','w','backgroundcolor',color1,'callback',{@conn_displayroi,'slider1'},'value',.5),...
            uicontrol('style','slider','units','norm','position',[.23,.0,.10,.05],'foregroundcolor','w','backgroundcolor',color1,'callback',{@conn_displayroi,'slider2'},'value',.5),...
            uicontrol('style','popupmenu','units','norm','position',[.8,.93,.15,.04],'string',{'all ROIs','source ROIs','select ROIs'},'value',data.displayreduced+1,'foregroundcolor','k','backgroundcolor','w','callback',{@conn_displayroi,'displayreduced'})];
        uicontrol('style','text','units','norm','position',[.03,.01,.05,.04],'string','view:  ','foregroundcolor','k','backgroundcolor',color1,'fontweight','bold','horizontalalignment','right');
        uicontrol('style','text','units','norm','position',[.35,.01,.02,.04],'string','q','fontname','symbol','horizontalalignment','right','foregroundcolor','k','backgroundcolor',color1,'fontweight','bold','horizontalalignment','right');
        uicontrol('style','text','units','norm','position',[.20,.01,.02,.04],'string','z','horizontalalignment','right','foregroundcolor','k','backgroundcolor',color1,'fontweight','bold','horizontalalignment','right');
        rcircle=[sin(linspace(0,2*pi,64)'),cos(linspace(0,2*pi,64))']*diag([5,5]);
        h=subplot(121);set(h,'units','norm','position',[.13,.845,.25,.05],'xtick',[],'ytick',[],'box','on');axis equal;set(h,'xlim',[-10,200]);
        h=patch(100+rcircle(:,1),0+rcircle(:,2),'w');set(h,'edgecolor','none','facecolor','r'); 
        h=patch(150+rcircle(:,1),0+rcircle(:,2),'w');set(h,'edgecolor','none','facecolor','b'); 
        h=text(0,0,'ROI-ROI connectivity:','horizontalalignment','left','fontsize',8);
        h=text(100+10,0,'Positive','horizontalalignment','left','fontsize',8);
        h=text(150+10,0,'Negative','horizontalalignment','left','fontsize',8);
    case 'thr',
        hfig=gcbf;
        data=get(hfig,'userdata');
        str=get(data.handles(2),'string');
        if ~isempty(str2num(str)),
            data.thr=max(0,str2num(str));
        end
        data.visible='on';
    case 'thrtype',
        hfig=gcbf;
        data=get(hfig,'userdata');
        value=get(data.handles(3),'value');
        data.thrtype=value;
        data.visible='on';
    case 'side',
        hfig=gcbf;
        data=get(hfig,'userdata');
        value=get(data.handles(4),'value');
        data.side=value;
        data.visible='on';
    case 'displayreduced',
        hfig=gcbf;
        data=get(hfig,'userdata');
        value=get(data.handles(12),'value');
        data.displayreduced=value-1;
        switch(data.displayreduced),
            case 0,
                data.displaytheserois=1:length(data.names2);
            case 1,
                data.displaytheserois=1:length(data.names);
            case 2,
                answ=listdlg('Promptstring','Select ROIs','selectionmode','multiple','liststring',data.names2,'initialvalue',data.displaytheserois);
                if ~isempty(answ), data.displaytheserois=answ; end
        end
        data.source=0;%data.source(data.source==0 || data.source<=length(data.displaytheserois));if isempty(data.source),data.soruce=0;end
        
        data.visible='on';
    case 'list1',
        hfig=gcbf;
        data=get(hfig,'userdata');
        value=get(data.handles(6),'value');
        if all(value>0&value<=length(data.displaytheserois)), 
            data.source=value;
            data.bgz=mean(data.z(data.displaytheserois(data.source)));
            set(data.handles(11),'value',max(0,min(1,data.bgz/200+.5)));
            data.bgimage=spm_get_data(data.ref,pinv(data.ref.mat)*[data.proj(:,1:3)*[data.bgx(:),data.bgy(:),data.bgz+zeros(prod(size(data.bgx)),1)]';ones(1,prod(size(data.bgx)))]);
            %set(data.refaxes,'cdata',convn(convn(reshape(data.bgimage,size(data.bgx)),conn_hanning(5),'same'),conn_hanning(5)','same'));
        else, 
            data.source=0; 
            data.bgz=0;
            set(data.handles(11),'value',max(0,min(1,data.bgz/200+.5)));
            data.bgimage=spm_get_data(data.ref,pinv(data.ref.mat)*[data.proj(:,1:3)*[data.bgx(:),data.bgy(:),data.bgz+zeros(prod(size(data.bgx)),1)]';ones(1,prod(size(data.bgx)))]);
            %set(data.refaxes,'cdata',convn(convn(reshape(data.bgimage,size(data.bgx)),conn_hanning(5),'same'),conn_hanning(5)','same'));
        end
        data.visible='on';
    case 'list2',
        hfig=gcbf;
        data=get(hfig,'userdata');
        value=get(data.handles(8),'value');
        set(data.plotsadd2,'linewidth',1);
        if value>0&&value<=length(data.plotsadd2), set(data.plotsadd2(value),'linewidth',3); end
        return;
        data.visible='on';
    case 'view',
        hfig=gcbf;
        data=get(hfig,'userdata');
        data.view=get(data.handles(9),'value');
        data.proj=[];data.x=[];data.y=[];data.z=[];
        set(data.handles(10),'value',.5);
        set(data.handles(11),'value',.5);
        data.bgz=0;
    case 'slider1',
        hfig=gcbf;
        data=get(hfig,'userdata');
        value=get(data.handles(10),'value');
        ang=(value-.5)*pi;
        switch(data.view),
            case 1, data.proj=[1,0,0;0,cos(ang),-sin(ang);0,sin(ang),cos(ang)];
            case 2, data.proj=[1,0,0;0,sin(ang),-cos(ang);0,cos(ang),sin(ang)];
            case 3, data.proj=[0,sin(ang),cos(ang);1,0,0;0,cos(ang),-sin(ang)];
        end
        data.x=[];data.y=[];data.z=[];
    case 'slider2',
        hfig=gcbf;
        data=get(hfig,'userdata');
        value=get(data.handles(11),'value');
        data.bgz=(value-.5)*200;
        data.bgimage=spm_get_data(data.ref,pinv(data.ref.mat)*[data.proj(:,1:3)*[data.bgx(:),data.bgy(:),data.bgz+zeros(prod(size(data.bgx)),1)]';ones(1,prod(size(data.bgx)))]);
        set(data.refaxes,'cdata',convn(convn(reshape(data.bgimage,size(data.bgx)),conn_hanning(5),'same'),conn_hanning(5)','same'));
        set(hfig,'userdata',data);
        return;
    case 'clusters',
        hfig=gcf;
        data=get(hfig,'userdata');
        nclusters=varargin{1};
        %P=data.p(1:end-4,1:end-4);X=double(P<.05).*sign(data.h(1:end-4,1:end-4));
        P=data.p;%P(:)=conn_fdr(data.p(:));
        X=double(P<.05).*sign(data.h);
        X(1:size(X,1)+1:size(X,1)*size(X,1))=1;
        Y = pdist(X, 'euclid');
        Z = linkage(Y, 'ward');
        figure;[H,T,idx]=dendrogram(Z,0,'labels',data.names,'orientation','left');figure(hfig);
        T = cluster(Z, 'maxclust', nclusters);
        data.display='clusters';
        data.clusters=T;
        for n1=1:nclusters,disp(' ');disp(['Cluster #',num2str(n1)]);disp(strvcat(data.names{T==n1}));end
    case 'cluster',
        hfig=gcf;
        data=get(hfig,'userdata');
        ncluster=varargin{1};
        data.display='connectivity';
        data.visible='on';
        data.source=find(data.clusters==ncluster);
        data.bgz=mean(data.z(data.source));
        set(data.handles(11),'value',max(0,min(1,data.bgz/200+.5)));
        data.bgimage=spm_get_data(data.ref,pinv(data.ref.mat)*[data.proj(:,1:3)*[data.bgx(:),data.bgy(:),data.bgz+zeros(prod(size(data.bgx)),1)]';ones(1,prod(size(data.bgx)))]);
        set(data.handles(6),'value',data.source);
        disp(['Cluster #',num2str(ncluster)]);disp(strvcat(data.names{data.source}));
end

% selects optimal view
if isempty(data.view),
    a=std(data.xyz2(:,1:3),1,1);
    [nill,idx]=sort(a);
    if idx(end-1)==1, idx([end-1,end])=idx([end,end-1]); end
    if idx(end)==1&&idx(end-1)==2,data.view=1;
    elseif idx(end)==1&&idx(end-1)==3,data.view=2;
    else data.view=3; end
    set(data.handles(9),'value',data.view);
end
% projector associated with view
if isempty(data.proj),
    switch(data.view),
        case 1, data.proj=[1,0,0;0,1,0;0,0,1];
        case 2, data.proj=[1,0,0;0,0,1;0,1,0];
        case 3, data.proj=[0,0,1;1,0,0;0,1,0];
    end
end
% projects coordinates and background image
scale=1;
if isempty(data.x)||isempty(data.y),
    data.x=data.xyz2*data.proj(:,1);data.y=data.xyz2*data.proj(:,2);data.z=data.xyz2*data.proj(:,3);
    lim=[1,1,1;data.ref.dim];refminmax=sort([lim((dec2bin(0:7)-'0'+1)+repmat([0,2,4],[8,1])),ones(8,1)]*data.ref.mat(1:3,:)'*data.proj(:,1:2));
    [data.bgx,data.bgy]=meshgrid(refminmax(1,1):scale:refminmax(end,1),refminmax(1,2):scale:refminmax(end,2));
    data.bgimage=spm_get_data(data.ref,pinv(data.ref.mat)*[data.proj(:,1:3)*[data.bgx(:),data.bgy(:),data.bgz+zeros(prod(size(data.bgx)),1)]';ones(1,prod(size(data.bgx)))]);
end
N=length(data.names);
N2=length(data.names2);
switch(data.display),
    case 'connectivity',
        % computes stat threshold
        switch(data.side),
            case 1,p=data.p;
            case 2,p=1-data.p;
            case 3,p=2*min(data.p,1-data.p);
        end
        %if data.displayreduced, p=p(:,1:N); end
        %p=p(intersect(1:N,data.displaytheserois),data.displaytheserois);
        p(setdiff(1:N,data.displaytheserois),:)=nan;
        p(:,setdiff(1:N2,data.displaytheserois))=nan;
        if any(~data.source), P=reshape(conn_fdr(p(:)),size(p));
        else, P=nan+zeros(size(p)); tempidx=data.source(data.source>0&data.source<=length(data.displaytheserois)); temp=p(intersect(1:N,data.displaytheserois(tempidx)),:); temp(:)=conn_fdr(temp(:)); P(intersect(1:N,data.displaytheserois(tempidx)),:)=temp; end;
        data.P=P;
        switch(data.thrtype),
            case 1, z=(p<=data.thr).*(.1+.8*p/max(eps,data.thr));
            case 2, z=(P<=data.thr).*(.1+.8*P/max(eps,data.thr));
        end
        z(isnan(p))=nan;
        if ~any(~data.source), z(setdiff(1:size(z,1),data.displaytheserois(data.source)),:)=nan; end
        
        % text lists
        txt1={};for n1=1:length(data.displaytheserois),
            txt1{end+1}=(sprintf('%-5s: %-40s',['(',num2str(n1),')'],data.names2{data.displaytheserois(n1)}));
        end;txt1{end+1}=' ';
        txt1=strvcat(txt1{:});
        %tp=[];sort2=[];txt2={};for n1=1:N,for n2=[1:n1-1,n1+1:N2+data.displayreduced*(N-N2)],
        tp=[];sort2=[];txt2={};
        for na1=1:length(data.displaytheserois),
            n1=data.displaytheserois(na1);
            for na2=1:length(data.displaytheserois),
                n2=data.displaytheserois(na2);
                if n1<=N&&n1~=n2&&z(n1,n2)>0,
                    txt2{end+1}=(sprintf('%-6s %-6s  %6.2f  %6.2f  %8.6f  %8.6f',['(',num2str(na1),')'],['(',num2str(na2),')'],data.h(n1,n2),data.F(n1,n2),p(n1,n2),P(n1,n2))); tp=cat(1,tp,P(n1,n2)-1e-10*abs(data.F(n1,n2))); sort2=cat(1,sort2,[n1,n2]); 
                end;
            end; 
        end;
        [nill,idxsort]=sort(tp); data.list2=sort2(idxsort,:); txt2=strvcat(txt2{idxsort},' ');
        
        set(data.handles(6),'string',txt1,'value',max(1,min(size(txt1,1), max(1,unique(data.source))))); %get(data.handles(6),'value'))));
        set(data.handles(8),'string',txt2,'value',max(1,min(size(txt2,1), get(data.handles(8),'value'))));
        
        % plots
        figure(hfig);set(hfig,'pointer','watch');drawnow;
        rcircle=[sin(linspace(0,2*pi,64)'),cos(linspace(0,2*pi,64))']*diag([5,5]);
        rtriang=[-1-j*.5;0;-1+j*.5];
        h=findobj(hfig,'tag','conn_displayroi_plot');
        if ~isempty(h),delete(h); end
        h=axes('units','norm','position',[.03,.06,.45,.78]);
        lim=[1,1,1;data.ref.dim];refminmax=sort([lim((dec2bin(0:7)-'0'+1)+repmat([0,2,4],[8,1])),ones(8,1)]*data.ref.mat(1:3,:)'*data.proj(:,1:2));
        data.refaxes=imagesc(refminmax(1,1):scale:refminmax(end,1),refminmax(1,2):scale:refminmax(end,2),convn(convn(reshape(data.bgimage,size(data.bgx)),conn_hanning(5),'same'),conn_hanning(5)','same'));hold on;
        h=gca;data.buttondown=struct('h1',h);set(h,'tag','conn_displayroi_plot');
        
        EPS=1e-0;
        data.plotsadd2=[];
        idxtext=[];
        hold on;
        for na1=1:length(data.displaytheserois),%size(z,2),%N2,
            n1=data.displaytheserois(na1);
            if any(na1==data.source)||(n1<=size(z,1)&&any(z(n1,:)>0))||any(z(:,n1)>0),%((n1<=size(z,1)||~data.displayreduced)&&any(z(:,n1)>0)),
                h=patch(data.x(n1)+rcircle(:,1)*max(.5,1+1e-3*data.z(n1)),data.y(n1)+rcircle(:,2)*max(.5,1+1e-3*data.z(n1)),max(1,data.z(n1))*EPS+200+zeros(size(rcircle,1),1),'w');
                if any(na1==data.source), set(h,'edgecolor','k','linewidth',2); else, set(h,'edgecolor','none'); end
                if all(data.h(z(:,n1)>0,n1)>0), k=sum(data.h(z(:,n1)>0,n1)>0,1);set(h,'facecolor',[1,0,0]);%*(.5+.5*k/max(eps,max(sum(z>0,1)))));
                elseif all(data.h(z(:,n1)>0,n1)<0), k=sum(data.h(z(:,n1)>0,n1)<0,1);set(h,'facecolor',[0,0,1]);%*(.5+.5*k/max(eps,max(sum(z>0,1)))));
                else, set(h,'facecolor',[0,1,0]); end
                hold on;
                set(h,'buttondownfcn',@conn_displayroi_menubuttondownfcn,'userdata',data);
            end
            if n1<=N,
                for na2=1:length(data.displaytheserois),
                    n2=data.displaytheserois(na2); %n2=[1:n1-1,n1+1:N2],
                    if n1~=n2&&z(n1,n2)>0, %(n2<=N||~data.displayreduced)&&(z(n1,n2)>0),
                        x=[data.x([n1;n2]),data.y([n1;n2])];
                        dx=(flipud(x)-x);dx=dx./repmat(max(eps,sqrt(sum(abs(dx).^2,2))),[1,2]);
                        h=plot3(x(:,1)+dx(:,1).*5,x(:,2)+dx(:,2).*5,0*max(1,data.z([n1;n2]))*EPS+.5,'r-','linewidth',1,'color',[1,0,0]+0*[0,1,1]*z(n1,n2),'visible',data.visible);
                        data.plotsadd2(end+1)=h;
                        if data.h(n1,n2)<0, set(h,'color',[0,0,1]+0*[1,1,0]*z(n1,n2)); end
                        set(h,'buttondownfcn',@conn_displayroi_menubuttondownfcn,'userdata',data);
                        rangle=rtriang*exp(j*angle(diff(data.x([n1;n2])+j*data.y([n1;n2]),1,1)));
                        h=patch(x(2,1)+dx(2,1)*5+3*real(rangle),x(2,2)+dx(2,2)*5+3*imag(rangle),0*max(1,data.z(n2))*EPS+.5+zeros(size(rangle)),'w'); set(h,'edgecolor','none','facecolor',[1,0,0]+0*[0,1,1]*z(n1,n2),'visible',data.visible);
                        if data.h(n1,n2)<0, set(h,'facecolor',[0,0,1]+0*[1,1,0]*z(n1,n2)); end
                    end
                end
            end
            if any(na1==data.source)||(n1<=N&&any(z(n1,:)>0))||any(z(:,n1)>0), %||((n1<=N||~data.displayreduced)&&any(z(:,n1)>0)),
                %h=text(data.x(n1),data.y(n1),max(1,data.z(n1))*EPS+202,num2str(n1));
                %set(h,'fontsize',10,'color','w','horizontalalignment','center','interpreter','none','fontweight','bold','backgroundcolor','none');
                idxtext=[idxtext;na1];
                %%if any(n1==data.source), set(h,'color','k'); end
                %set(h,'buttondownfcn',@conn_displayroi_menubuttondownfcn,'userdata',data);
            end
        end
        h=text(data.x(data.displaytheserois(idxtext)),data.y(data.displaytheserois(idxtext)),max(1,data.z(data.displaytheserois(idxtext)))*EPS+202,num2str(idxtext));
        set(h,'fontsize',9,'color','w','horizontalalignment','center','interpreter','none','fontweight','bold','backgroundcolor','none');
        set(h,'buttondownfcn',@conn_displayroi_menubuttondownfcn,'userdata',data);
        data.plotsadd2=data.plotsadd2(idxsort);
        hold off;
    case 'clusters',
        figure(hfig);set(hfig,'pointer','watch');drawnow;
        rcircle=[sin(linspace(0,2*pi,64)'),cos(linspace(0,2*pi,64))']*diag([5,5]);
        h=findobj('tag','conn_displayroi_plot');
        if ~isempty(h),delete(h); end
        h=axes('units','norm','position',[.03,.06,.45,.78]);
        lim=[1,1,1;data.ref.dim];refminmax=sort([lim((dec2bin(0:7)-'0'+1)+repmat([0,2,4],[8,1])),ones(8,1)]*data.ref.mat(1:3,:)'*data.proj(:,1:2));
        data.refaxes=imagesc(refminmax(1,1):scale:refminmax(end,1),refminmax(1,2):scale:refminmax(end,2),convn(convn(reshape(data.bgimage,size(data.bgx)),conn_hanning(5),'same'),conn_hanning(5)','same'));hold on;
        h=gca;data.buttondown=struct('h1',h);set(h,'tag','conn_displayroi_plot');

        cmap=jet(max(1,max(data.clusters)));
        EPS=1;
        data.plotsadd2=[];
        for n1=1:N,
            hold on;
            if length(data.clusters)>=n1&&data.clusters(n1)>0,
                h=patch(data.x(n1)+rcircle(:,1)*max(.5,1+1e-3*data.z(n1)),data.y(n1)+rcircle(:,2)*max(.5,1+1e-3*data.z(n1)),max(1,data.z(n1))*EPS+.10+zeros(size(rcircle,1),1),'w');
                set(h,'edgecolor','none','facecolor',cmap(data.clusters(n1),:)); 
                hold on;
                set(h,'buttondownfcn',@conn_displayroi_menubuttondownfcn,'userdata',data);
                h=text(data.x(n1),data.y(n1),max(1,data.z(n1))*EPS+.10+2,num2str(n1));
                set(h,'fontsize',9,'color','w','horizontalalignment','center','interpreter','none','fontweight','bold','backgroundcolor','none');
                set(h,'buttondownfcn',@conn_displayroi_menubuttondownfcn,'userdata',data);
            end
        end
        hold off;
end
set(gca,'ydir','normal');
axis equal; axis off;
set(hfig,'userdata',data);
set(hfig,'pointer','arrow');

function conn_displayroi_menubuttondownfcn(varargin);
data=get(gcbo,'userdata');
xyz=get(data.buttondown.h1,'currentpoint'); 
x=xyz(1,1);y=xyz(1,2);z=-100;
[nill,idx]=min(sqrt(abs(data.x(data.displaytheserois)-x).^2+abs(data.y(data.displaytheserois)-y).^2)+1e-10*abs(data.z(data.displaytheserois)-z).^2);
txt=data.names2{data.displaytheserois(idx)};
h=findobj('tag','conn_displayroi_menubuttondownfcn');if isempty(h), h=figure('units','pixels','position',[get(0,'pointerlocation')-[125,-200],250,40]);else, figure(h); end;
set(h,'units','pixels','position',[get(0,'pointerlocation')-[125,-200],0,0]+[0,0,1,1].*get(h,'position'),'menubar','none','numbertitle','off','color','k','tag','conn_displayroi_menubuttondownfcn');
clf(h);text(0,1,['x,y,z = (',num2str(data.xyz2(data.displaytheserois(idx),1),'%1.0f'),',',num2str(data.xyz2(data.displaytheserois(idx),2),'%1.0f'),',',num2str(data.xyz2(data.displaytheserois(idx),3),'%1.0f'),') mm'],'color','y','fontweight','bold','horizontalalignment','center','fontsize',9);
text(0,0,['(',num2str(idx),') : ',txt],'color','y','fontweight','bold','horizontalalignment','center','fontsize',9,'interpreter','none');set(gca,'units','norm','position',[0,0,1,1],'xlim',[-1,1],'ylim',[-.5,1.5],'visible','off');
%hc=get(0,'children');if length(hc)>0&&hc(1)~=h,hc=[h;hc(hc~=h)];set(0,'children',h); end

