
function h=conn_filesearchtool(varargin);

if nargin<1 || ischar(varargin{1}),
    fields={'position',[.5,.1,.4,.8],...
        'backgroundcolor',.9*[1,1,1],...
        'foregroundcolor',[0,0,0],...
        'title','File search tool',...
        'folder',pwd,...
        'filter','*',...
        'callback','',...
        'max',2};
    params=[];
    for n1=1:2:nargin, params=setfield(params,lower(varargin{n1}),varargin{n1+1}); end
    for n1=1:2:length(fields), if ~isfield(params,fields{n1}) | isempty(getfield(params,fields{n1})), params=setfield(params,fields{n1},fields{n1+1}); end; end;
    M=[params.position(1),params.position(3),0,0,0;params.position(2),0,params.position(4),0,0;0,0,0,params.position(3),0;0,0,0,0,params.position(4)]';
    %uicontrol('style','frame','units','norm','position',[1,0,0,1,1]*M,'backgroundcolor',params.backgroundcolor);
    axes('units','norm','position',[1,0,0,1,1]*M,'color',params.backgroundcolor,'xcolor',params.foregroundcolor,'ycolor',params.foregroundcolor,'xtick',[],'ytick',[],'box','on');
    uicontrol('style','text','units','norm','position',[1,.05,.8,.9,.175]*M,'foregroundcolor',params.foregroundcolor,'backgroundcolor',params.backgroundcolor,'string',params.title,'fontweight','bold','fontname','arial','fontsize',11,'fontangle','italic','horizontalalignment','left');
    uicontrol('style','text','units','norm','position',[1,.05,.8,.2,.05]*M,'foregroundcolor',params.foregroundcolor,'backgroundcolor',params.backgroundcolor,'string','Filter','fontweight','bold','fontname','arial','fontsize',9,'horizontalalignment','center');
    h.filter=uicontrol('style','edit','units','norm','position',[1,.25,.8,.7,.05]*M,'foregroundcolor',params.foregroundcolor,'backgroundcolor',params.backgroundcolor,'string',params.filter,'tooltipstring','Select a file name filter (wildcards may be used)');
    uicontrol('style','text','units','norm','position',[1,.05,.85,.2,.05]*M,'foregroundcolor',params.foregroundcolor,'backgroundcolor',params.backgroundcolor,'string','Folder','fontweight','bold','fontname','arial','fontsize',9,'horizontalalignment','center');
    h.folder=uicontrol('style','edit','units','norm','position',[1,.25,.85,.7,.05]*M,'foregroundcolor',params.foregroundcolor,'backgroundcolor',params.backgroundcolor,'string',params.folder,'tooltipstring','Select the root folder');
    h.find=uicontrol('style','togglebutton','units','norm','position',[1,.7,.925,.25,.05]*M,'foregroundcolor',params.foregroundcolor,'backgroundcolor',params.backgroundcolor,'value',0,'string','Find','fontweight','bold','fontname','arial','fontsize',9,'horizontalalignment','center','tooltipstring','Recursively find files names matching the filter starting from the selected folder');
    h.files=uicontrol('style','listbox','units','norm','position',[1,.05,.05,.9,.70]*M,'foregroundcolor',params.foregroundcolor,'backgroundcolor',params.backgroundcolor,'string','','max',params.max,'tooltipstring','Displays file matches. Select a folder for browsing to a different location');
    h.callback=params.callback;
    set([h.files,h.find,h.folder,h.filter],'userdata',h);
    names={'files','find','folder','filter'}; for n1=1:length(names), set(h.(names{n1}),'callback',{@conn_filesearchtool,names{n1}}); end
    conn_filesearchtool(h.folder,[],'folder');
else,
    h=get(varargin{1},'userdata');
    switch(varargin{3}),
        case {'folder','filter','files'},
            pathname=fliplr(deblank(fliplr(deblank(get(h.folder,'string')))));
            if strcmp(varargin{3},'files'),
				%disp(get(h.files,'value'))
                filename=get(h.files,'string');
                filename=filename(get(h.files,'value'),:);
                if isempty(filename), return; end
                filename=fliplr(deblank(fliplr(deblank(filename(1,:)))));
                if strcmp(filename,'..'),
                    idx=find(pathname==filesep); idx(idx==length(pathname))=[];
                    if ~isempty(idx), pathname=pathname(1:idx(end)-1); else, return; end
                else,
                    pathname=fullfile(pathname,filename);
                end
            end
            if isdir(pathname) || isempty(dir(pathname)),
                results='   ..'; 
                names=dir(pathname);
                for n1=1:length(names), if names(n1).isdir&&~strcmp(names(n1).name,'.')&&~strcmp(names(n1).name,'..'), results=strvcat(results,['   ',names(n1).name]); end; end
                filter=get(h.filter,'string');
                [filternow,filter]=strtok(filter,';');
                while ~isempty(filternow),
                    filename=fullfile(pathname,fliplr(deblank(fliplr(deblank(filternow)))));
                    names=dir(filename);
                    for n1=1:length(names), if ~names(n1).isdir, results=strvcat(results,names(n1).name); end; end
                    [filternow,filter]=strtok(filter,';');
                end
                set(h.files,'string',results,'value',min(size(results,1),get(h.files,'value')));
                set(h.folder,'string',pathname);
            elseif ~isempty(h.callback), 
                idx=get(h.files,'value');
                names=get(h.files,'string');
                if ~isempty(idx) & size(names,1)>=max(idx),
                    names=names(idx,:);
                    pathname=fliplr(deblank(fliplr(deblank(get(h.folder,'string')))));
                    if isempty(pathname)||pathname(end)~=filesep, pathname=[pathname,filesep]; end
                    names=[repmat(pathname,[size(names,1),1]),names];
                    if iscell(h.callback),
                        if length(h.callback)>1, feval(h.callback{1},h.callback{2:end},names); else, feval(h.callback{1},names); end
                    else, feval(h.callback,names); end
                end
            end
        case {'find'}
            state=get(h.find,'value'); 
            if state,
                results=get(h.files,'string');results=results(find(results(:,1)==' '),:);
                set(h.find,'string','Cancel');
                pathname=fliplr(deblank(fliplr(deblank(get(h.folder,'string')))));
                filter=get(h.filter,'string');
                set(h.files,'string',results,'value',1);
                dirtree(pathname,filter,h,length(pathname)+1);
                set(h.find,'value',0,'string','Find');
            else,
                set(h.find,'value',0,'string','Find');
            end
    end
end


function dirtree(pathname,filter,h,L);

if ~get(h.find,'value'), return; end
filterrest=filter;
[filternow,filterrest]=strtok(filterrest,';');
while ~isempty(filternow),
    filename=fullfile(pathname,fliplr(deblank(fliplr(deblank(filternow)))));
    dir0=dir(filename);
    [names,idx]=sortrows(strvcat(dir0(:).name));
    for n1=1:length(dir0),
        if ~dir0(idx(n1)).isdir,
            txt=strvcat(get(h.files,'string'),fullfile(pathname(L+1:end),dir0(idx(n1)).name));
            if size(txt,1)<1e4, % Change this value to increase the maximum number of files displayed
                set(h.files,'string',txt);
            else, return; end
        end
    end
    [filternow,filterrest]=strtok(filterrest,';');
end
drawnow;
dir0=dir(pathname);
[names,idx]=sortrows(strvcat(dir0(:).name));
for n1=1:length(dir0),
    if dir0(idx(n1)).isdir && ~strcmp(dir0(idx(n1)).name,'.') && ~strcmp(dir0(idx(n1)).name,'..'),
        dirtree(fullfile(pathname,dir0(idx(n1)).name),filter,h,L);
    end
end

