function out=conn_importspm(spmfiles);
% Imports experiment info from SPM.mat files
%

global CONN_x;
if nargin>0,
    if ~iscell(spmfiles),spmfiles=cellstr(spmfiles);end
    nsubjects=length(spmfiles);
    if nsubjects~=CONN_x.Setup.nsubjects, CONN_x.Setup.nsubjects=conn_merge(CONN_x.Setup.nsubjects,nsubjects); end
    for nsub=1:nsubjects,
        filename=fliplr(deblank(fliplr(deblank(spmfiles{nsub}))));
        CONN_x.Setup.spm{nsub}=conn_file(filename);
    end
end
%CONN_x.Setup.nsessions=zeros(1,CONN_x.Setup.nsubjects);
changed=0;err=0;
for nsub=1:CONN_x.Setup.nsubjects,
	if ~isempty(CONN_x.Setup.spm{nsub}{1}), 
		%try,
			spmfile=load(CONN_x.Setup.spm{nsub}{1});
			if isfield(spmfile.SPM,'xBF')&&isfield(spmfile.SPM.xBF,'UNITS'), 
				units=spmfile.SPM.xBF.UNITS; 
				if strcmp(units,'scans'), units=1;
				elseif strcmp(units,'secs'), units=2; 
				else, disp(['warning: importing from ',CONN_x.Setup.spm{nsub}{1},': invalid SPM.xBF.UNITS value (assuming scans)']); err=err+1; end
			else, disp(['warning: importing from ',CONN_x.Setup.spm{nsub}{1},': SPM.xBF.UNITS not found (assuming scans)']); units=1; err=err+1; end
			if isfield(spmfile.SPM,'xY')&&isfield(spmfile.SPM.xY,'RT'), CONN_x.Setup.RT=spmfile.SPM.xY.RT; else, disp(['warning: importing from ',CONN_x.Setup.spm{nsub}{1},': SPM.xY.RT not found (leaving unchanged)']); err=err+1; end
			if ~isfield(spmfile.SPM,'nscan'), disp(['warning: importing from ',CONN_x.Setup.spm{nsub}{1},': SPM.nscan not found (stopped importing for this subject)']); err=err+1; 
			else, nsess=length(spmfile.SPM.nscan); 
				CONN_x.Setup.nsessions(nsub)=nsess;
				for nses=1:nsess,
					begin=1;
					idx=spmfile.SPM.Sess(nses).row;
					filename=fliplr(deblank(fliplr(deblank(spmfile.SPM.xY.P(idx,:)))));
					switch(filesep),case '\',idx=find(filename=='/');case '/',idx=find(filename=='\');end; filename(idx)=filesep;
					n=0; while n<size(filename,1),
						ok=dir(deblank(filename(n+1,:)));
						if ~isempty(ok), n=n+1;
						else,
							if begin && changed, begin=0;
							else,
								fullname1=deblank(filename(n+1,:));
								[pathname1,name1,ext1]=fileparts(fullname1);
								[name2,pathname2]=uigetfile(['*.',ext1],['File not found: ',name1,ext1],['*',name1,ext1]);
								fullname2=fullfile(pathname2,name2);
								changed=1;begin=0;
							end
							fullnamematch=strvcat(fliplr(fullname1),fliplr(fullname2));
							m=sum(cumsum(fullnamematch(1,:)~=fullnamematch(2,:))==0);
							m1=max(0,length(fullname1)-m); m2=max(0,length(fullname2)-m);
							filename=strvcat(filename(1:n,:),[repmat(fullname2(1:m2),[size(filename,1)-n,1]),filename(n+1:end,m1+1:end)]);
						end
					end
					[V,str,icon]=conn_getinfo(filename);
					CONN_x.Setup.functional{nsub}{nses}={filename,str,icon};
                    CONN_x.Setup.nscans{nsub}{nses}=prod(size(V));
					nconditions=length(spmfile.SPM.Sess(nses).U);
					for ncondition=1:nconditions,
						name=spmfile.SPM.Sess(nses).U(ncondition).name{1};
						idx=strmatch(name,CONN_x.Setup.conditions.names,'exact');
						if isempty(idx), idx=length(CONN_x.Setup.conditions.names); CONN_x.Setup.conditions.names{end+1}=' '; end
						CONN_x.Setup.conditions.names{idx}=name;
						if units==2,
							CONN_x.Setup.conditions.values{nsub}{idx}{nses}{1}=spmfile.SPM.Sess(nses).U(ncondition).ons;
							CONN_x.Setup.conditions.values{nsub}{idx}{nses}{2}=spmfile.SPM.Sess(nses).U(ncondition).dur;
						else,
							CONN_x.Setup.conditions.values{nsub}{idx}{nses}{1}=(spmfile.SPM.Sess(nses).U(ncondition).ons-1)*CONN_x.Setup.RT;
							CONN_x.Setup.conditions.values{nsub}{idx}{nses}{2}=spmfile.SPM.Sess(nses).U(ncondition).dur*CONN_x.Setup.RT;
						end
					end
					if isfield(spmfile.SPM.Sess(nses),'C'),
						name='SPM covariates';
						idx=strmatch(name,CONN_x.Setup.l1covariates.names,'exact');
						if isempty(idx), idx=length(CONN_x.Setup.l1covariates.names); CONN_x.Setup.l1covariates.names{end+1}=' '; end
						CONN_x.Setup.l1covariates.names{idx}=name;
						CONN_x.Setup.l1covariates.files{nsub}{idx}{nses}={'[raw values]',[],spmfile.SPM.Sess(nses).C.C};
                    elseif ~isempty(dir(conn_prepend('rp_',deblank(filename(1,:)),'.mat'))),
						name='realignment';
						idx=strmatch(name,CONN_x.Setup.l1covariates.names,'exact');
						if isempty(idx), idx=length(CONN_x.Setup.l1covariates.names); CONN_x.Setup.l1covariates.names{end+1}=' '; end
						CONN_x.Setup.l1covariates.names{idx}=name;
						CONN_x.Setup.l1covariates.files{nsub}{idx}{nses}=conn_file(conn_prepend('rp_',deblank(filename(1,:)),'.mat'));
                    end
                    if ~isempty(dir(conn_prepend('art_regresion_outliers_',deblank(filename(1,:)),'.mat'))),
						name='ART covariates';
						idx=strmatch(name,CONN_x.Setup.l1covariates.names,'exact');
						if isempty(idx), idx=length(CONN_x.Setup.l1covariates.names); CONN_x.Setup.l1covariates.names{end+1}=' '; end
						CONN_x.Setup.l1covariates.names{idx}=name;
						CONN_x.Setup.l1covariates.files{nsub}{idx}{nses}=conn_file(conn_prepend('art_regresion_outliers_',deblank(filename(1,:)),'.mat'));
                    end
			end
		end
	%catch,
	%	disp(['warning: importing from ',CONN_x.Setup.spm{nsub}{1},': unexpected error (stopped importing for this subject)']); 
	%	err=err+1;
	%	disp(lasterr);
	%end
end
end
if isfield(CONN_x,'gui')&&isnumeric(CONN_x.gui)&&CONN_x.gui, 
    if ~err, uiwait(msgbox([num2str(CONN_x.Setup.nsubjects),' subjects imported with no errors'],'Done'));
    else, uiwait(msgbox(['Import finished with ',num2str(err),' errors'],'WARNING!')); end
end
if nargout,out=CONN_x;end
