function conn_update(ver,force)
global CONN_x

if nargin<1||isempty(ver),if isfield(CONN_x,'ver'),ver=CONN_x.ver;else,ver=[];end;end
path0=fileparts(which('conn'));
url0='http://www.nitrc.org';
url1='/projects/conn/';

if isfield(CONN_x,'ver'),
    version_conn=regexp(ver,'(\d.*?)\.(\w)','tokens','once');
    if iscell(version_conn)&&length(version_conn)==2,txt=['CONN - fMRI functional connectivity version ',version_conn{1},'.',version_conn{2}];
    else,txt='';end
else,
    txt='';
end
conn_update_disp({txt,'Checking for updates. Please wait...'});
[s,ok]=urlread([url0,url1]);

if ~ok, conn_update_disp(['Cannot access ',[url0,url1],' to check for updates. Please try again later']);
else,
    version_url=regexp(s,'conn v\.(\d.*?)\.(\w)','tokens','once');
    if isfield(CONN_x,'ver'),
        if iscell(version_conn) && length(version_conn)==2 && (str2num(version_url{1})<str2num(version_conn{1}) || (str2num(version_url{1})==str2num(version_conn{1}) && (version_url{2})<=(version_conn{2}))), samever=1; else,samever=0;end
        if nargin>1&&force,samever=0;end
        if samever,
            conn_update_disp({['Your version (',version_conn{1},'.',version_conn{2},') is up to date']});
        else,
            if 0,% only check / do not offer to download 
                conn_update_disp({txt,['Update (',version_url{1},'.',version_url{2},') available at ',url0,url1]});
            else,
                conn_update_disp({txt,['Update (',version_url{1},'.',version_url{2},') available at ',url0,url1]});
                answ=questdlg({['Update (',version_url{1},'.',version_url{2},') available at ',url0,url1],'Download and install now?'},'conn update','Yes', 'No', 'Yes');
                if strcmp(answ,'Yes'),
                    connversion={'CONN fMRI connectivity tool'};
                    hfig=findobj('tag',connversion{1});
                    if ~isempty(hfig)&&ishandle(hfig),
                        answ=questdlg({'This process will close your current CONN session','Any unsaved data will be lost','Do you want to continue?'},'conn update','Yes', 'No', 'Yes');
                    else, answ='Yes';end
                    if strcmp(answ,'Yes'),
                        %group_id=regexp(s,'frs/\?group_id=(\d+)">Files','tokens','once');
                        group_id=regexp(s,'frs/\?group_id=(\d+)">','tokens','once');
                        url2=['/frs/?group_id=',group_id{1}];
                        conn_update_disp('Accessing download page... ');
                        [s2,ok]=urlread([url0,url2]);
                        
                        file_id=regexp(s2,['/frs/download\.php/(\d+)/conn',version_url{1},version_url{2},'\.zip'],'tokens','once');
                        url3=['/frs/download.php/',file_id{1},'/conn',version_url{1},version_url{2},'.zip'];
                        [nill,temp]=fileparts(fileparts(path0));if length(version_conn)==2&&strcmp(temp,['conn',version_conn{1},version_conn{2}]),path1=fileparts(path0);else,path1=path0;end
                        path1=fullfile(fileparts(path1),['conn',version_url{1},version_url{2}]);
                        [ok,ko]=mkdir(fileparts(path1),['conn',version_url{1},version_url{2}]);
                        ok=0;while ~ok,
                            path1=uigetdir(path1,'Select a directory to install the new version');
                            if isequal(path1,0),break;end
                            [ok,ko]=mkdir(fileparts(path1),['conn',version_url{1},version_url{2}]);
                            if ~ok,
                                conn_update_disp(['Unable to create directory ',path1,' - check permissions']);
                            end
                        end
                        if ~isequal(path1,0),
                            fileattrib(path1,'+w','a','s');
                            conn_update_disp('Downloading new version. Please wait...');
                            unzip([url0,url3],path1);
                            conn_update_disp(['New version (',version_url{1},'.',version_url{2},') successfully downloaded at ',path1]);
                            %unzip(['http://web.mit.edu/swg/conn',version_url{1},version_url{2},'.zip'],path1);
                            path2=fileparts(conn_dir(fullfile(path1,'conn.m')));
                            conn close;
                            rmpath(path0);
                            addpath(path2);
                            conn;
                            ko=savepath;
                            if ko, conn_update_disp({['Not possible to save MATLAB path. Check file permissions.'],['To use this new release in future MATLAB sessions type:'],['   addpath ',path2]}); 
                            else, conn_update_disp({['Update (',version_url{1},'.',version_url{2},') successfully installed'],['Saved new MATLAB path: ',path2],['You can delete if you wish the previous version at ',path0]}); end
                        else,conn_update_disp(['Installation cancelled']);end
                    end
                end
            end
        end
    else,
        conn_update_disp({['CONN version ',version_url{1},'.',version_url{2},' available at ',url0,url1]});
    end
end

    function conn_update_disp(varargin)
        persistent h;
        if isfield(CONN_x,'gui')&&~isstruct(CONN_x.gui)&&CONN_x.gui,
            if ~isempty(h)&&ishandle(h),close(h);end
            h=msgbox(varargin{1},'conn_update');
        else,
            disp(char(varargin{:}));
        end
        
    end

end
