
function [dataplot,infoplot,data1plot]=conn_vproject(a,b,c,views,projection,thres,res,box,select,mat,threshold,data1plot,spmfile);
%CONN_VPROJECT Volume display
%
if numel(a)==1 && ishandle(a), % callbacks from UI objects
    init=0;
    GCF=gcf;
    if isstruct(b), ARG=b; end;
	OPTION=c; 
    if isempty(OPTION), return; end
    DATA=get(GCF,'userdata');
    a=DATA.a;
    b=DATA.b;
    c=DATA.c;
    projection=DATA.projection;
    thres=DATA.thres;
    threshold=DATA.threshold;
    res=DATA.res;
    box=DATA.box;
    views=DATA.views;
    select=DATA.select;
    mat=DATA.mat;
    spmfile=DATA.spmfile;
    data1plot=[];
    if isstruct(OPTION),
    else,
        switch(OPTION),
            case 'buttondown',
                xlim=get(DATA.axes,'xlim');ylim=get(DATA.axes,'ylim');xpos=get(DATA.axes,'currentpoint');
                if xpos(1,1)>=xlim(1)&&xpos(1,1)<=xlim(2)&&xpos(1,2)>=ylim(1)&&xpos(1,2)<=ylim(2),
                    DATA.buttondown=get(0,'pointerlocation');
                    DATA.selectiontype=get(GCF,'selectiontype');
                    set(GCF,'windowbuttonmotionfcn',{@conn_vproject,'buttonmotion'},'userdata',DATA);
                    res=DATA.res*3;
                    box=1;
                else, DATA.buttondown=[]; set(GCF,'userdata',DATA); return; end
            case 'buttonup',
                p1=DATA.buttondown;
                if ~isempty(p1),
                    p2=get(0,'pointerlocation')-p1;
                    if strcmp(DATA.selectiontype,'extend'),
                        ang=-.005*(p2(2)+p2(1));projection([1,2],:)=[cos(ang),sin(ang);-sin(ang),cos(ang)]*projection([1,2],:);
                    else,
                        %ang=.01*p2(2);projection([2,3],:)=[cos(ang),sin(ang);-sin(ang),cos(ang)]*projection([2,3],:);
                        ang=-.01*p2(1);projection([1,3],:)=[cos(ang),sin(ang);-sin(ang),cos(ang)]*projection([1,3],:);
                    end
                    DATA.projection=projection;
                    set(GCF,'windowbuttonmotionfcn',[],'userdata',DATA);
                else, return; end
            case 'buttonmotion',
                p1=DATA.buttondown;
                p2=get(0,'pointerlocation')-p1;
                if strcmp(DATA.selectiontype,'extend'),
                    ang=-.005*(p2(2)+p2(1));projection([1,2],:)=[cos(ang),sin(ang);-sin(ang),cos(ang)]*projection([1,2],:);
                else,
                    %ang=.01*p2(2);projection([2,3],:)=[cos(ang),sin(ang);-sin(ang),cos(ang)]*projection([2,3],:);
                    ang=-.01*p2(1);projection([1,3],:)=[cos(ang),sin(ang);-sin(ang),cos(ang)]*projection([1,3],:);
                end
                res=DATA.res*3;
                box=1;
            case 'resolution',
                res=str2num(get(DATA.handles(2),'string'));
                if isempty(res), res=DATA.res; end
                set(DATA.handles(2),'string',num2str(res));
                DATA.res=res;
                set(GCF,'userdata',DATA);
                init=-1;
            case 'threshold',
                threshold=str2num(get(DATA.handles(4),'string'));
                if isempty(threshold), threshold=DATA.threshold; end
                set(DATA.handles(4),'string',num2str(threshold));
                DATA.threshold=threshold;
                set(GCF,'userdata',DATA);
                init=-1;
            case 'keypress',
                switch(lower(ARG.Character)),
                    case 'y',
                        DATA.rotation=DATA.rotation+[10,0,0]*(2*(length(ARG.Modifier)>0)-1);
                    case 'x',
                        DATA.rotation=DATA.rotation+[0,10,0]*(2*(length(ARG.Modifier)>0)-1);
                    case 'z',
                        DATA.rotation=DATA.rotation+[0,0,10]*(2*(length(ARG.Modifier)>0)-1);
                    otherwise,
                        return;
                end
                ang=-.01*DATA.rotation(1);projection([1,3],:)=[cos(ang),sin(ang);-sin(ang),cos(ang)]*projection([1,3],:);
                ang=.01*DATA.rotation(2);projection([2,3],:)=[cos(ang),sin(ang);-sin(ang),cos(ang)]*projection([2,3],:);
                ang=-.01*DATA.rotation(3);projection([1,2],:)=[cos(ang),sin(ang);-sin(ang),cos(ang)]*projection([1,2],:);
                DATA.rotation=[0,0,0];
                DATA.projection=projection;
                set(GCF,'windowbuttonmotionfcn',[],'userdata',DATA);
            case 'selectroi'
                selectcluster=get(DATA.handles(8),'value');
                if selectcluster>length(DATA.clusters), select=[]; else, select=DATA.clusters{selectcluster}; end
                DATA.select=select; DATA.selectcluster=selectcluster; set(GCF,'userdata',DATA);
                init=-2;
            case 'vox-thr',
                temp=str2num(get(DATA.handles(2),'string'));
                if ~isempty(temp), thres{1}=temp; else, set(DATA.handles(2),'string',num2str(thres{1})); end
                thres{2}=get(DATA.handles(3),'value');
                DATA.selectcluster=[];
                DATA.thres=thres;set(GCF,'userdata',DATA);
                init=-1;
            case 'clu-thr',
                temp=str2num(get(DATA.handles(5),'string'));
                if ~isempty(temp), thres{3}=temp; else, set(DATA.handles(5),'string',num2str(thres{3})); end
                thres{4}=get(DATA.handles(6),'value');
                DATA.selectcluster=[];
                if thres{4}==4, set(DATA.handles(4),'string','extent threshold: cluster k ='); else, set(DATA.handles(4),'string','extent threshold: cluster p ='); end
                DATA.thres=thres;set(GCF,'userdata',DATA);
                init=-1;
            case 'export_mask',
                [filename,filepath]=uiputfile('*.nii','Save mask as');
                if ischar(filename),
                    V=struct('mat',mat{1},'dim',size(b(:,:,:,1)),'dt',[spm_type('float32') spm_platform('bigend')],'fname',fullfile(filepath,filename));
                    V=spm_write_vol(V,b(:,:,:,end).*double(b(:,:,:,end)>0));
                    if ~isempty(spmfile),
                        s = questdlg('Mask saved. Explore mask results?', ...
                            'ROI_EXTRACT', ...
                            'Yes','No','Yes');
                        if ~strcmp(s,'No'),
                            [spmfile_path,spmfile_name]=fileparts(spmfile);
                            cwd=pwd;cd(spmfile_path);
                            conn_rex(spmfile,fullfile(filepath,filename),'output_type','saverex','level','clusters','select_clusters',0,'steps',{'extract','results'},'s',[],'gui',0);
                            %roi_extract(spmfile,fullfile(filepath,filename),'output_type','text','select_clusters','each','steps',{'extract'});
                            cd(cwd);
                        end
                    end
                end
                return;
            case 'export_stats',
                [filename,filepath]=uiputfile('*.txt','Save stats as');
                if ischar(filename),
                    txt=strvcat(get(DATA.handles(7),'string'),DATA.txt);
                    h=fopen(fullfile(filepath,filename),'wt');
                    for n1=1:size(txt,1), fprintf(h,'%s\n',txt(n1,:)); end
                    fclose(h);
                end
                return;
            case 'switch',
                side=get(DATA.handles(11),'value');
                if side~=DATA.side,
                    switch(side),
                        case 1, b=c;
                        case 2, b=1-c;
                        case 3, b=2*min(c,1-c);
                    end
                    b(b==0)=nan; b=-log(b);
                    DATA.side=side;
                    %b=-log(1-exp(-DATA.b(:,:,:,1)));
                    %DATA.side=-DATA.side;
                    init=-1;
                    DATA.selectcluster=[];
                end
            otherwise,
                return
        end
    end
else, %called not from UI 
    init=1;
    if nargin<10 || isempty(mat), mat={eye(4),numel(a)}; end
    if nargin<9 || isempty(select), select=[]; end
    if nargin<8 || isempty(box), box=0; end
    if nargin<7 || isempty(res), res=1; end
    if nargin<6 || isempty(thres), thres={.05,1,1,1}; end
    if nargin<5 || isempty(projection), projection=[-1,0,0;0,0,-1;0,-1,0]; end; 
    %if nargin<3 || isempty(projection), projection=[-0.3529,0.9347,-0.0429;0.0247,-0.0365,-0.9990;-0.9353,-0.3537,-0.0103]; end
    if nargin<4 || isempty(views), views='full'; end
    if nargin<3, c=[]; end
    if nargin<2, b=[]; end
    if nargin<1 || isempty(a), a=spm_read_vols(spm_vol(fullfile(fileparts(which('spm')),'apriori','grey.nii'))); end
    if nargin<11 || isempty(threshold), if isempty(b), threshold=[nanmean(a(:))]; else, threshold=[nanmean(a(:)),2]; end; end
    if nargin<12 || isempty(data1plot), data1plot=[]; end
    if nargin<13 || isempty(spmfile), spmfile=[]; end


    GCF=gcf;
    if ~strcmp(views,'none'), 
        a(:,:,[1,end],1)=0;a(:,[1,end],:,1)=0;a([1,end],:,:,1)=0;
        clf; 
        DATA.a=a;
        DATA.b=b;
        DATA.c=c;
        DATA.projection=projection;
        DATA.thres=thres;
        DATA.threshold=threshold;
        DATA.res=res;
        DATA.box=box;
        DATA.views=views;
        DATA.rotation=[0,0,0];
        DATA.selectcluster=[];
        DATA.select=select;
        DATA.mat=mat;
        DATA.clusters={[]};
        DATA.side=1;
        DATA.spmfile=spmfile;
    end
end

if init>0, % initialize
    %map=[gray(64).^2;.5*repmat([1,1,0],[64,1])+.5*((gray(64).^2)*diag([1,1,0]));.5*repmat([1,0,0],[64,1])+.5*((gray(64).^2)*diag([1,0,0]))];
    %map=[.5+.5*(gray(64).^2);.5*repmat([1,1,0],[64,1])+.5*((gray(64).^.5)*diag([1,1,0]));.5*repmat([0,0,1],[64,1])+.5*((gray(64).^.5)*diag([0,0,1]))];map(1,:)=1;
    map=[.25+.75*(gray(64).^2)*diag([1,1,1]);0*repmat([1,1,1],[64,1])+1*((gray(64).^1)*diag([1,0,0]));.25*repmat([1,1,0],[64,1])+.75*((gray(64).^.5)*diag([1,1,0]))];map(1,:)=.25;
    switch(views),
        case 'full',
            clf;
            if isempty(b),
                DATA.handles=[uicontrol('style','text','units','norm','position',[.6,.95,.1,.05],'string','resolution','backgroundcolor','w','foregroundcolor','b'),...
                    uicontrol('style','edit','units','norm','position',[.7,.95,.1,.05],'string',num2str(DATA.res),'callback',{@conn_vproject,'resolution'},'backgroundcolor','w','foregroundcolor','k'),...
                    uicontrol('style','text','units','norm','position',[.8,.95,.1,.05],'string','threshold','backgroundcolor','w','foregroundcolor','b'),...
                    uicontrol('style','edit','units','norm','position',[.9,.95,.1,.05],'string',num2str(DATA.threshold),'callback',{@conn_vproject,'threshold'},'backgroundcolor','w','foregroundcolor','b')];
                DATA.axes=subplot(122); set(DATA.axes,'units','norm','position',[.55,.1,.4,.8],'visible','off');
                set(GCF,'name','Volume display','numbertitle','off','color','w','units','norm','position',[.1,.5,.8,.4],'interruptible','off','busyaction','cancel','windowbuttondownfcn',{@conn_vproject,'buttondown'},'windowbuttonupfcn',{@conn_vproject,'buttonup'},'windowbuttonmotionfcn',[],'keypressfcn',{@conn_vproject,'keypress'},'colormap',map,'userdata',DATA);
            else,
                uicontrol('style','frame','units','norm','position',[.39,.87,.45,.11],'backgroundcolor',.9*[1,1,1]);
                DATA.handles=[...
                    uicontrol('style','text','units','norm','position',[.40,.92,.15,.04],'string','height threshold: voxel p =','foregroundcolor','k','backgroundcolor',.9*[1,1,1]),...
                    uicontrol('style','edit','units','norm','position',[.55,.93,.05,.03],'string',num2str(thres{1}),'callback',{@conn_vproject,'vox-thr'}),...
                    uicontrol('style','popupmenu','units','norm','position',[.625,.935,.1,.03],'string',{'p-uncorrected','p-FDR corrected'},'callback',{@conn_vproject,'vox-thr'},'value',thres{2}),...
                    uicontrol('style','text','units','norm','position',[.4,.88,.15,.04],'string','extent threshold: cluster p =','foregroundcolor','k','backgroundcolor',.9*[1,1,1]),...
                    uicontrol('style','edit','units','norm','position',[.55,.89,.05,.03],'string',num2str(thres{3}),'callback',{@conn_vproject,'clu-thr'}),...
                    uicontrol('style','popupmenu','units','norm','position',[.625,.895,.1,.03],'string',{'p-uncorrected','p-FWE corrected','p-FDR corrected','k-value'},'callback',{@conn_vproject,'clu-thr'},'value',thres{4}),...
                    uicontrol('style','text','units','norm','position',[.05,.50,.925,.025],'string',sprintf('%18s%15s%15s%15s%15s%15s%15s','Clusters (x,y,z)','k','cluster p-unc','cluster p-FWE','cluster p-FDR','voxel p-unc','voxel p-FDR'),'backgroundcolor','w','foregroundcolor','b','horizontalalignment','left','fontname','monospaced','fontsize',8),...
                    uicontrol('style','listbox','units','norm','position',[.05,.05,.925,.45],'string','','backgroundcolor','w','foregroundcolor','k','horizontalalignment','left','fontname','monospaced','fontsize',8,'callback',{@conn_vproject,'selectroi'}),...
                    uicontrol('style','pushbutton','units','norm','position',[.875,.845,.1,.04],'string','export mask','callback',{@conn_vproject,'export_mask'}),...
                    uicontrol('style','pushbutton','units','norm','position',[.875,.885,.1,.04],'string','export stats','callback',{@conn_vproject,'export_stats'}),...
                    uicontrol('style','popupmenu','units','norm','position',[.875,.945,.1,.03],'string',{'positive contrast','negative contrast','two-sided'},'callback',{@conn_vproject,'switch'}),...
                    uicontrol('style','listbox','units','norm','position',[.62,.55,.355,.28],'string','','visible','off','backgroundcolor','w','foregroundcolor','k','horizontalalignment','left','max',2),...
                    uicontrol('style','text','units','norm','position',[.725,.92,.1,.04],'string','','foregroundcolor','k','backgroundcolor',.9*[1,1,1]),...
                    uicontrol('style','text','units','norm','position',[.725,.88,.1,.04],'string','','foregroundcolor','k','backgroundcolor',.9*[1,1,1])];
                    %uicontrol('style','text','units','norm','position',[.2,.30,.1,.025],'string','k','backgroundcolor','k','foregroundcolor','y','horizontalalignment','left'),...
                    %uicontrol('style','text','units','norm','position',[.3,.30,.1,.025],'string','voxel p-unc','backgroundcolor','k','foregroundcolor','y','horizontalalignment','left'),...
                    %uicontrol('style','text','units','norm','position',[.4,.30,.1,.025],'string','voxel p-cor','backgroundcolor','k','foregroundcolor','y','horizontalalignment','left'),...
                    %uicontrol('style','listbox','units','norm','position',[.2,.05,.1,.25],'string','','backgroundcolor','k','foregroundcolor','w','horizontalalignment','left'),...
                    %uicontrol('style','listbox','units','norm','position',[.3,.05,.1,.25],'string','','backgroundcolor','k','foregroundcolor','w','horizontalalignment','left'),...
                    %uicontrol('style','listbox','units','norm','position',[.4,.05,.1,.25],'string','','backgroundcolor','k','foregroundcolor','w','horizontalalignment','left')];
                if isempty(DATA.mat{2}), set(DATA.handles(6),'visible','off','value',4); DATA.thres{4}=4; DATA.thres{3}=10; thres=DATA.thres; set(DATA.handles(5),'string',num2str(thres{3})); set(DATA.handles(4),'string','extent threshold: cluster k ='); end
                DATA.axes=subplot(222);set(DATA.axes,'units','norm','position',[.40,.55,.2,.28],'visible','off');%[.55,.35,.4,.6],'visible','off');
                set(GCF,'name',['Volume display ',DATA.spmfile],'numbertitle','off','color','w','units','norm','position',[.1,.2,.8,.7],'interruptible','off','busyaction','cancel','windowbuttondownfcn',{@conn_vproject,'buttondown'},'windowbuttonupfcn',{@conn_vproject,'buttonup'},'windowbuttonmotionfcn',[],'keypressfcn',{@conn_vproject,'keypress'},'colormap',map,'userdata',DATA); 
            end
        case '3d',
            clf;
            DATA.handles=[uicontrol('style','text','units','norm','position',[0,0,.1,.05],'string','resolution','backgroundcolor','k','foregroundcolor','w'),...
                uicontrol('style','edit','units','norm','position',[.1,0,.1,.05],'string',num2str(DATA.res),'callback',{@conn_vproject,'resolution'},'backgroundcolor','k','foregroundcolor','w'),...
                uicontrol('style','text','units','norm','position',[.2,0,.1,.05],'string','threshold','backgroundcolor','k','foregroundcolor','w'),...
                uicontrol('style','edit','units','norm','position',[.3,0,.1,.05],'string',num2str(DATA.threshold),'callback',{@conn_vproject,'threshold'},'backgroundcolor','k','foregroundcolor','w')];
            DATA.axes=gca;set(DATA.axes,'visible','off');
            set(GCF,'name','Volume display','numbertitle','off','color','w','interruptible','off','busyaction','cancel','windowbuttondownfcn',{@conn_vproject,'buttondown'},'windowbuttonupfcn',{@conn_vproject,'buttonup'},'windowbuttonmotionfcn',[],'keypressfcn',{@conn_vproject,'keypress'},'colormap',map,'userdata',DATA);
        case 'orth',
            clf;
            DATA.handles=[uicontrol('style','text','units','norm','position',[0,0,.1,.05],'string','resolution','backgroundcolor','k','foregroundcolor','w'),...
                uicontrol('style','edit','units','norm','position',[.1,0,.1,.05],'string',num2str(DATA.res),'callback',{@conn_vproject,'resolution'},'backgroundcolor','k','foregroundcolor','w'),...
                uicontrol('style','text','units','norm','position',[.2,0,.1,.05],'string','threshold','backgroundcolor','k','foregroundcolor','w'),...
                uicontrol('style','edit','units','norm','position',[.3,0,.1,.05],'string',num2str(DATA.threshold),'callback',{@conn_vproject,'threshold'},'backgroundcolor','k','foregroundcolor','w')];
            DATA.axes=gca;set(DATA.axes,'visible','off');
            %DATA.axes=gca;
            set(GCF,'color','w','windowbuttondownfcn',[],'windowbuttonupfcn',[],'windowbuttonmotionfcn',[],'keypressfcn',[],'colormap',map,'userdata',DATA);
        case 'none',
            if ~nargout, DATA.axes=gca;set(DATA.axes,'visible','off'); end
            %DATA.axes=gca;
            %set(GCF,'color','w','userdata',DATA);
    end
end

% display
if strcmp(views,'full'),
    if init~=0, % redraws orth views
        if ~isempty(b),%length(threshold)>1,
            if isempty(DATA.clusters)||init~=-2, % compute/display stats
                bnew=b(:,:,:,1);bnew(~a)=nan;%bnew(a<=threshold(1))=nan;
                [bnew,txt,xyzpeak,clusters,clusternames,ithres]=vproject_display(bnew,threshold,thres,mat);
                if DATA.side>2, ithres(1)=spm_invTcdf(1-(1-spm_Tcdf(ithres(1),mat{3}(2)))/2,mat{3}(2)); end
                b(:,:,:,2)=bnew; threshold(3)=0;%.5;
                %for n1=1:4, set(DATA.handles(8+n1),'string',strvcat(txt{n1})); end
                set(DATA.handles(8),'string',strvcat(txt,' '),'value',max(1,min(size(txt,1)+1,get(DATA.handles(8),'value'))));
                DATA.stdprojections=cell(1,4); 
                DATA.txt=txt;
                DATA.clusternames=clusternames;
                DATA.ithres=ithres;
            else,
                clusters=DATA.clusters;
                xyzpeak=DATA.xyzpeak;
                clusternames=DATA.clusternames;
            end
            if isfield(DATA,'selectcluster'), selectcluster=DATA.selectcluster;else, selectcluster=get(DATA.handles(8),'value'); end
            if selectcluster<=length(clusters), select=clusters{selectcluster}; clusternames=clusternames{selectcluster}.txt; 
            elseif (isempty(selectcluster)||selectcluster==length(clusters)+1)&&~isempty(clusternames), select=[]; clusternames=clusternames{length(clusters)+1}.txt; 
            else, select=[]; clusternames=[]; end
        end
        %M={[-1,0,0;0,0,-1;0,-1,0],[0,-1,0;0,0,-1;-1,0,0],[-1,0,0;0,1,0;0,0,1]};
        M={[1,0,0;0,0,-1;0,1,0],[0,-1,0;0,0,-1;1,0,0],[1,0,0;0,-1,0;0,0,-1]};
        set(GCF,'pointer','watch'); drawnow
        if ~isfield(DATA,'stdprojections') || init==-1, DATA.stdprojections=cell(1,4); end
        tplot={};infoplot={};for n1=1:3, [tplot{n1},infoplot{n1},DATA.stdprojections{n1}]=conn_vproject(a,b,c,'none',M{n1},thres,res,0,select,mat,threshold,DATA.stdprojections{n1}); end; 
        %tplot=[tplot{1},tplot{2};tplot{3},ones(size(tplot{3},1),size(tplot{2},2))];
        tplot=cat(1,cat(2,tplot{1},tplot{2}),cat(2,tplot{3},tplot{1}(1)*ones([size(tplot{3},1),size(tplot{2},2),size(tplot{2},3)])));
        if ~isempty(b), h=subplot(3,4,1); set(h,'units','norm','position',[.05,.55,.3,.4]); else, h=subplot(3,4,1); set(h,'units','norm','position',[.05,.1,.4,.8]);end
        %pres=.5;image(1:pres:size(tplot,2),1:pres:size(tplot,1),round(max((ceil(tplot(1:pres:end,1:pres:end)/64)-1)*64+1,convn(convn(tplot(1:pres:end,1:pres:end),conn_hanning(7)/4,'same'),conn_hanning(7)'/4,'same'))));axis equal; axis off;
        pres=.25;conf=conn_hanning(2/pres+1);conf=conf/sum(conf); image(1:pres:size(tplot,2),1:pres:size(tplot,1),convn(convn(tplot(round(1:pres:end),round(1:pres:end),:),conf,'same'),conf','same'));axis equal; axis off;
        %image(round(convn(convn(tplot(round(1:.5:end),round(1:.5:end),:),conn_hanning(3)/2,'same'),conn_hanning(3)'/2,'same')));axis equal; axis off;
        %image(tplot);axis equal; axis off;
        data1plot=DATA.stdprojections{4};
        if ~isempty(clusternames),set(DATA.handles(12),'string',clusternames,'value',1,'visible','on');else,set(DATA.handles(12),'string','','value',1,'visible','off');end
        set(DATA.handles(13),'string',[' T_min = ',num2str(DATA.ithres(1),'%0.2f')]);
        set(DATA.handles(14),'string',[' k_min =',num2str(DATA.ithres(2))]);
        if ~isempty(b),
            DATA.b=b;DATA.threshold=threshold;DATA.xyzpeak=xyzpeak;DATA.infoplot=infoplot;DATA.select=select;DATA.clusters=clusters;%set(GCF,'userdata',DATA);
        end
    end
    %subplot(122);conn_vproject(a,'none',projection,threshold,res,box); 
    %if ~isempty(b), DATA.axes=subplot(222); else, DATA.axes=subplot(122); end
    set(DATA.axes,'visible','off');
    %views='none';
    set(GCF,'pointer','arrow');%,'userdata',DATA);
end
if strcmp(views,'orth'),
    %M={[-1,0,0;0,0,-1;0,-1,0],[0,-1,0;0,0,-1;-1,0,0],[-1,0,0;0,1,0;0,0,1]};
    M={[1,0,0;0,0,-1;0,1,0],[0,1,0;0,0,-1;1,0,0],[1,0,0;0,1,0;0,0,-1]};
    set(GCF,'pointer','watch'); drawnow
    for n1=1:3, subplot(2,2,n1);conn_vproject(a,b,c,'none',M{n1},threshold,res,box); end;
    set(GCF,'pointer','arrow');
else,
    if ~nargout, set(GCF,'pointer','watch'); drawnow; end
    % volume plot
	[dataplot,idx,mask,B,b2,res,data1plot]=vproject_view(a,b,c,projection,threshold,res,select,data1plot);
    %if size(dataplot,3)>1, dataplot=dataplot(:,:,1)+dataplot(:,:,2); end
    infoplot=struct('boundingbox',b2,'res',res,'size',[size(dataplot,1),size(dataplot,2)],'projection',projection);
    if ~nargout, 
        axes(DATA.axes);
        %image(dataplot);axis equal;axis off;
        pres=.25;conf=conn_hanning(2/pres+1);conf=conf/sum(conf); image(1:pres:size(dataplot,2),1:pres:size(dataplot,1),convn(convn(dataplot(round(1:pres:end),round(1:pres:end),:),conf,'same'),conf','same'));axis equal; axis off;
        %pres=.5;image(1:pres:size(dataplot,2),1:pres:size(dataplot,1),round(max((ceil(dataplot(1:pres:end,1:pres:end)/64)-1)*64+1,convn(convn(dataplot(1:pres:end,1:pres:end),conn_hanning(5)/3,'same'),conn_hanning(5)'/3,'same'))));axis equal; axis off;
        DATA.axes=gca;
        DATA.infoplot{4}=infoplot;DATA.stdprojections{4}=data1plot; set(GCF,'userdata',DATA);
        % bounding box
        if box,
            B3=B'*pinv(projection);
            B3=[1+(B3(:,1)-b2(1,1))/res, 1+(B3(:,2)-b2(1,2))/res, 1+(B3(:,3)-b2(1,3))/res];
            border={[1,3,7,5,1],[2,6,4,8,2],[1,3,2,8,1],[7,5,4,6,7]};
            [minBt3]=max(B3(:,3));
            for n0=1:length(border),
                for n1=1:length(border{n0})-1,
                    color=(B3(border{n0}(n1),3)==minBt3|B3(border{n0}(n1+1),3)==minBt3);
                    Bt1=linspace(B3(border{n0}(n1),1),B3(border{n0}(n1+1),1),100);
                    Bt2=linspace(B3(border{n0}(n1),2),B3(border{n0}(n1+1),2),100);
                    Bt3=linspace(B3(border{n0}(n1),3),B3(border{n0}(n1+1),3),100);
                    if color,
                        Bt1(Bt3>idx(max(1,min(prod(size(mask)), round(Bt2)+size(idx,1)*round(Bt1-1)))) & ...
                            mask(max(1,min(prod(size(mask)), round(Bt2)+size(idx,1)*round(Bt1-1)))) )=nan;
                    end
                    hold on; h=plot(Bt1,Bt2,'-'); set(h,'color',.25*[0,0,1],'linewidth',4-3*color);hold off;
                end
            end
        end
        set(GCF,'pointer','arrow');
    end
end

function [dataplot,idx,mask,B,b2,res,data1plot]=vproject_view(a,b,c,projection,threshold,res,select,data1plot);
%interpolate&project
if ~isempty(data1plot),
    mask=data1plot.mask;
    idx=data1plot.idx;
    trans=data1plot.trans;
    B=data1plot.B;
    b2=data1plot.b2;
else,
    if ~isempty(b), a=a+j*b(:,:,:,end); end
    [x1,y1,z1]=meshgrid((1:size(a,2))-(size(a,2)+1)/2,(1:size(a,1))-(size(a,1)+1)/2,(1:size(a,3))-(size(a,3)+1)/2);
    bb={[1,size(a,2)]-(size(a,2)+1)/2,[1,size(a,1)]-(size(a,2)+1)/2,[1,size(a,3)]-(size(a,3)+1)/2};
    B=[];for n1=1:8,B=[B,[bb{1}(1+rem(n1,2));bb{2}(1+rem(floor(n1/2),2));bb{3}(1+rem(floor(n1/4),2))]]; end
    B2=B'*pinv(projection);
    b2=[min(B2,[],1);max(B2,[],1)];
    %res=res*((prod(b2(2,:)-b2(1,:))./prod(size(a))).^(1/3));
    if 1,%faster&avoids memory problems
        nz2=b2(1,3):res:b2(2,3);
        [x2,y2]=meshgrid(b2(1,1):res:b2(2,1),b2(1,2):res:b2(2,2));
        N=numel(x2);
        d2=[x2(:),y2(:)]*projection(1:2,:);
        d2=d2-repmat([bb{2}(1),bb{1}(1),bb{3}(1)],[N,1]);
        d2=reshape(d2,[size(x2),3]);
        trans=zeros(size(x2));
        idx=zeros([size(x2),1+(length(threshold)>1)]);
        idx1=1:N;idx2=[];
        for n1=1:length(nz2),
            x3=round(d2(idx1)+nz2(n1)*projection(3,1));
            y3=round(d2(idx1+N)+nz2(n1)*projection(3,2));
            z3=round(d2(idx1+N*2)+nz2(n1)*projection(3,3));
            %a3=interp3(x1,y1,z1,a,x3,y3,z3,'nearest');
            %idxs=max(1,min(size(a,1), 1+round(y3-bb{2}(1)) )) + size(a,1)*max(0,min(size(a,2)-1, round(x3-bb{1}(1)) )) + size(a,1)*size(a,2)*max(0,min(size(a,3)-1, round(z3-bb{3}(1)) ));
            idxs=max(1,min(size(a,1), 1+y3 )) + size(a,1)*max(0,min(size(a,2)-1, x3 )) + size(a,1)*size(a,2)*max(0,min(size(a,3)-1, z3 ));
            a3=a(idxs);
            idx0=real(a3)>threshold(1)|imag(a3)>threshold(end);
            idx(idx1(idx0))=(length(nz2)+1-n1)/length(nz2);
            idx2=[idx2,idx1(idx0)];
            idx1=idx1(~idx0);
            if length(threshold)>1,
                x3=d2(idx2)+nz2(n1)*projection(3,1);
                y3=d2(idx2+N)+nz2(n1)*projection(3,2);
                z3=d2(idx2+N*2)+nz2(n1)*projection(3,3);
                %a3=interp3(x1,y1,z1,a,x3,y3,z3,'nearest');
                %idxt=max(1,min(size(a,1), 1+round(y3-bb{2}(1)) )) + size(a,1)*max(0,min(size(a,2)-1, round(x3-bb{1}(1)) )) + size(a,1)*size(a,2)*max(0,min(size(a,3)-1, round(z3-bb{3}(1)) ));
                idxt=max(1,min(size(a,1), 1+round(y3) )) + size(a,1)*max(0,min(size(a,2)-1, round(x3) )) + size(a,1)*size(a,2)*max(0,min(size(a,3)-1, round(z3) ));
                a3=a(idxt);
                if 0,
                    idx00=find(imag(a3)>threshold(end));
                    idx(N+idx2(idx00))=max(idx(N+idx2(idx00)),imag(a3(idx00))); %n1;
                    idxtrans=find(trans(idx2(idx00))==0);
                    trans(idx2(idx00(idxtrans)))=idxt(idx00(idxtrans));
                else,
                    idx00=find(imag(a3)>threshold(end));
                    idxtrans=find(~idx(N+idx2(idx00)));%idxtrans=find(imag(a3(idx00))>=idx(N+idx2(idx00)));
                    idx(N+idx2(idx00(idxtrans)))=(length(nz2)+1-n1)/length(nz2);%imag(a3(idx00(idxtrans)));
                    trans(idx2(idx00(idxtrans)))=idxt(idx00(idxtrans));
                end
                
                %idx2=idx2(~idx00);
            end
        end
        mask=(idx>0);
        %if any(any(mask(:,:,1)>0)), idx(~mask(:,:,1))=5*max(idx(mask(:,:,1)>0)); else, idx(~mask(:,:,1))=length(nz2); end
    else,
        [x2,y2,z2]=meshgrid(b2(1,1):res:b2(2,1),b2(1,2):res:b2(2,2),b2(1,3):res:b2(2,3));
        d=[x2(:),y2(:),z2(:)]*projection;
        x2=reshape(d(:,1),size(x2));
        y2=reshape(d(:,2),size(y2));
        z2=reshape(d(:,3),size(z2));
        %a2=interp3(x1,y1,z1,a,x2,y2,z2,'nearest');
        a2=a(max(1,min(size(a,1), 1+round(y2-bb{2}(1)) )) + size(a,1)*max(0,min(size(a,2)-1, round(x2-bb{1}(1)) )) + size(a,1)*size(a,2)*max(0,min(size(a,3)-1, round(z2-bb{3}(1)) )));
        [mask,idx]=max(a2>threshold,[],3);idx(~mask)=max(idx(mask>0));
    end
    data1plot.mask=mask;
    data1plot.idx=idx;
    data1plot.trans=trans;
    data1plot.B=B;
    data1plot.b2=b2;
end
conf1=conn_hanning(3)/2;conf1=conf1/sum(conf1);
conf2=conn_hanning(3)/2;conf2=conf2/sum(conf2);
if size(idx,3)==1, dataplot=-idx; dataplot=1+63*(dataplot-min(dataplot(:)))/(max(dataplot(:))-min(dataplot(:)));
else, 
    %dataplot1=-idx(:,:,1); dataplot1=1+63*(dataplot1-min(dataplot1(:)))/(max(dataplot1(:))-min(dataplot1(:)));
    %conjmask=mask(:,:,1)&mask(:,:,2);
    %dataplot2=-idx(:,:,2); dataplot2=1+63*(dataplot2-min(dataplot2(:)))/(max(dataplot2(:))-min(dataplot2(:)));
    %dataplot=dataplot1; dataplot(conjmask)=64+dataplot2(conjmask);
    if 1,
        dataplot1=idx(:,:,1);
        dataplot2=idx(:,:,2);
        %dataplot1=convn(convn(dataplot1,conf1,'same'),conf1','same');
        %dataplot2=convn(convn(dataplot2,conf2,'same'),conf2','same');
        k=.2;
        dataplotA=(dataplot2==0).*(k+(1-k)*dataplot1.^4) + (dataplot2>0).*(k+(1-k)*dataplot1.^4);
        dataplotB=(dataplot2==0).*dataplotA + (dataplot2>0).*(.5*dataplotA.*(dataplot2<=.9*dataplot1));
        %dataplotB=(dataplot2==0).*dataplotA + (dataplot2>0).*(0*(dataplot2>.95*dataplot1) + .5*dataplotA.*(dataplot2<=.95*dataplot1));
        dataplot=cat(3,dataplotA,dataplotB,dataplotB);
    else,
        dataplot1=idx(:,:,1);
        dataplot1=0+1*(dataplot1-min(dataplot1(~isinf(dataplot1))))/(max(dataplot1(~isinf(dataplot1)))-min(dataplot1(~isinf(dataplot1))));
        dataplot2=idx(:,:,2); if any(dataplot2(:)>0),mindataplot=.95*min(dataplot2(dataplot2>0));else,mindataplot=0;end;
        %dataplot2=dataplot2>mindataplot;
        dataplot2=max(0,dataplot2-mindataplot);
        dataplot2=convn(convn(dataplot2,conf1,'same'),conf1','same');
        dataplot2=0+1*dataplot2/max(eps,max(dataplot2(:)));
        %dataplot1=max(prctile(dataplot1(dataplot1<max(dataplot1(:))),5),dataplot1);dataplot2=max(0,dataplot1-dataplot2);
        %dataplot1=.75+.25*(dataplot1).^2;dataplot2=max(0,dataplot1-dataplot2);
        dataplot1=convn(convn(max(0,min(1,dataplot1)),conf2,'same'),conf2','same');
        dataplot1=0+1*(dataplot1).^4;
        %dataplotA=max(0,min(1, dataplot1+.25*(dataplot2>0)));dataplotB=max(0,min(1, dataplot1-dataplot2+.0*(dataplot2>0)));
        dataplotA=max(0,min(1, dataplot1.*(dataplot2==0)+(.25+dataplot1).*(dataplot2>0)));
        dataplotB=max(0,min(1, dataplot1.*(dataplot2==0)+(.25+dataplot1).*(.5-.5*dataplot2).*(dataplot2>0)));
        dataplot=cat(3,dataplotA,dataplotB,dataplotB);
        %idxback=find(all(dataplot<.1,3)); dataplot(idxback)=1;dataplot(idxback+size(dataplot,1)*size(dataplot,2))=1;dataplot(idxback+2*size(dataplot,1)*size(dataplot,2))=1;
        %dataplot=cat(3,dataplot1,dataplot2,dataplot2);
    end
end
if ~isempty(select),
    [transa,transb,transc]=unique(trans(:));%trans=a(c);
    [nill,idxp]=intersect(transa(:),select(:));
    d=logical(zeros(size(transa)));d(idxp)=1;
    e=find(d(transc));
    %%dataplot(e)=dataplot(e)+64;
    dataplot3=zeros([size(dataplot,1),size(dataplot,2)]);dataplot3(e)=1;dataplot3=convn(convn(dataplot3,conf1,'same'),conf1,'same');e=find(dataplot3>0);
    n=size(dataplot,1)*size(dataplot,2);
    dataplot(e+1*n)=dataplot(e+1*n).*(1-dataplot3(e))+dataplot(e+0*n).*(dataplot3(e));
    %dataplot(e+2*n)=dataplot(e+2*n).*(1-dataplot3(e))+dataplot(e+0*n).*(dataplot3(e));
end
if size(idx,3)~=1,
    n=size(dataplot,1)*size(dataplot,2);
    idxtemp1=find(dataplot2>0);
    idxtemp2=find(c(trans(idxtemp1))>.5);
    idxtemp=idxtemp1(idxtemp2);
    temp3=dataplot(idxtemp+2*n); 
    dataplot(idxtemp+2*n)=dataplot(idxtemp+0*n); 
    dataplot(idxtemp+0*n)=temp3;
end

function [anew,txt,xyzpeak,clusters,clusternames,ithres]=vproject_display(a,threshold,thres,mat);
persistent refsrois;
if isempty(refsrois),
    %filename=fullfile(fileparts(which('conn')),'utils','otherrois','talairach.nii');
    %filename=fullfile(fileparts(which('conn')),'rois','aal.nii');
    filename=fullfile(fileparts(which('conn')),'rois','BA.img');
    [filename_path,filename_name,filename_ext]=fileparts(filename);
    V=spm_vol(filename);
    refsrois=struct('filename',filename_name,'V',V,'data',spm_read_vols(V),'labels',{textread(fullfile(filename_path,[filename_name,'.txt']),'%s','delimiter','\n')});
    [x,y,z]=ndgrid(1:size(a,1),1:size(a,2),1:size(a,3));xyz=[x(:),y(:),z(:)];
    refsrois.data=spm_get_data(refsrois.V,pinv(refsrois.V.mat)*mat{1}*[xyz,ones(size(xyz,1),1)]');
    maxrefsrois=max(refsrois.data(:)); refsrois.count=hist(refsrois.data(:),0:maxrefsrois);
    refsrois.labels={'not-labeled',refsrois.labels{:}};
end

if nargin<4, mat={eye(4),numel(a)}; end
idx0=find(~isnan(a));
p=exp(-a(idx0));
P=a;P(idx0)=conn_fdr(p(:));
ithres=[nan,nan];

switch(thres{2}),
    case 1,%'vox-unc',
        % voxels above height threshold
        idxvoxels=find(a>-log(thres{1}));
        anew=zeros(size(a));anew(idxvoxels)=a(idxvoxels)+log(thres{1});%1;
        if ~isempty(idxvoxels),
            [xt,yt,zt]=ind2sub(size(a),idxvoxels);C=spm_clusters([xt,yt,zt]');c=hist(C,1:max(C));
        end
        u=spm_invTcdf(1-thres{1},mat{3}(2));
        ithres(1)=u;
    case 2,%'vox-FDR',
        idxvoxels=find(P<thres{1})  ;
        anew=zeros(size(a));anew(idxvoxels)=-log(P(idxvoxels))+log(thres{1});%1;
        if ~isempty(idxvoxels),
            [xt,yt,zt]=ind2sub(size(a),idxvoxels);C=spm_clusters([xt,yt,zt]');c=hist(C,1:max(C)); % C: cluster per voxel; c: #voxels per clusters
        end
        if isempty(idxvoxels), u=1; ithres(1)=inf;else, u=spm_invTcdf(1-exp(-min(a(idxvoxels))),mat{3}(2)); ithres(1)=u;end
end

txt=[];xyzpeak={};clusters={};clusternames={};
if ~isempty(idxvoxels),
    xyz=[xt,yt,zt];
    idx1=find(c>0);
    idxn=[];idx2={};for n1=1:length(idx1),idx2{n1}=find(C==(idx1(n1))); idxn(n1)=length(idx2{n1}); end
    [nill,sidxn]=sort(idxn(:));sidxn=flipud(sidxn);
    xyzpeak=cell(1,length(idx1));
    clusters=cell(1,length(idx1));
    k=zeros(1,length(idx1));cp=k;cP=k;cPFDR=k; minP=k;minp=k;
    for n1=1:length(idx1),
        k(n1)=idxn(sidxn(n1));
        clusters{n1}=idxvoxels(idx2{sidxn(n1)});
        [minP(n1),idxminp]=min(P(clusters{n1}));
        minp(n1)=exp(-max(a(clusters{n1})));
        xyzpeak{n1}=xyz(idx2{sidxn(n1)}(idxminp),:);
        if ~isempty(mat{2}),
            if isempty(mat{5}), [cP(n1),cp(n1)]=spm_P(1,k(n1)*mat{2}(end)/mat{4},u,mat{3},'T',mat{2},1,mat{4});
            else, [cP(n1),cp(n1)]=spm_P(1,k(n1)*mat{5},u,mat{3},'T',mat{2},1,mat{4}); end
        else, cP(n1)=nan;cp(n1)=nan; end
    end
    cPFDR=conn_fdr(cp);
    for n1=1:length(idx1),
        temp=['( ',sprintf('%+03.0f ',(mat{1}(1:3,:)*[xyzpeak{n1}';1])'),') '];
        temp=[temp,repmat(' ',[1,18-length(temp)])];
        txt=strvcat(txt,[...
            temp,...
            [sprintf('%15d',k(n1))],...
            [sprintf('%15f',cp(n1))],...
            [sprintf('%15f',cP(n1))],...
            [sprintf('%15f',cPFDR(n1))],...
            [sprintf('%15f',minp(n1))],...
            [sprintf('%15f',minP(n1))]]);
    end
    switch(thres{4}),
        case 1,%'clu-unc',
            idxclu=find(cp<thres{3});
            idxrem=find(cp>=thres{3});
        case 2,%'clu-FWE',
            idxclu=find(cP<thres{3});
            idxrem=find(cP>=thres{3});
        case 3,%'clu-FDR',
            idxclu=find(cPFDR<thres{3});
            idxrem=find(cPFDR>=thres{3});
        case 4,%'k-value',
            idxclu=find(k>=thres{3});
            idxrem=find(k<thres{3});
    end
    if ~isempty(idxclu), ithres(2)=min(k(idxclu)); end
    for n1=1:length(idxrem), anew(clusters{idxrem(n1)})=0; end
    txt=txt(idxclu,:);
    xyzpeak={xyzpeak{idxclu}};
    clusters={clusters{idxclu}};
    if ~isempty(idxclu),
        for n1=1:length(idxclu)+1,
            if n1<=length(idxclu),xyztemp=xyz(idx2{sidxn(idxclu(n1))},:);
            else, xyztemp=xyz(cat(2,idx2{sidxn(idxclu)}),:); end;
            v=spm_get_data(refsrois.V,pinv(refsrois.V.mat)*mat{1}*[xyztemp,ones(size(xyztemp,1),1)]');
            uv=unique(v);
            clusternames{n1}.uvb=zeros(1,length(uv));for n2=1:length(uv),clusternames{n1}.uvb(n2)=sum(v==uv(n2));end
            clusternames{n1}.uvc=refsrois.count(1+uv);
            clusternames{n1}.uvd={refsrois.labels{1+uv}};
            [nill,uvidx]=sort(-clusternames{n1}.uvb+1e10*(uv==0));
            clusternames{n1}.uvb=clusternames{n1}.uvb(uvidx);clusternames{n1}.uvc=clusternames{n1}.uvc(uvidx);clusternames{n1}.uvd={clusternames{n1}.uvd{uvidx}};
            clusternames{n1}.txt=cell(1,length(uv)); for n2=1:length(uv),clusternames{n1}.txt{n2}=[num2str(clusternames{n1}.uvb(n2)),' voxels covering ',num2str(clusternames{n1}.uvb(n2)/clusternames{n1}.uvc(n2)*100,'%0.0f'),'% of ',refsrois.filename,'.',clusternames{n1}.uvd{n2}]; end
            clusternames{n1}.txt=strvcat(clusternames{n1}.txt{:});
        end
    end
%     clusternames={clusternames{idxclu,1},clusternames{idxclu(idxclulast),2}};
    %for n1=1:length(clusternames),disp(' ');disp(clusternames{n1}.txt);end
end

%if params.plotlist, figure('color','w'); end
%h=[];xlim=[];ylim=[];
%disp(txt);

%     if params.permutation && ~isempty(params.L),
%         txt{end}=[txt{end},'  p=',num2str(mean(params.L(:,1)>=k),'%0.4f'),' (',num2str(length(unique(params.L(params.L(:,1)>=k,2)))/params.Ln,'%0.4f'),')'];
%     end
%     if params.plotlist,
%         %subplot(length(idx1),1,n1);
%         h(n1)=axes('units','norm','position',...
%             [.9,.5*(1-n1/max(length(idx1)+1,5)+.05/max(length(idx1)+1,5)),.09,.5*.9/max(length(idx1)+1,5)]);
%         mx1=mean(X1(:,idx(idx2{sidxn(n1)})),2);
%         mx2=mean(X2(:,idx(idx2{sidxn(n1)})),2);
%         plot(mx1,mx2,'.'); h0=ylabel(txt{end});set(h0,'fontsize',8,'rotation',0,'horizontalalignment','right')
%         params.output.clusters{n1}=[mx1,mx2];
%         xlim=cat(1,xlim,[min(mx1),max(mx1)]);ylim=cat(1,ylim,[min(mx2),max(mx2)]);
%     end
%   end
%if params.plotlist,
%    for n1=1:length(idx1),
%        set(h(n1),'xlim',[min(xlim(:,1))-.01,max(xlim(:,2))+.01],'ylim',[min(ylim(:,1))-.01,max(ylim(:,2))+.01]);
%        if n1~=length(idx1), set(h(n1),'xticklabel',[],'yticklabel',[],'fontsize',6); end
%    end
%end

