DO_name={'TDg.img','TDf.img','TDe.img','TDd.img','TDc.img','TDb.img','TDa.img'};
DO_IDX={3,[4,2],4,[6,2],6,[4,2],4};
DO_NOCSF=[1,1,1,0,0,0,0];
DO_CERONLY=[1,1,1,1,1,0,0];
DO_BAONLY=[0,0,0,1,1,0,0];

a=spm_vol('talairach.nii');b=spm_read_vols(a);
txt=textread('labels.txt','%s','delimiter','.\t'); txt=reshape(txt,[6,length(txt)/6]);
    
for n0=1:length(DO_name),
    name=DO_name{n0};
    IDX=DO_IDX{n0};
    NOCSF=DO_NOCSF(n0);
    CERONLY=DO_CERONLY(n0);
    BAONLY=DO_BAONLY(n0);
    REMOVE={'Extra-Nuclear','Sub-Gyral'};
    
    names=[];for n1=1:length(IDX), names=[names,strvcat(txt{IDX(n1),:})]; end;
    [names,idxsort]=sortrows(names);
    values=str2num(strvcat(txt{1,idxsort}));
    idxkeep=1:size(names,1); 
    if CERONLY, idxkeep=union(strmatch('Left Cerebrum',{txt{2,idxsort}},'exact'),strmatch('Right Cerebrum',{txt{2,idxsort}},'exact')); end
    if NOCSF, idxkeep=setdiff(idxkeep,strmatch('Cerebro-Spinal Fluid',{txt{5,idxsort}},'exact')); end
    if CERONLY, for n1=1:length(REMOVE),idxkeep=setdiff(idxkeep,strmatch(REMOVE{n1},{txt{4,idxsort}},'exact')); end; end
    if BAONLY, idxkeep=idxkeep(strmatch('Brodmann',{txt{6,idxsort(idxkeep)}})); end
    idxkeep=idxkeep(~any(names(idxkeep,:)=='*',2));
    names=names(idxkeep,:);
    values=values(idxkeep);
    
    idxlabels=[1;1+find(~all(names(1:end-1,:)==names(2:end,:),2));size(names,1)+1];
    
    clear ROIname ROIvalues;
    for n1=1:length(idxlabels)-1,
        ROIname{n1}=[];for n2=1:length(IDX),if n2>1, ROIname{n1}=[ROIname{n1},'.']; end; ROIname{n1}=[ROIname{n1},txt{IDX(n2),idxsort(idxkeep(idxlabels(n1)))}]; end;
        %names(idxlabels(n1),:);
        ROIvalues{n1}=values(idxlabels(n1):idxlabels(n1+1)-1);
    end
    
    B=zeros(size(b));
    for n1=1:length(ROIname),
        n=0;
        for n2=1:length(ROIvalues{n1}),
            idx=find(b==ROIvalues{n1}(n2));
            B(idx)=n1;
            n=n+length(idx);
        end
        disp([num2str(n1),'/',num2str(length(ROIname)),' ',ROIname{n1},' ',num2str(n),' voxels']);
    end
    
    a.fname=name;
    a.dt=[2,1];
    spm_write_vol(a,B);
    [nill,namename,nameext]=fileparts(name);
    h=fopen([namename,'.txt'],'wt');
    for n1=1:length(ROIname),fprintf(h,'%s\n',ROIname{n1});end
    fclose(h);
end

if 1,
    a0=spm_vol(fullfile(fileparts(which('spm')),'apriori','brainmask.nii'));
    clear b1;
    a1(1)=spm_vol('TDd.img');
    b1{1}=spm_read_vols(a1(1));
    a1(2)=spm_vol('TDc.img');
    b1{2}=spm_read_vols(a1(2));
    opt=strel('square',3);
    for n0=1:length(b1),
        t=b1{n0};
        [x,y,z]=ndgrid(1:size(t,1),1:size(t,2),1:size(t,3));
        m=reshape(spm_get_data(a0,pinv(a0.mat)*a1(n0).mat*[x(:),y(:),z(:),ones(numel(x),1)]'),size(t));
        for n1=1:3,
            t2=imdilate(t,opt);
            t=t.*(t>0)+t2.*(t==0&m>.0);
            imagesc(t(:,:,50));drawnow;
        end
        a1(n0).fname=[a1(n0).fname];
        spm_write_vol(a1(n0),t);
%         [x,y]=ndgrid(1:a1(n0).dim(1),1:a1(n0).dim(2));xy=[x(:),y(:)]';
%         for idx=1:size(b1{n0},3),
%             x=b1{n0}(:,:,idx);
%             opt=strel('square',3);x2=x;for n1=1:3,x3=imdilate(x2,opt);x3(x2>0)=x2(x2>0);x2=x3;end;
%             m=reshape(spm_get_data(a0,pinv(a0.mat)*a1(n0).mat*[xy;idx+zeros(1,size(xy,2));ones(1,size(xy,2))]),size(x));
%             x2=x2.*(m>.25);
%             imagesc([x,x2,10*m]); axis equal;drawnow; %pause;
%             b1{n0}(:,:,idx)=x2;
%         end
%         a1(n0).fname=[a1(n0).fname];
%         spm_write_vol(a1(n0),b1{n0});
    end
end
